lexer grammar asn1;
options {
  language=CSharp;

}
@members {
System.Collections.Generic.List<IToken> tokens = new System.Collections.Generic.List<IToken>();
public override void Emit(IToken tok) {
        token = tok;
       	tokens.Add(tok);
}
public override IToken NextToken() {
    	base.NextToken();
        if ( tokens.Count==0 ) {
            return Token.EOF_TOKEN;
        }
        IToken ret = tokens[0];
        tokens.Remove(ret);
        return ret;
}
public override void ReportError(RecognitionException e) {
	base.ReportError(e);
        throw e;
}
}

T162 : ';' ;
T163 : '[' ;
T164 : ']' ;
T165 : '<' ;
T166 : '[[' ;
T167 : ']]' ;
T168 : ':' ;
T169 : '!' ;

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 588
PLUS_INFINITY : 'PLUS-INFINITY';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 589
MINUS_INFINITY	: 'MINUS-INFINITY';		
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 590
GeneralizedTime  :	'GeneralizedTime';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 591
UTCTime  :	'UTCTime';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 592
MANTISSA	: 'mantissa';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 593
BASE		: 'base';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 594
EXPONENT	: 'exponent';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 595
UnionMark  :  '|'|'UNION';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 596
IntersectionMark  :	'^' | 'INTERSECTION';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 597
DEFINITIONS :	 'DEFINITIONS';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 598
EXPLICIT:	 'EXPLICIT';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 599
TAGS 	:	'TAGS';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 600
IMPLICIT:	'IMPLICIT';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 601
AUTOMATIC	:	'AUTOMATIC';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 602
EXTENSIBILITY	:	'EXTENSIBILITY';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 603
IMPLIED :	'IMPLIED';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 604
BEGIN	:	'BEGIN';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 605
END	:	'END';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 606
EXPORTS	:	'EXPORTS';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 607
ALL	: 	'ALL';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 608
IMPORTS	:	'IMPORTS';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 609
FROM	:	'FROM';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 610
UNIVERSAL	: 'UNIVERSAL';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 611
APPLICATION	: 'APPLICATION';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 612
PRIVATE		:'PRIVATE';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 613
BIT	: 'BIT';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 614
STRING	:	'STRING';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 615
BOOLEAN :	'BOOLEAN';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 616
ENUMERATED	:'ENUMERATED';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 617
INTEGER	:	'INTEGER';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 618
REAL	:	'REAL';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 619
CHOICE	:	'CHOICE';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 620
SEQUENCE	:'SEQUENCE';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 621
OPTIONAL	:'OPTIONAL';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 622
SIZE	:	'SIZE';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 623
OF	:	'OF';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 624
OCTET	:	'OCTET';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 625
MIN	: 	'MIN';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 626
MAX	:	'MAX';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 627
TRUE	:	'TRUE';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 628
FALSE	:	'FALSE';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 629
ABSENT	:	'ABSENT';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 630
PRESENT	:	'PRESENT';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 631
WITH 	:	'WITH';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 632
COMPONENT	: 'COMPONENT';		
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 633
COMPONENTS 	: 'COMPONENTS';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 634
DEFAULT 	: 'DEFAULT';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 635
NULL		:'NULL';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 636
PATTERN		:'PATTERN';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 637
OBJECT 		:'OBJECT';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 638
IDENTIFIER	:'IDENTIFIER';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 639
RELATIVE_OID	:'RELATIVE-OID';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 640
NumericString	:'NumericString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 641
PrintableString	:'PrintableString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 642
VisibleString	:'VisibleString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 643
IA5String	:'IA5String';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 644
TeletexString	:'TeletexString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 645
VideotexString	:'VideotexString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 646
GraphicString	:'GraphicString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 647
GeneralString	:'GeneralString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 648
UniversalString	:'UniversalString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 649
BMPString	:'BMPString';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 650
UTF8String	:'UTF8String';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 651
INCLUDES	:'INCLUDES';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 652
EXCEPT		:'EXCEPT';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 653
SET		:'SET';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 654
ASSIG_OP		: '::=';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 655
L_BRACKET	:	'{';	
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 656
R_BRACKET	:	'}';	
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 657
L_PAREN		:	'(';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 658
R_PAREN		:	')';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 659
COMMA		:	',';

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 661
EXT_MARK	: '...';
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 662
DOUBLE_DOT  : '..';

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 664
BitStringLiteral	:
	'\'' ('0'|'1'|' ' | '\t' | '\r' | '\n')* '\'B'
	;
	

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 669
OctectStringLiteral	:
	'\'' ('0'..'9'|'a'..'f'|'A'..'F'|' ' | '\t' | '\r' | '\n')* '\'H'
	;

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 673
StringLiteral 	: 	STR+ ;

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 675
fragment
STR 	:	'"' ( options {greedy=false;} : .)* '"' ;
			
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 678
UID  :   ('A'..'Z') ('a'..'z'|'A'..'Z'|'0'..'9'|'-')*
    ;

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 681
LID  :   ('a'..'z') ('a'..'z'|'A'..'Z'|'0'..'9'|'-')*
    ;


// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 685
fragment	
INT	:	('+'|'-')? ( '0' | ('1'..'9') ('0'..'9')*);


	
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 690
fragment
DIGITS
	:	('0'..'9')+;

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 694
FloatingPointLiteral
    :
    d=INT r=DOUBLE_DOT
    	  {
    	  $d.Type = INT;
    	  Emit($d);$d.Line = input.Line;
          $r.Type = DOUBLE_DOT;
    	  Emit($r);$r.Line = input.Line;
    	  }
    |	  INT DOT (DIGITS)? (Exponent)? 
    | 	d = INT { $d.Type = INT; Emit($d);$d.Line = input.Line;}
    ;

	
	
// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 709
DOT	:	 '.';	





// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 715
fragment
Exponent : ('e'|'E') ('+'|'-')? ('0'..'9')+ ;


// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 719
WS  :   (' ' | '\t' | '\r' | '\n')+ {$channel=HIDDEN;}
    ;    

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 722
COMMENT
    :   '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
    ;

// $ANTLR src "C:\prj\DataModeling\tinyAsn1\AntrlParser\asn1.g" 726
COMMENT2
    :   '--' ( options {greedy=false;} : . )* ('--'|'\r'?'\n') {$channel=HIDDEN;}
    ;




