// $ANTLR 3.0.1 C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g 2008-08-05 15:41:58

	#pragma warning disable 0219


using System;
using Antlr.Runtime;
using IList 		= System.Collections.IList;
using ArrayList 	= System.Collections.ArrayList;
using Stack 		= Antlr.Runtime.Collections.StackList;




using Antlr.Runtime.Tree;

/**=============================================================================
Antlr grammar of the ASN.1 parser used
in autoICD and asn1scc projects  
================================================================================
Copyright(c) Semantix Information Technologies S.A www.semantix.gr
All rights reserved.

This source code is only intended as a supplement to the
Semantix Technical Reference and related electronic documentation 
provided with the autoICD and asn1scc applications.
See these sources for detailed information regarding the
asn1scc and autoICD applications.
==============================================================================*/
public class asn1Parser : Parser 
{
    public static readonly string[] tokenNames = new string[] 
	{
        "<invalid>", 
		"<EOR>", 
		"<DOWN>", 
		"<UP>", 
		"MODULE_DEF", 
		"TYPE_ASSIG", 
		"VAL_ASSIG", 
		"VAL_SET_ASSIG", 
		"TYPE_DEF", 
		"TYPE_TAG", 
		"BIT_STRING_TYPE", 
		"BIT_STRING_ITEM", 
		"ENUMERATED_LST_ITEM", 
		"ENUMERATED_TYPE", 
		"INTEGER_TYPE", 
		"INTEGER_LST_ITEM", 
		"CHOICE_TYPE", 
		"CHOICE_EXT_BODY", 
		"CHOICE_ITEM", 
		"CHOICE_EXT_ITEM", 
		"SEQUENCE_TYPE", 
		"SET_TYPE", 
		"SEQUENCE_BODY", 
		"SEQUENCE_EXT_BODY", 
		"SEQUENCE_ITEM", 
		"SEQUENCE_EXT_GROUP", 
		"SEQUENCE_OF_TYPE", 
		"SET_OF_TYPE", 
		"STRING_TYPE", 
		"REFERENCED_TYPE", 
		"OBJ_LST_ITEM1", 
		"OBJ_LST_ITEM2", 
		"DEFINED_VALUE", 
		"CONSTRAINT", 
		"EXCEPTION_SPEC", 
		"UNION_ELEMENT2", 
		"UNION_SET_ALL_EXCEPT", 
		"INTERSECTION_ELEMENT", 
		"VALUE_RANGE_EXPR", 
		"SUBTYPE_EXPR", 
		"SIZE_EXPR", 
		"PERMITTED_ALPHABET_EXPR", 
		"INNER_TYPE_EXPR", 
		"NAME_CONSTRAINT_EXPR", 
		"PATTERN_EXPR", 
		"MIN_VAL_INCLUDED", 
		"MAX_VAL_INCLUDED", 
		"MAX_VAL_PRESENT", 
		"CHAR_SEQUENCE_VALUE", 
		"EXPORTS_ALL", 
		"IMPORTS_FROM_MODULE", 
		"ASN1_FILE", 
		"OCTECT_STING", 
		"SIMPLIFIED_SIZE_CONSTRAINT", 
		"OBJECT_TYPE", 
		"NUMBER_LST_ITEM", 
		"DEFAULT_VALUE", 
		"VALUE_REFERENCE", 
		"COMPONENTS_OF", 
		"NAMED_VALUE", 
		"NAMED_VALUE_LIST", 
		"VALUE_LIST", 
		"CHOICE_VALUE", 
		"OBJECT_ID_VALUE", 
		"UNION_SET", 
		"INTERSECTION_SET", 
		"NUMERIC_VALUE2", 
		"SELECTION_TYPE", 
		"WITH_COMPONENT_CONSTR", 
		"WITH_COMPONENTS_CONSTR", 
		"EXCEPTION_SPEC_CONST_INT", 
		"EXCEPTION_SPEC_VAL_REF", 
		"EXCEPTION_SPEC_TYPE_VALUE", 
		"EMPTY_LIST", 
		"L_BRACKET", 
		"R_BRACKET", 
		"L_PAREN", 
		"INT", 
		"R_PAREN", 
		"DEFINITIONS", 
		"EXPLICIT", 
		"TAGS", 
		"IMPLICIT", 
		"AUTOMATIC", 
		"EXTENSIBILITY", 
		"IMPLIED", 
		"ASSIG_OP", 
		"BEGIN", 
		"END", 
		"EXPORTS", 
		"ALL", 
		"COMMA", 
		"IMPORTS", 
		"FROM", 
		"UNIVERSAL", 
		"APPLICATION", 
		"PRIVATE", 
		"SIZE", 
		"NULL", 
		"BIT", 
		"STRING", 
		"BOOLEAN", 
		"ENUMERATED", 
		"EXT_MARK", 
		"INTEGER", 
		"REAL", 
		"CHOICE", 
		"SEQUENCE", 
		"SET", 
		"OPTIONAL", 
		"DEFAULT", 
		"COMPONENTS", 
		"OF", 
		"OCTET", 
		"NumericString", 
		"PrintableString", 
		"VisibleString", 
		"IA5String", 
		"TeletexString", 
		"VideotexString", 
		"GraphicString", 
		"GeneralString", 
		"UniversalString", 
		"BMPString", 
		"UTF8String", 
		"GeneralizedTime", 
		"UTCTime", 
		"UID", 
		"BitStringLiteral", 
		"OctectStringLiteral", 
		"TRUE", 
		"FALSE", 
		"StringLiteral", 
		"PLUS_INFINITY", 
		"MINUS_INFINITY", 
		"FloatingPointLiteral", 
		"MANTISSA", 
		"BASE", 
		"EXPONENT", 
		"UnionMark", 
		"EXCEPT", 
		"IntersectionMark", 
		"DOUBLE_DOT", 
		"MIN", 
		"MAX", 
		"INCLUDES", 
		"WITH", 
		"COMPONENT", 
		"PRESENT", 
		"ABSENT", 
		"PATTERN", 
		"LID", 
		"OBJECT", 
		"IDENTIFIER", 
		"RELATIVE_OID", 
		"STR", 
		"DIGITS", 
		"DOT", 
		"Exponent", 
		"WS", 
		"COMMENT", 
		"COMMENT2", 
		"';'", 
		"'['", 
		"']'", 
		"'<'", 
		"'[['", 
		"']]'", 
		"':'", 
		"'!'"
    };

    public const int BIT_STRING_ITEM = 11;
    public const int COMMENT2 = 161;
    public const int UnionMark = 139;
    public const int EXPONENT = 138;
    public const int MANTISSA = 136;
    public const int TeletexString = 118;
    public const int SEQUENCE_OF_TYPE = 26;
    public const int UTCTime = 126;
    public const int TYPE_DEF = 8;
    public const int SEQUENCE_EXT_BODY = 23;
    public const int SEQUENCE_ITEM = 24;
    public const int BitStringLiteral = 128;
    public const int PrintableString = 115;
    public const int GeneralizedTime = 125;
    public const int ENUMERATED_TYPE = 13;
    public const int EXCEPTION_SPEC_CONST_INT = 70;
    public const int EXCEPT = 140;
    public const int EOF = -1;
    public const int SEQUENCE_BODY = 22;
    public const int DOUBLE_DOT = 142;
    public const int PATTERN = 150;
    public const int INCLUDES = 145;
    public const int EMPTY_LIST = 73;
    public const int EXCEPTION_SPEC_TYPE_VALUE = 72;
    public const int EXPORTS = 89;
    public const int ASN1_FILE = 51;
    public const int BEGIN = 87;
    public const int L_PAREN = 76;
    public const int SET_TYPE = 21;
    public const int BASE = 137;
    public const int INTERSECTION_SET = 65;
    public const int UID = 127;
    public const int CHOICE_EXT_BODY = 17;
    public const int COMMENT = 160;
    public const int MAX_VAL_PRESENT = 47;
    public const int BIT_STRING_TYPE = 10;
    public const int SET_OF_TYPE = 27;
    public const int SUBTYPE_EXPR = 39;
    public const int SIZE_EXPR = 40;
    public const int EXT_MARK = 103;
    public const int UNION_SET = 64;
    public const int OBJECT_TYPE = 54;
    public const int PRIVATE = 96;
    public const int VALUE_LIST = 61;
    public const int DEFINITIONS = 79;
    public const int NULL = 98;
    public const int PERMITTED_ALPHABET_EXPR = 41;
    public const int INT = 77;
    public const int REFERENCED_TYPE = 29;
    public const int INTEGER_TYPE = 14;
    public const int UTF8String = 124;
    public const int DEFINED_VALUE = 32;
    public const int TYPE_ASSIG = 5;
    public const int OF = 112;
    public const int VAL_SET_ASSIG = 7;
    public const int IMPLIED = 85;
    public const int SEQUENCE_EXT_GROUP = 25;
    public const int LID = 151;
    public const int SEQUENCE = 107;
    public const int REAL = 105;
    public const int MINUS_INFINITY = 134;
    public const int WS = 159;
    public const int INTEGER_LST_ITEM = 15;
    public const int ABSENT = 149;
    public const int FloatingPointLiteral = 135;
    public const int STRING_TYPE = 28;
    public const int CHOICE_VALUE = 62;
    public const int GraphicString = 120;
    public const int IntersectionMark = 141;
    public const int IMPORTS = 92;
    public const int UniversalString = 122;
    public const int FROM = 93;
    public const int END = 88;
    public const int FALSE = 131;
    public const int UNIVERSAL = 94;
    public const int DEFAULT_VALUE = 56;
    public const int CONSTRAINT = 33;
    public const int SIZE = 97;
    public const int VALUE_REFERENCE = 57;
    public const int UNION_ELEMENT2 = 35;
    public const int AUTOMATIC = 83;
    public const int IA5String = 117;
    public const int IMPORTS_FROM_MODULE = 50;
    public const int NAMED_VALUE_LIST = 60;
    public const int UNION_SET_ALL_EXCEPT = 36;
    public const int COMPONENTS = 111;
    public const int L_BRACKET = 74;
    public const int APPLICATION = 95;
    public const int DIGITS = 156;
    public const int OctectStringLiteral = 129;
    public const int EXCEPTION_SPEC = 34;
    public const int NumericString = 114;
    public const int MIN_VAL_INCLUDED = 45;
    public const int MAX = 144;
    public const int Exponent = 158;
    public const int CHOICE_ITEM = 18;
    public const int OBJ_LST_ITEM1 = 30;
    public const int OBJ_LST_ITEM2 = 31;
    public const int EXPLICIT = 80;
    public const int VALUE_RANGE_EXPR = 38;
    public const int STR = 155;
    public const int BOOLEAN = 101;
    public const int VAL_ASSIG = 6;
    public const int OBJECT = 152;
    public const int OCTECT_STING = 52;
    public const int COMMA = 91;
    public const int PRESENT = 148;
    public const int IDENTIFIER = 153;
    public const int ALL = 90;
    public const int RELATIVE_OID = 154;
    public const int WITH_COMPONENT_CONSTR = 68;
    public const int GeneralString = 121;
    public const int INTERSECTION_ELEMENT = 37;
    public const int ENUMERATED_LST_ITEM = 12;
    public const int DOT = 157;
    public const int COMPONENT = 147;
    public const int BMPString = 123;
    public const int CHOICE = 106;
    public const int NAMED_VALUE = 59;
    public const int WITH = 146;
    public const int OBJECT_ID_VALUE = 63;
    public const int INTEGER = 104;
    public const int EXTENSIBILITY = 84;
    public const int WITH_COMPONENTS_CONSTR = 69;
    public const int IMPLICIT = 82;
    public const int INNER_TYPE_EXPR = 42;
    public const int ASSIG_OP = 86;
    public const int DEFAULT = 110;
    public const int SEQUENCE_TYPE = 20;
    public const int CHAR_SEQUENCE_VALUE = 48;
    public const int SET = 108;
    public const int TAGS = 81;
    public const int MIN = 143;
    public const int PATTERN_EXPR = 44;
    public const int TRUE = 130;
    public const int COMPONENTS_OF = 58;
    public const int R_BRACKET = 75;
    public const int R_PAREN = 78;
    public const int OPTIONAL = 109;
    public const int StringLiteral = 132;
    public const int EXPORTS_ALL = 49;
    public const int SIMPLIFIED_SIZE_CONSTRAINT = 53;
    public const int VideotexString = 119;
    public const int ENUMERATED = 102;
    public const int CHOICE_TYPE = 16;
    public const int SELECTION_TYPE = 67;
    public const int MAX_VAL_INCLUDED = 46;
    public const int PLUS_INFINITY = 133;
    public const int NAME_CONSTRAINT_EXPR = 43;
    public const int CHOICE_EXT_ITEM = 19;
    public const int BIT = 99;
    public const int NUMBER_LST_ITEM = 55;
    public const int VisibleString = 116;
    public const int NUMERIC_VALUE2 = 66;
    public const int TYPE_TAG = 9;
    public const int EXCEPTION_SPEC_VAL_REF = 71;
    public const int OCTET = 113;
    public const int STRING = 100;
    public const int MODULE_DEF = 4;
    
    
        public asn1Parser(ITokenStream input) 
    		: base(input)
    	{
    		InitializeCyclicDFAs();
        }
        
    protected ITreeAdaptor adaptor = new CommonTreeAdaptor();
    
    public ITreeAdaptor TreeAdaptor
    {
        get { return this.adaptor; }
        set { this.adaptor = value; }
    }

    override public string[] TokenNames
	{
		get { return tokenNames; }
	}

    override public string GrammarFileName
	{
		get { return "C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g"; }
	}

    
    public override void ReportError(RecognitionException e) {
    	base.ReportError(e);
            throw e;
    }
    


    public class moduleDefinitions_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start moduleDefinitions
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:141:1: moduleDefinitions : ( moduleDefinition )* -> ^( ASN1_FILE ( moduleDefinition )* ) ;
    public moduleDefinitions_return moduleDefinitions() // throws RecognitionException [1]
    {   
        moduleDefinitions_return retval = new moduleDefinitions_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        moduleDefinition_return moduleDefinition1 = null;
        
        
        RewriteRuleSubtreeStream stream_moduleDefinition = new RewriteRuleSubtreeStream(adaptor,"rule moduleDefinition");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:142:2: ( ( moduleDefinition )* -> ^( ASN1_FILE ( moduleDefinition )* ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:142:4: ( moduleDefinition )*
            {
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:142:4: ( moduleDefinition )*
            	do 
            	{
            	    int alt1 = 2;
            	    int LA1_0 = input.LA(1);
            	    
            	    if ( (LA1_0 == UID) )
            	    {
            	        alt1 = 1;
            	    }
            	    
            	
            	    switch (alt1) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:142:4: moduleDefinition
            			    {
            			    	PushFollow(FOLLOW_moduleDefinition_in_moduleDefinitions353);
            			    	moduleDefinition1 = moduleDefinition();
            			    	followingStackPointer_--;
            			    	
            			    	stream_moduleDefinition.Add(moduleDefinition1.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop1;
            	    }
            	} while (true);
            	
            	loop1:
            		;	// Stops C# compiler whinging that label 'loop1' has no statements

            	
            	// AST REWRITE
            	// elements:          moduleDefinition
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 142:22: -> ^( ASN1_FILE ( moduleDefinition )* )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:142:24: ^( ASN1_FILE ( moduleDefinition )* )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(ASN1_FILE, "ASN1_FILE"), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:142:36: ( moduleDefinition )*
            	    while ( stream_moduleDefinition.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_moduleDefinition.Next());
            	    
            	    }
            	    stream_moduleDefinition.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end moduleDefinitions

    public class definitiveIdentifier_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start definitiveIdentifier
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:146:1: definitiveIdentifier : L_BRACKET ( definitiveObjIdComponent )* R_BRACKET ;
    public definitiveIdentifier_return definitiveIdentifier() // throws RecognitionException [1]
    {   
        definitiveIdentifier_return retval = new definitiveIdentifier_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken L_BRACKET2 = null;
        IToken R_BRACKET4 = null;
        definitiveObjIdComponent_return definitiveObjIdComponent3 = null;
        
        
        object L_BRACKET2_tree=null;
        object R_BRACKET4_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:147:2: ( L_BRACKET ( definitiveObjIdComponent )* R_BRACKET )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:147:4: L_BRACKET ( definitiveObjIdComponent )* R_BRACKET
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	L_BRACKET2 = (IToken)input.LT(1);
            	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_definitiveIdentifier375); 
            	L_BRACKET2_tree = (object)adaptor.Create(L_BRACKET2);
            	adaptor.AddChild(root_0, L_BRACKET2_tree);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:147:14: ( definitiveObjIdComponent )*
            	do 
            	{
            	    int alt2 = 2;
            	    int LA2_0 = input.LA(1);
            	    
            	    if ( (LA2_0 == INT || LA2_0 == LID) )
            	    {
            	        alt2 = 1;
            	    }
            	    
            	
            	    switch (alt2) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:147:14: definitiveObjIdComponent
            			    {
            			    	PushFollow(FOLLOW_definitiveObjIdComponent_in_definitiveIdentifier377);
            			    	definitiveObjIdComponent3 = definitiveObjIdComponent();
            			    	followingStackPointer_--;
            			    	
            			    	adaptor.AddChild(root_0, definitiveObjIdComponent3.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop2;
            	    }
            	} while (true);
            	
            	loop2:
            		;	// Stops C# compiler whinging that label 'loop2' has no statements

            	R_BRACKET4 = (IToken)input.LT(1);
            	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_definitiveIdentifier380); 
            	R_BRACKET4_tree = (object)adaptor.Create(R_BRACKET4);
            	adaptor.AddChild(root_0, R_BRACKET4_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end definitiveIdentifier

    public class definitiveObjIdComponent_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start definitiveObjIdComponent
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:150:1: definitiveObjIdComponent : ( identifier ( L_PAREN INT R_PAREN )? | INT );
    public definitiveObjIdComponent_return definitiveObjIdComponent() // throws RecognitionException [1]
    {   
        definitiveObjIdComponent_return retval = new definitiveObjIdComponent_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken L_PAREN6 = null;
        IToken INT7 = null;
        IToken R_PAREN8 = null;
        IToken INT9 = null;
        identifier_return identifier5 = null;
        
        
        object L_PAREN6_tree=null;
        object INT7_tree=null;
        object R_PAREN8_tree=null;
        object INT9_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:151:2: ( identifier ( L_PAREN INT R_PAREN )? | INT )
            int alt4 = 2;
            int LA4_0 = input.LA(1);
            
            if ( (LA4_0 == LID) )
            {
                alt4 = 1;
            }
            else if ( (LA4_0 == INT) )
            {
                alt4 = 2;
            }
            else 
            {
                NoViableAltException nvae_d4s0 =
                    new NoViableAltException("150:1: definitiveObjIdComponent : ( identifier ( L_PAREN INT R_PAREN )? | INT );", 4, 0, input);
            
                throw nvae_d4s0;
            }
            switch (alt4) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:151:4: identifier ( L_PAREN INT R_PAREN )?
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_identifier_in_definitiveObjIdComponent391);
                    	identifier5 = identifier();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, identifier5.Tree);
                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:151:15: ( L_PAREN INT R_PAREN )?
                    	int alt3 = 2;
                    	int LA3_0 = input.LA(1);
                    	
                    	if ( (LA3_0 == L_PAREN) )
                    	{
                    	    alt3 = 1;
                    	}
                    	switch (alt3) 
                    	{
                    	    case 1 :
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:151:17: L_PAREN INT R_PAREN
                    	        {
                    	        	L_PAREN6 = (IToken)input.LT(1);
                    	        	Match(input,L_PAREN,FOLLOW_L_PAREN_in_definitiveObjIdComponent395); 
                    	        	L_PAREN6_tree = (object)adaptor.Create(L_PAREN6);
                    	        	adaptor.AddChild(root_0, L_PAREN6_tree);

                    	        	INT7 = (IToken)input.LT(1);
                    	        	Match(input,INT,FOLLOW_INT_in_definitiveObjIdComponent397); 
                    	        	INT7_tree = (object)adaptor.Create(INT7);
                    	        	adaptor.AddChild(root_0, INT7_tree);

                    	        	R_PAREN8 = (IToken)input.LT(1);
                    	        	Match(input,R_PAREN,FOLLOW_R_PAREN_in_definitiveObjIdComponent399); 
                    	        	R_PAREN8_tree = (object)adaptor.Create(R_PAREN8);
                    	        	adaptor.AddChild(root_0, R_PAREN8_tree);

                    	        
                    	        }
                    	        break;
                    	
                    	}

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:152:4: INT
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	INT9 = (IToken)input.LT(1);
                    	Match(input,INT,FOLLOW_INT_in_definitiveObjIdComponent407); 
                    	INT9_tree = (object)adaptor.Create(INT9);
                    	adaptor.AddChild(root_0, INT9_tree);

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end definitiveObjIdComponent

    public class moduleDefinition_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start moduleDefinition
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:155:1: moduleDefinition : a= modulereference ( definitiveIdentifier )? d= DEFINITIONS ( EXPLICIT TAGS | IMPLICIT TAGS | AUTOMATIC TAGS )? ( EXTENSIBILITY IMPLIED )? ASSIG_OP BEGIN ( exports )? ( imports )? ( typeAssigment | valueAssigment )* END -> ^( MODULE_DEF[$d] modulereference ( EXPLICIT )? ( IMPLICIT )? ( AUTOMATIC )? ( EXTENSIBILITY )? ( exports )? ( imports )? ( typeAssigment )* ( valueAssigment )* ) ;
    public moduleDefinition_return moduleDefinition() // throws RecognitionException [1]
    {   
        moduleDefinition_return retval = new moduleDefinition_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken d = null;
        IToken EXPLICIT11 = null;
        IToken TAGS12 = null;
        IToken IMPLICIT13 = null;
        IToken TAGS14 = null;
        IToken AUTOMATIC15 = null;
        IToken TAGS16 = null;
        IToken EXTENSIBILITY17 = null;
        IToken IMPLIED18 = null;
        IToken ASSIG_OP19 = null;
        IToken BEGIN20 = null;
        IToken END25 = null;
        modulereference_return a = null;

        definitiveIdentifier_return definitiveIdentifier10 = null;

        exports_return exports21 = null;

        imports_return imports22 = null;

        typeAssigment_return typeAssigment23 = null;

        valueAssigment_return valueAssigment24 = null;
        
        
        object d_tree=null;
        object EXPLICIT11_tree=null;
        object TAGS12_tree=null;
        object IMPLICIT13_tree=null;
        object TAGS14_tree=null;
        object AUTOMATIC15_tree=null;
        object TAGS16_tree=null;
        object EXTENSIBILITY17_tree=null;
        object IMPLIED18_tree=null;
        object ASSIG_OP19_tree=null;
        object BEGIN20_tree=null;
        object END25_tree=null;
        RewriteRuleTokenStream stream_TAGS = new RewriteRuleTokenStream(adaptor,"token TAGS");
        RewriteRuleTokenStream stream_EXTENSIBILITY = new RewriteRuleTokenStream(adaptor,"token EXTENSIBILITY");
        RewriteRuleTokenStream stream_EXPLICIT = new RewriteRuleTokenStream(adaptor,"token EXPLICIT");
        RewriteRuleTokenStream stream_IMPLICIT = new RewriteRuleTokenStream(adaptor,"token IMPLICIT");
        RewriteRuleTokenStream stream_END = new RewriteRuleTokenStream(adaptor,"token END");
        RewriteRuleTokenStream stream_ASSIG_OP = new RewriteRuleTokenStream(adaptor,"token ASSIG_OP");
        RewriteRuleTokenStream stream_IMPLIED = new RewriteRuleTokenStream(adaptor,"token IMPLIED");
        RewriteRuleTokenStream stream_DEFINITIONS = new RewriteRuleTokenStream(adaptor,"token DEFINITIONS");
        RewriteRuleTokenStream stream_BEGIN = new RewriteRuleTokenStream(adaptor,"token BEGIN");
        RewriteRuleTokenStream stream_AUTOMATIC = new RewriteRuleTokenStream(adaptor,"token AUTOMATIC");
        RewriteRuleSubtreeStream stream_exports = new RewriteRuleSubtreeStream(adaptor,"rule exports");
        RewriteRuleSubtreeStream stream_modulereference = new RewriteRuleSubtreeStream(adaptor,"rule modulereference");
        RewriteRuleSubtreeStream stream_valueAssigment = new RewriteRuleSubtreeStream(adaptor,"rule valueAssigment");
        RewriteRuleSubtreeStream stream_typeAssigment = new RewriteRuleSubtreeStream(adaptor,"rule typeAssigment");
        RewriteRuleSubtreeStream stream_definitiveIdentifier = new RewriteRuleSubtreeStream(adaptor,"rule definitiveIdentifier");
        RewriteRuleSubtreeStream stream_imports = new RewriteRuleSubtreeStream(adaptor,"rule imports");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:155:18: (a= modulereference ( definitiveIdentifier )? d= DEFINITIONS ( EXPLICIT TAGS | IMPLICIT TAGS | AUTOMATIC TAGS )? ( EXTENSIBILITY IMPLIED )? ASSIG_OP BEGIN ( exports )? ( imports )? ( typeAssigment | valueAssigment )* END -> ^( MODULE_DEF[$d] modulereference ( EXPLICIT )? ( IMPLICIT )? ( AUTOMATIC )? ( EXTENSIBILITY )? ( exports )? ( imports )? ( typeAssigment )* ( valueAssigment )* ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:155:22: a= modulereference ( definitiveIdentifier )? d= DEFINITIONS ( EXPLICIT TAGS | IMPLICIT TAGS | AUTOMATIC TAGS )? ( EXTENSIBILITY IMPLIED )? ASSIG_OP BEGIN ( exports )? ( imports )? ( typeAssigment | valueAssigment )* END
            {
            	PushFollow(FOLLOW_modulereference_in_moduleDefinition423);
            	a = modulereference();
            	followingStackPointer_--;
            	
            	stream_modulereference.Add(a.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:155:40: ( definitiveIdentifier )?
            	int alt5 = 2;
            	int LA5_0 = input.LA(1);
            	
            	if ( (LA5_0 == L_BRACKET) )
            	{
            	    alt5 = 1;
            	}
            	switch (alt5) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:155:40: definitiveIdentifier
            	        {
            	        	PushFollow(FOLLOW_definitiveIdentifier_in_moduleDefinition425);
            	        	definitiveIdentifier10 = definitiveIdentifier();
            	        	followingStackPointer_--;
            	        	
            	        	stream_definitiveIdentifier.Add(definitiveIdentifier10.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	d = (IToken)input.LT(1);
            	Match(input,DEFINITIONS,FOLLOW_DEFINITIONS_in_moduleDefinition433); 
            	stream_DEFINITIONS.Add(d);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:157:4: ( EXPLICIT TAGS | IMPLICIT TAGS | AUTOMATIC TAGS )?
            	int alt6 = 4;
            	switch ( input.LA(1) ) 
            	{
            	    case EXPLICIT:
            	    	{
            	        alt6 = 1;
            	        }
            	        break;
            	    case IMPLICIT:
            	    	{
            	        alt6 = 2;
            	        }
            	        break;
            	    case AUTOMATIC:
            	    	{
            	        alt6 = 3;
            	        }
            	        break;
            	}
            	
            	switch (alt6) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:157:5: EXPLICIT TAGS
            	        {
            	        	EXPLICIT11 = (IToken)input.LT(1);
            	        	Match(input,EXPLICIT,FOLLOW_EXPLICIT_in_moduleDefinition439); 
            	        	stream_EXPLICIT.Add(EXPLICIT11);

            	        	TAGS12 = (IToken)input.LT(1);
            	        	Match(input,TAGS,FOLLOW_TAGS_in_moduleDefinition441); 
            	        	stream_TAGS.Add(TAGS12);

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:158:5: IMPLICIT TAGS
            	        {
            	        	IMPLICIT13 = (IToken)input.LT(1);
            	        	Match(input,IMPLICIT,FOLLOW_IMPLICIT_in_moduleDefinition447); 
            	        	stream_IMPLICIT.Add(IMPLICIT13);

            	        	TAGS14 = (IToken)input.LT(1);
            	        	Match(input,TAGS,FOLLOW_TAGS_in_moduleDefinition449); 
            	        	stream_TAGS.Add(TAGS14);

            	        
            	        }
            	        break;
            	    case 3 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:159:6: AUTOMATIC TAGS
            	        {
            	        	AUTOMATIC15 = (IToken)input.LT(1);
            	        	Match(input,AUTOMATIC,FOLLOW_AUTOMATIC_in_moduleDefinition456); 
            	        	stream_AUTOMATIC.Add(AUTOMATIC15);

            	        	TAGS16 = (IToken)input.LT(1);
            	        	Match(input,TAGS,FOLLOW_TAGS_in_moduleDefinition458); 
            	        	stream_TAGS.Add(TAGS16);

            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:160:4: ( EXTENSIBILITY IMPLIED )?
            	int alt7 = 2;
            	int LA7_0 = input.LA(1);
            	
            	if ( (LA7_0 == EXTENSIBILITY) )
            	{
            	    alt7 = 1;
            	}
            	switch (alt7) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:160:5: EXTENSIBILITY IMPLIED
            	        {
            	        	EXTENSIBILITY17 = (IToken)input.LT(1);
            	        	Match(input,EXTENSIBILITY,FOLLOW_EXTENSIBILITY_in_moduleDefinition466); 
            	        	stream_EXTENSIBILITY.Add(EXTENSIBILITY17);

            	        	IMPLIED18 = (IToken)input.LT(1);
            	        	Match(input,IMPLIED,FOLLOW_IMPLIED_in_moduleDefinition468); 
            	        	stream_IMPLIED.Add(IMPLIED18);

            	        
            	        }
            	        break;
            	
            	}

            	ASSIG_OP19 = (IToken)input.LT(1);
            	Match(input,ASSIG_OP,FOLLOW_ASSIG_OP_in_moduleDefinition475); 
            	stream_ASSIG_OP.Add(ASSIG_OP19);

            	BEGIN20 = (IToken)input.LT(1);
            	Match(input,BEGIN,FOLLOW_BEGIN_in_moduleDefinition477); 
            	stream_BEGIN.Add(BEGIN20);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:162:4: ( exports )?
            	int alt8 = 2;
            	int LA8_0 = input.LA(1);
            	
            	if ( (LA8_0 == EXPORTS) )
            	{
            	    alt8 = 1;
            	}
            	switch (alt8) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:162:4: exports
            	        {
            	        	PushFollow(FOLLOW_exports_in_moduleDefinition482);
            	        	exports21 = exports();
            	        	followingStackPointer_--;
            	        	
            	        	stream_exports.Add(exports21.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:163:4: ( imports )?
            	int alt9 = 2;
            	int LA9_0 = input.LA(1);
            	
            	if ( (LA9_0 == IMPORTS) )
            	{
            	    alt9 = 1;
            	}
            	switch (alt9) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:163:4: imports
            	        {
            	        	PushFollow(FOLLOW_imports_in_moduleDefinition488);
            	        	imports22 = imports();
            	        	followingStackPointer_--;
            	        	
            	        	stream_imports.Add(imports22.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:164:4: ( typeAssigment | valueAssigment )*
            	do 
            	{
            	    int alt10 = 3;
            	    int LA10_0 = input.LA(1);
            	    
            	    if ( (LA10_0 == UID) )
            	    {
            	        alt10 = 1;
            	    }
            	    else if ( (LA10_0 == LID) )
            	    {
            	        alt10 = 2;
            	    }
            	    
            	
            	    switch (alt10) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:165:5: typeAssigment
            			    {
            			    	PushFollow(FOLLOW_typeAssigment_in_moduleDefinition500);
            			    	typeAssigment23 = typeAssigment();
            			    	followingStackPointer_--;
            			    	
            			    	stream_typeAssigment.Add(typeAssigment23.Tree);
            			    
            			    }
            			    break;
            			case 2 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:166:6: valueAssigment
            			    {
            			    	PushFollow(FOLLOW_valueAssigment_in_moduleDefinition507);
            			    	valueAssigment24 = valueAssigment();
            			    	followingStackPointer_--;
            			    	
            			    	stream_valueAssigment.Add(valueAssigment24.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop10;
            	    }
            	} while (true);
            	
            	loop10:
            		;	// Stops C# compiler whinging that label 'loop10' has no statements

            	END25 = (IToken)input.LT(1);
            	Match(input,END,FOLLOW_END_in_moduleDefinition519); 
            	stream_END.Add(END25);

            	
            	// AST REWRITE
            	// elements:          imports, modulereference, EXTENSIBILITY, valueAssigment, IMPLICIT, typeAssigment, exports, AUTOMATIC, EXPLICIT
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 170:4: -> ^( MODULE_DEF[$d] modulereference ( EXPLICIT )? ( IMPLICIT )? ( AUTOMATIC )? ( EXTENSIBILITY )? ( exports )? ( imports )? ( typeAssigment )* ( valueAssigment )* )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:8: ^( MODULE_DEF[$d] modulereference ( EXPLICIT )? ( IMPLICIT )? ( AUTOMATIC )? ( EXTENSIBILITY )? ( exports )? ( imports )? ( typeAssigment )* ( valueAssigment )* )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(MODULE_DEF, d), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_modulereference.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:41: ( EXPLICIT )?
            	    if ( stream_EXPLICIT.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_EXPLICIT.Next());
            	    
            	    }
            	    stream_EXPLICIT.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:51: ( IMPLICIT )?
            	    if ( stream_IMPLICIT.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_IMPLICIT.Next());
            	    
            	    }
            	    stream_IMPLICIT.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:61: ( AUTOMATIC )?
            	    if ( stream_AUTOMATIC.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_AUTOMATIC.Next());
            	    
            	    }
            	    stream_AUTOMATIC.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:72: ( EXTENSIBILITY )?
            	    if ( stream_EXTENSIBILITY.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_EXTENSIBILITY.Next());
            	    
            	    }
            	    stream_EXTENSIBILITY.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:87: ( exports )?
            	    if ( stream_exports.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_exports.Next());
            	    
            	    }
            	    stream_exports.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:96: ( imports )?
            	    if ( stream_imports.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_imports.Next());
            	    
            	    }
            	    stream_imports.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:105: ( typeAssigment )*
            	    while ( stream_typeAssigment.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_typeAssigment.Next());
            	    
            	    }
            	    stream_typeAssigment.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:170:120: ( valueAssigment )*
            	    while ( stream_valueAssigment.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_valueAssigment.Next());
            	    
            	    }
            	    stream_valueAssigment.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end moduleDefinition

    public class exports_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start exports
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:186:1: exports : (a= EXPORTS ALL ';' -> EXPORTS_ALL[$a] | EXPORTS ( ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* )? ';' -> ( ^( EXPORTS ( typereference )* ( valuereference )* ) )? );
    public exports_return exports() // throws RecognitionException [1]
    {   
        exports_return retval = new exports_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken ALL26 = null;
        IToken char_literal27 = null;
        IToken EXPORTS28 = null;
        IToken COMMA31 = null;
        IToken char_literal34 = null;
        typereference_return typereference29 = null;

        valuereference_return valuereference30 = null;

        typereference_return typereference32 = null;

        valuereference_return valuereference33 = null;
        
        
        object a_tree=null;
        object ALL26_tree=null;
        object char_literal27_tree=null;
        object EXPORTS28_tree=null;
        object COMMA31_tree=null;
        object char_literal34_tree=null;
        RewriteRuleTokenStream stream_162 = new RewriteRuleTokenStream(adaptor,"token 162");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_EXPORTS = new RewriteRuleTokenStream(adaptor,"token EXPORTS");
        RewriteRuleTokenStream stream_ALL = new RewriteRuleTokenStream(adaptor,"token ALL");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_typereference = new RewriteRuleSubtreeStream(adaptor,"rule typereference");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:186:9: (a= EXPORTS ALL ';' -> EXPORTS_ALL[$a] | EXPORTS ( ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* )? ';' -> ( ^( EXPORTS ( typereference )* ( valuereference )* ) )? )
            int alt15 = 2;
            int LA15_0 = input.LA(1);
            
            if ( (LA15_0 == EXPORTS) )
            {
                int LA15_1 = input.LA(2);
                
                if ( (LA15_1 == ALL) )
                {
                    alt15 = 1;
                }
                else if ( (LA15_1 == UID || LA15_1 == LID || LA15_1 == 162) )
                {
                    alt15 = 2;
                }
                else 
                {
                    NoViableAltException nvae_d15s1 =
                        new NoViableAltException("186:1: exports : (a= EXPORTS ALL ';' -> EXPORTS_ALL[$a] | EXPORTS ( ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* )? ';' -> ( ^( EXPORTS ( typereference )* ( valuereference )* ) )? );", 15, 1, input);
                
                    throw nvae_d15s1;
                }
            }
            else 
            {
                NoViableAltException nvae_d15s0 =
                    new NoViableAltException("186:1: exports : (a= EXPORTS ALL ';' -> EXPORTS_ALL[$a] | EXPORTS ( ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* )? ';' -> ( ^( EXPORTS ( typereference )* ( valuereference )* ) )? );", 15, 0, input);
            
                throw nvae_d15s0;
            }
            switch (alt15) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:187:5: a= EXPORTS ALL ';'
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,EXPORTS,FOLLOW_EXPORTS_in_exports589); 
                    	stream_EXPORTS.Add(a);

                    	ALL26 = (IToken)input.LT(1);
                    	Match(input,ALL,FOLLOW_ALL_in_exports591); 
                    	stream_ALL.Add(ALL26);

                    	char_literal27 = (IToken)input.LT(1);
                    	Match(input,162,FOLLOW_162_in_exports593); 
                    	stream_162.Add(char_literal27);

                    	
                    	// AST REWRITE
                    	// elements:          
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 187:23: -> EXPORTS_ALL[$a]
                    	{
                    	    adaptor.AddChild(root_0, adaptor.Create(EXPORTS_ALL, a));
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:5: EXPORTS ( ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* )? ';'
                    {
                    	EXPORTS28 = (IToken)input.LT(1);
                    	Match(input,EXPORTS,FOLLOW_EXPORTS_in_exports604); 
                    	stream_EXPORTS.Add(EXPORTS28);

                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:13: ( ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* )?
                    	int alt14 = 2;
                    	int LA14_0 = input.LA(1);
                    	
                    	if ( (LA14_0 == UID || LA14_0 == LID) )
                    	{
                    	    alt14 = 1;
                    	}
                    	switch (alt14) 
                    	{
                    	    case 1 :
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:14: ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )*
                    	        {
                    	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:14: ( typereference | valuereference )
                    	        	int alt11 = 2;
                    	        	int LA11_0 = input.LA(1);
                    	        	
                    	        	if ( (LA11_0 == UID) )
                    	        	{
                    	        	    alt11 = 1;
                    	        	}
                    	        	else if ( (LA11_0 == LID) )
                    	        	{
                    	        	    alt11 = 2;
                    	        	}
                    	        	else 
                    	        	{
                    	        	    NoViableAltException nvae_d11s0 =
                    	        	        new NoViableAltException("188:14: ( typereference | valuereference )", 11, 0, input);
                    	        	
                    	        	    throw nvae_d11s0;
                    	        	}
                    	        	switch (alt11) 
                    	        	{
                    	        	    case 1 :
                    	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:15: typereference
                    	        	        {
                    	        	        	PushFollow(FOLLOW_typereference_in_exports608);
                    	        	        	typereference29 = typereference();
                    	        	        	followingStackPointer_--;
                    	        	        	
                    	        	        	stream_typereference.Add(typereference29.Tree);
                    	        	        
                    	        	        }
                    	        	        break;
                    	        	    case 2 :
                    	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:31: valuereference
                    	        	        {
                    	        	        	PushFollow(FOLLOW_valuereference_in_exports612);
                    	        	        	valuereference30 = valuereference();
                    	        	        	followingStackPointer_--;
                    	        	        	
                    	        	        	stream_valuereference.Add(valuereference30.Tree);
                    	        	        
                    	        	        }
                    	        	        break;
                    	        	
                    	        	}

                    	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:47: ( COMMA ( typereference | valuereference ) )*
                    	        	do 
                    	        	{
                    	        	    int alt13 = 2;
                    	        	    int LA13_0 = input.LA(1);
                    	        	    
                    	        	    if ( (LA13_0 == COMMA) )
                    	        	    {
                    	        	        alt13 = 1;
                    	        	    }
                    	        	    
                    	        	
                    	        	    switch (alt13) 
                    	        		{
                    	        			case 1 :
                    	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:48: COMMA ( typereference | valuereference )
                    	        			    {
                    	        			    	COMMA31 = (IToken)input.LT(1);
                    	        			    	Match(input,COMMA,FOLLOW_COMMA_in_exports616); 
                    	        			    	stream_COMMA.Add(COMMA31);

                    	        			    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:54: ( typereference | valuereference )
                    	        			    	int alt12 = 2;
                    	        			    	int LA12_0 = input.LA(1);
                    	        			    	
                    	        			    	if ( (LA12_0 == UID) )
                    	        			    	{
                    	        			    	    alt12 = 1;
                    	        			    	}
                    	        			    	else if ( (LA12_0 == LID) )
                    	        			    	{
                    	        			    	    alt12 = 2;
                    	        			    	}
                    	        			    	else 
                    	        			    	{
                    	        			    	    NoViableAltException nvae_d12s0 =
                    	        			    	        new NoViableAltException("188:54: ( typereference | valuereference )", 12, 0, input);
                    	        			    	
                    	        			    	    throw nvae_d12s0;
                    	        			    	}
                    	        			    	switch (alt12) 
                    	        			    	{
                    	        			    	    case 1 :
                    	        			    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:55: typereference
                    	        			    	        {
                    	        			    	        	PushFollow(FOLLOW_typereference_in_exports619);
                    	        			    	        	typereference32 = typereference();
                    	        			    	        	followingStackPointer_--;
                    	        			    	        	
                    	        			    	        	stream_typereference.Add(typereference32.Tree);
                    	        			    	        
                    	        			    	        }
                    	        			    	        break;
                    	        			    	    case 2 :
                    	        			    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:188:71: valuereference
                    	        			    	        {
                    	        			    	        	PushFollow(FOLLOW_valuereference_in_exports623);
                    	        			    	        	valuereference33 = valuereference();
                    	        			    	        	followingStackPointer_--;
                    	        			    	        	
                    	        			    	        	stream_valuereference.Add(valuereference33.Tree);
                    	        			    	        
                    	        			    	        }
                    	        			    	        break;
                    	        			    	
                    	        			    	}

                    	        			    
                    	        			    }
                    	        			    break;
                    	        	
                    	        			default:
                    	        			    goto loop13;
                    	        	    }
                    	        	} while (true);
                    	        	
                    	        	loop13:
                    	        		;	// Stops C# compiler whinging that label 'loop13' has no statements

                    	        
                    	        }
                    	        break;
                    	
                    	}

                    	char_literal34 = (IToken)input.LT(1);
                    	Match(input,162,FOLLOW_162_in_exports631); 
                    	stream_162.Add(char_literal34);

                    	
                    	// AST REWRITE
                    	// elements:          valuereference, typereference, EXPORTS
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 189:4: -> ( ^( EXPORTS ( typereference )* ( valuereference )* ) )?
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:189:7: ( ^( EXPORTS ( typereference )* ( valuereference )* ) )?
                    	    if ( stream_valuereference.HasNext() || stream_typereference.HasNext() || stream_EXPORTS.HasNext() )
                    	    {
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:189:7: ^( EXPORTS ( typereference )* ( valuereference )* )
                    	        {
                    	        object root_1 = (object)adaptor.GetNilNode();
                    	        root_1 = (object)adaptor.BecomeRoot(stream_EXPORTS.Next(), root_1);
                    	        
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:189:17: ( typereference )*
                    	        while ( stream_typereference.HasNext() )
                    	        {
                    	            adaptor.AddChild(root_1, stream_typereference.Next());
                    	        
                    	        }
                    	        stream_typereference.Reset();
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:189:32: ( valuereference )*
                    	        while ( stream_valuereference.HasNext() )
                    	        {
                    	            adaptor.AddChild(root_1, stream_valuereference.Next());
                    	        
                    	        }
                    	        stream_valuereference.Reset();
                    	        
                    	        adaptor.AddChild(root_0, root_1);
                    	        }
                    	    
                    	    }
                    	    stream_valuereference.Reset();
                    	    stream_typereference.Reset();
                    	    stream_EXPORTS.Reset();
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end exports

    public class imports_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start imports
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:192:1: imports : IMPORTS ( importFromModule )* ';' -> ( importFromModule )* ;
    public imports_return imports() // throws RecognitionException [1]
    {   
        imports_return retval = new imports_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken IMPORTS35 = null;
        IToken char_literal37 = null;
        importFromModule_return importFromModule36 = null;
        
        
        object IMPORTS35_tree=null;
        object char_literal37_tree=null;
        RewriteRuleTokenStream stream_162 = new RewriteRuleTokenStream(adaptor,"token 162");
        RewriteRuleTokenStream stream_IMPORTS = new RewriteRuleTokenStream(adaptor,"token IMPORTS");
        RewriteRuleSubtreeStream stream_importFromModule = new RewriteRuleSubtreeStream(adaptor,"rule importFromModule");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:192:9: ( IMPORTS ( importFromModule )* ';' -> ( importFromModule )* )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:193:2: IMPORTS ( importFromModule )* ';'
            {
            	IMPORTS35 = (IToken)input.LT(1);
            	Match(input,IMPORTS,FOLLOW_IMPORTS_in_imports661); 
            	stream_IMPORTS.Add(IMPORTS35);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:193:10: ( importFromModule )*
            	do 
            	{
            	    int alt16 = 2;
            	    int LA16_0 = input.LA(1);
            	    
            	    if ( (LA16_0 == UID || LA16_0 == LID) )
            	    {
            	        alt16 = 1;
            	    }
            	    
            	
            	    switch (alt16) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:193:10: importFromModule
            			    {
            			    	PushFollow(FOLLOW_importFromModule_in_imports663);
            			    	importFromModule36 = importFromModule();
            			    	followingStackPointer_--;
            			    	
            			    	stream_importFromModule.Add(importFromModule36.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop16;
            	    }
            	} while (true);
            	
            	loop16:
            		;	// Stops C# compiler whinging that label 'loop16' has no statements

            	char_literal37 = (IToken)input.LT(1);
            	Match(input,162,FOLLOW_162_in_imports667); 
            	stream_162.Add(char_literal37);

            	
            	// AST REWRITE
            	// elements:          importFromModule
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 193:33: -> ( importFromModule )*
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:193:36: ( importFromModule )*
            	    while ( stream_importFromModule.HasNext() )
            	    {
            	        adaptor.AddChild(root_0, stream_importFromModule.Next());
            	    
            	    }
            	    stream_importFromModule.Reset();
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end imports

    public class importFromModule_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start importFromModule
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:196:1: importFromModule : ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* FROM modulereference ( definitiveIdentifier )? -> ^( IMPORTS_FROM_MODULE modulereference ( typereference )* ( valuereference )* ) ;
    public importFromModule_return importFromModule() // throws RecognitionException [1]
    {   
        importFromModule_return retval = new importFromModule_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken COMMA40 = null;
        IToken FROM43 = null;
        typereference_return typereference38 = null;

        valuereference_return valuereference39 = null;

        typereference_return typereference41 = null;

        valuereference_return valuereference42 = null;

        modulereference_return modulereference44 = null;

        definitiveIdentifier_return definitiveIdentifier45 = null;
        
        
        object COMMA40_tree=null;
        object FROM43_tree=null;
        RewriteRuleTokenStream stream_FROM = new RewriteRuleTokenStream(adaptor,"token FROM");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_modulereference = new RewriteRuleSubtreeStream(adaptor,"rule modulereference");
        RewriteRuleSubtreeStream stream_typereference = new RewriteRuleSubtreeStream(adaptor,"rule typereference");
        RewriteRuleSubtreeStream stream_definitiveIdentifier = new RewriteRuleSubtreeStream(adaptor,"rule definitiveIdentifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:2: ( ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* FROM modulereference ( definitiveIdentifier )? -> ^( IMPORTS_FROM_MODULE modulereference ( typereference )* ( valuereference )* ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:4: ( typereference | valuereference ) ( COMMA ( typereference | valuereference ) )* FROM modulereference ( definitiveIdentifier )?
            {
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:4: ( typereference | valuereference )
            	int alt17 = 2;
            	int LA17_0 = input.LA(1);
            	
            	if ( (LA17_0 == UID) )
            	{
            	    alt17 = 1;
            	}
            	else if ( (LA17_0 == LID) )
            	{
            	    alt17 = 2;
            	}
            	else 
            	{
            	    NoViableAltException nvae_d17s0 =
            	        new NoViableAltException("197:4: ( typereference | valuereference )", 17, 0, input);
            	
            	    throw nvae_d17s0;
            	}
            	switch (alt17) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:5: typereference
            	        {
            	        	PushFollow(FOLLOW_typereference_in_importFromModule685);
            	        	typereference38 = typereference();
            	        	followingStackPointer_--;
            	        	
            	        	stream_typereference.Add(typereference38.Tree);
            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:21: valuereference
            	        {
            	        	PushFollow(FOLLOW_valuereference_in_importFromModule689);
            	        	valuereference39 = valuereference();
            	        	followingStackPointer_--;
            	        	
            	        	stream_valuereference.Add(valuereference39.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:37: ( COMMA ( typereference | valuereference ) )*
            	do 
            	{
            	    int alt19 = 2;
            	    int LA19_0 = input.LA(1);
            	    
            	    if ( (LA19_0 == COMMA) )
            	    {
            	        alt19 = 1;
            	    }
            	    
            	
            	    switch (alt19) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:38: COMMA ( typereference | valuereference )
            			    {
            			    	COMMA40 = (IToken)input.LT(1);
            			    	Match(input,COMMA,FOLLOW_COMMA_in_importFromModule693); 
            			    	stream_COMMA.Add(COMMA40);

            			    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:44: ( typereference | valuereference )
            			    	int alt18 = 2;
            			    	int LA18_0 = input.LA(1);
            			    	
            			    	if ( (LA18_0 == UID) )
            			    	{
            			    	    alt18 = 1;
            			    	}
            			    	else if ( (LA18_0 == LID) )
            			    	{
            			    	    alt18 = 2;
            			    	}
            			    	else 
            			    	{
            			    	    NoViableAltException nvae_d18s0 =
            			    	        new NoViableAltException("197:44: ( typereference | valuereference )", 18, 0, input);
            			    	
            			    	    throw nvae_d18s0;
            			    	}
            			    	switch (alt18) 
            			    	{
            			    	    case 1 :
            			    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:45: typereference
            			    	        {
            			    	        	PushFollow(FOLLOW_typereference_in_importFromModule696);
            			    	        	typereference41 = typereference();
            			    	        	followingStackPointer_--;
            			    	        	
            			    	        	stream_typereference.Add(typereference41.Tree);
            			    	        
            			    	        }
            			    	        break;
            			    	    case 2 :
            			    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:61: valuereference
            			    	        {
            			    	        	PushFollow(FOLLOW_valuereference_in_importFromModule700);
            			    	        	valuereference42 = valuereference();
            			    	        	followingStackPointer_--;
            			    	        	
            			    	        	stream_valuereference.Add(valuereference42.Tree);
            			    	        
            			    	        }
            			    	        break;
            			    	
            			    	}

            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop19;
            	    }
            	} while (true);
            	
            	loop19:
            		;	// Stops C# compiler whinging that label 'loop19' has no statements

            	FROM43 = (IToken)input.LT(1);
            	Match(input,FROM,FOLLOW_FROM_in_importFromModule705); 
            	stream_FROM.Add(FROM43);

            	PushFollow(FOLLOW_modulereference_in_importFromModule707);
            	modulereference44 = modulereference();
            	followingStackPointer_--;
            	
            	stream_modulereference.Add(modulereference44.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:100: ( definitiveIdentifier )?
            	int alt20 = 2;
            	int LA20_0 = input.LA(1);
            	
            	if ( (LA20_0 == L_BRACKET) )
            	{
            	    alt20 = 1;
            	}
            	switch (alt20) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:197:100: definitiveIdentifier
            	        {
            	        	PushFollow(FOLLOW_definitiveIdentifier_in_importFromModule709);
            	        	definitiveIdentifier45 = definitiveIdentifier();
            	        	followingStackPointer_--;
            	        	
            	        	stream_definitiveIdentifier.Add(definitiveIdentifier45.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          typereference, modulereference, valuereference
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 198:3: -> ^( IMPORTS_FROM_MODULE modulereference ( typereference )* ( valuereference )* )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:198:6: ^( IMPORTS_FROM_MODULE modulereference ( typereference )* ( valuereference )* )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(IMPORTS_FROM_MODULE, "IMPORTS_FROM_MODULE"), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_modulereference.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:198:44: ( typereference )*
            	    while ( stream_typereference.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_typereference.Next());
            	    
            	    }
            	    stream_typereference.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:198:59: ( valuereference )*
            	    while ( stream_valuereference.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_valuereference.Next());
            	    
            	    }
            	    stream_valuereference.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end importFromModule

    public class valueAssigment_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start valueAssigment
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:202:1: valueAssigment : valuereference type a= ASSIG_OP value -> ^( VAL_ASSIG[$a] valuereference type value ) ;
    public valueAssigment_return valueAssigment() // throws RecognitionException [1]
    {   
        valueAssigment_return retval = new valueAssigment_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        valuereference_return valuereference46 = null;

        type_return type47 = null;

        value_return value48 = null;
        
        
        object a_tree=null;
        RewriteRuleTokenStream stream_ASSIG_OP = new RewriteRuleTokenStream(adaptor,"token ASSIG_OP");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_value = new RewriteRuleSubtreeStream(adaptor,"rule value");
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:203:2: ( valuereference type a= ASSIG_OP value -> ^( VAL_ASSIG[$a] valuereference type value ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:203:4: valuereference type a= ASSIG_OP value
            {
            	PushFollow(FOLLOW_valuereference_in_valueAssigment744);
            	valuereference46 = valuereference();
            	followingStackPointer_--;
            	
            	stream_valuereference.Add(valuereference46.Tree);
            	PushFollow(FOLLOW_type_in_valueAssigment746);
            	type47 = type();
            	followingStackPointer_--;
            	
            	stream_type.Add(type47.Tree);
            	a = (IToken)input.LT(1);
            	Match(input,ASSIG_OP,FOLLOW_ASSIG_OP_in_valueAssigment750); 
            	stream_ASSIG_OP.Add(a);

            	PushFollow(FOLLOW_value_in_valueAssigment752);
            	value48 = value();
            	followingStackPointer_--;
            	
            	stream_value.Add(value48.Tree);
            	
            	// AST REWRITE
            	// elements:          type, valuereference, value
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 203:42: -> ^( VAL_ASSIG[$a] valuereference type value )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:203:45: ^( VAL_ASSIG[$a] valuereference type value )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(VAL_ASSIG, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_valuereference.Next());
            	    adaptor.AddChild(root_1, stream_type.Next());
            	    adaptor.AddChild(root_1, stream_value.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end valueAssigment

    public class typeAssigment_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start typeAssigment
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:211:1: typeAssigment : typereference a= ASSIG_OP type -> ^( TYPE_ASSIG[$a] typereference type ) ;
    public typeAssigment_return typeAssigment() // throws RecognitionException [1]
    {   
        typeAssigment_return retval = new typeAssigment_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        typereference_return typereference49 = null;

        type_return type50 = null;
        
        
        object a_tree=null;
        RewriteRuleTokenStream stream_ASSIG_OP = new RewriteRuleTokenStream(adaptor,"token ASSIG_OP");
        RewriteRuleSubtreeStream stream_typereference = new RewriteRuleSubtreeStream(adaptor,"rule typereference");
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:212:2: ( typereference a= ASSIG_OP type -> ^( TYPE_ASSIG[$a] typereference type ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:212:25: typereference a= ASSIG_OP type
            {
            	PushFollow(FOLLOW_typereference_in_typeAssigment785);
            	typereference49 = typereference();
            	followingStackPointer_--;
            	
            	stream_typereference.Add(typereference49.Tree);
            	a = (IToken)input.LT(1);
            	Match(input,ASSIG_OP,FOLLOW_ASSIG_OP_in_typeAssigment789); 
            	stream_ASSIG_OP.Add(a);

            	PushFollow(FOLLOW_type_in_typeAssigment791);
            	type50 = type();
            	followingStackPointer_--;
            	
            	stream_type.Add(type50.Tree);
            	
            	// AST REWRITE
            	// elements:          typereference, type
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 212:55: -> ^( TYPE_ASSIG[$a] typereference type )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:212:58: ^( TYPE_ASSIG[$a] typereference type )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_ASSIG, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_typereference.Next());
            	    adaptor.AddChild(root_1, stream_type.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end typeAssigment

    public class typeTag_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start typeTag
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:220:1: typeTag : a= '[' (t= UNIVERSAL | t= APPLICATION | t= PRIVATE )? ( INT | val= valuereference ) ']' (impOrExp= IMPLICIT | impOrExp= EXPLICIT )? -> ^( TYPE_TAG[$a] ( $t)? ( INT )? ( ^( VALUE_REFERENCE[val.start] $val) )? ( $impOrExp)? ) ;
    public typeTag_return typeTag() // throws RecognitionException [1]
    {   
        typeTag_return retval = new typeTag_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken t = null;
        IToken impOrExp = null;
        IToken INT51 = null;
        IToken char_literal52 = null;
        valuereference_return val = null;
        
        
        object a_tree=null;
        object t_tree=null;
        object impOrExp_tree=null;
        object INT51_tree=null;
        object char_literal52_tree=null;
        RewriteRuleTokenStream stream_163 = new RewriteRuleTokenStream(adaptor,"token 163");
        RewriteRuleTokenStream stream_164 = new RewriteRuleTokenStream(adaptor,"token 164");
        RewriteRuleTokenStream stream_INT = new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_IMPLICIT = new RewriteRuleTokenStream(adaptor,"token IMPLICIT");
        RewriteRuleTokenStream stream_EXPLICIT = new RewriteRuleTokenStream(adaptor,"token EXPLICIT");
        RewriteRuleTokenStream stream_UNIVERSAL = new RewriteRuleTokenStream(adaptor,"token UNIVERSAL");
        RewriteRuleTokenStream stream_APPLICATION = new RewriteRuleTokenStream(adaptor,"token APPLICATION");
        RewriteRuleTokenStream stream_PRIVATE = new RewriteRuleTokenStream(adaptor,"token PRIVATE");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:2: (a= '[' (t= UNIVERSAL | t= APPLICATION | t= PRIVATE )? ( INT | val= valuereference ) ']' (impOrExp= IMPLICIT | impOrExp= EXPLICIT )? -> ^( TYPE_TAG[$a] ( $t)? ( INT )? ( ^( VALUE_REFERENCE[val.start] $val) )? ( $impOrExp)? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:4: a= '[' (t= UNIVERSAL | t= APPLICATION | t= PRIVATE )? ( INT | val= valuereference ) ']' (impOrExp= IMPLICIT | impOrExp= EXPLICIT )?
            {
            	a = (IToken)input.LT(1);
            	Match(input,163,FOLLOW_163_in_typeTag827); 
            	stream_163.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:10: (t= UNIVERSAL | t= APPLICATION | t= PRIVATE )?
            	int alt21 = 4;
            	switch ( input.LA(1) ) 
            	{
            	    case UNIVERSAL:
            	    	{
            	        alt21 = 1;
            	        }
            	        break;
            	    case APPLICATION:
            	    	{
            	        alt21 = 2;
            	        }
            	        break;
            	    case PRIVATE:
            	    	{
            	        alt21 = 3;
            	        }
            	        break;
            	}
            	
            	switch (alt21) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:11: t= UNIVERSAL
            	        {
            	        	t = (IToken)input.LT(1);
            	        	Match(input,UNIVERSAL,FOLLOW_UNIVERSAL_in_typeTag832); 
            	        	stream_UNIVERSAL.Add(t);

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:25: t= APPLICATION
            	        {
            	        	t = (IToken)input.LT(1);
            	        	Match(input,APPLICATION,FOLLOW_APPLICATION_in_typeTag838); 
            	        	stream_APPLICATION.Add(t);

            	        
            	        }
            	        break;
            	    case 3 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:41: t= PRIVATE
            	        {
            	        	t = (IToken)input.LT(1);
            	        	Match(input,PRIVATE,FOLLOW_PRIVATE_in_typeTag844); 
            	        	stream_PRIVATE.Add(t);

            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:53: ( INT | val= valuereference )
            	int alt22 = 2;
            	int LA22_0 = input.LA(1);
            	
            	if ( (LA22_0 == INT) )
            	{
            	    alt22 = 1;
            	}
            	else if ( (LA22_0 == LID) )
            	{
            	    alt22 = 2;
            	}
            	else 
            	{
            	    NoViableAltException nvae_d22s0 =
            	        new NoViableAltException("221:53: ( INT | val= valuereference )", 22, 0, input);
            	
            	    throw nvae_d22s0;
            	}
            	switch (alt22) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:54: INT
            	        {
            	        	INT51 = (IToken)input.LT(1);
            	        	Match(input,INT,FOLLOW_INT_in_typeTag849); 
            	        	stream_INT.Add(INT51);

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:58: val= valuereference
            	        {
            	        	PushFollow(FOLLOW_valuereference_in_typeTag853);
            	        	val = valuereference();
            	        	followingStackPointer_--;
            	        	
            	        	stream_valuereference.Add(val.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	char_literal52 = (IToken)input.LT(1);
            	Match(input,164,FOLLOW_164_in_typeTag857); 
            	stream_164.Add(char_literal52);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:83: (impOrExp= IMPLICIT | impOrExp= EXPLICIT )?
            	int alt23 = 3;
            	int LA23_0 = input.LA(1);
            	
            	if ( (LA23_0 == IMPLICIT) )
            	{
            	    alt23 = 1;
            	}
            	else if ( (LA23_0 == EXPLICIT) )
            	{
            	    alt23 = 2;
            	}
            	switch (alt23) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:85: impOrExp= IMPLICIT
            	        {
            	        	impOrExp = (IToken)input.LT(1);
            	        	Match(input,IMPLICIT,FOLLOW_IMPLICIT_in_typeTag863); 
            	        	stream_IMPLICIT.Add(impOrExp);

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:221:105: impOrExp= EXPLICIT
            	        {
            	        	impOrExp = (IToken)input.LT(1);
            	        	Match(input,EXPLICIT,FOLLOW_EXPLICIT_in_typeTag869); 
            	        	stream_EXPLICIT.Add(impOrExp);

            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          val, impOrExp, t, INT
            	// token labels:      t, impOrExp
            	// rule labels:       val, retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_t = new RewriteRuleTokenStream(adaptor, "token t", t);
            	RewriteRuleTokenStream stream_impOrExp = new RewriteRuleTokenStream(adaptor, "token impOrExp", impOrExp);
            	RewriteRuleSubtreeStream stream_val = new RewriteRuleSubtreeStream(adaptor, "token val", (val!=null ? val.Tree : null));
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 222:4: -> ^( TYPE_TAG[$a] ( $t)? ( INT )? ( ^( VALUE_REFERENCE[val.start] $val) )? ( $impOrExp)? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:222:7: ^( TYPE_TAG[$a] ( $t)? ( INT )? ( ^( VALUE_REFERENCE[val.start] $val) )? ( $impOrExp)? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_TAG, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:222:22: ( $t)?
            	    if ( stream_t.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_t.Next());
            	    
            	    }
            	    stream_t.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:222:26: ( INT )?
            	    if ( stream_INT.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_INT.Next());
            	    
            	    }
            	    stream_INT.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:222:31: ( ^( VALUE_REFERENCE[val.start] $val) )?
            	    if ( stream_val.HasNext() )
            	    {
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:222:31: ^( VALUE_REFERENCE[val.start] $val)
            	        {
            	        object root_2 = (object)adaptor.GetNilNode();
            	        root_2 = (object)adaptor.BecomeRoot(adaptor.Create(VALUE_REFERENCE, val.start), root_2);
            	        
            	        adaptor.AddChild(root_2, stream_val.Next());
            	        
            	        adaptor.AddChild(root_1, root_2);
            	        }
            	    
            	    }
            	    stream_val.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:222:67: ( $impOrExp)?
            	    if ( stream_impOrExp.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_impOrExp.Next());
            	    
            	    }
            	    stream_impOrExp.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end typeTag

    public class type_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start type
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:250:1: type : ( typeTag )? ( nULL -> ^( TYPE_DEF ( typeTag )? nULL ) | bitStringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* ) | booleanType ( constraint )* -> ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* ) | enumeratedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* ) | integerType ( constraint )* -> ^( TYPE_DEF ( typeTag )? integerType ( constraint )* ) | realType ( constraint )* -> ^( TYPE_DEF ( typeTag )? realType ( constraint )* ) | stringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? stringType ( constraint )* ) | referencedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* ) | sequenceOfType -> ^( TYPE_DEF ( typeTag )? sequenceOfType ) | choiceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* ) | sequenceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* ) | setType ( constraint )* -> ^( TYPE_DEF ( typeTag )? setType ) | setOfType -> ^( TYPE_DEF ( typeTag )? setOfType ) | objectIdentifier ( constraint )* -> ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* ) | relativeOID ( constraint )* -> ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* ) | selectionType -> ^( TYPE_DEF ( typeTag )? selectionType ) ) ;
    public type_return type() // throws RecognitionException [1]
    {   
        type_return retval = new type_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        typeTag_return typeTag53 = null;

        nULL_return nULL54 = null;

        bitStringType_return bitStringType55 = null;

        constraint_return constraint56 = null;

        booleanType_return booleanType57 = null;

        constraint_return constraint58 = null;

        enumeratedType_return enumeratedType59 = null;

        constraint_return constraint60 = null;

        integerType_return integerType61 = null;

        constraint_return constraint62 = null;

        realType_return realType63 = null;

        constraint_return constraint64 = null;

        stringType_return stringType65 = null;

        constraint_return constraint66 = null;

        referencedType_return referencedType67 = null;

        constraint_return constraint68 = null;

        sequenceOfType_return sequenceOfType69 = null;

        choiceType_return choiceType70 = null;

        constraint_return constraint71 = null;

        sequenceType_return sequenceType72 = null;

        constraint_return constraint73 = null;

        setType_return setType74 = null;

        constraint_return constraint75 = null;

        setOfType_return setOfType76 = null;

        objectIdentifier_return objectIdentifier77 = null;

        constraint_return constraint78 = null;

        relativeOID_return relativeOID79 = null;

        constraint_return constraint80 = null;

        selectionType_return selectionType81 = null;
        
        
        RewriteRuleSubtreeStream stream_nULL = new RewriteRuleSubtreeStream(adaptor,"rule nULL");
        RewriteRuleSubtreeStream stream_stringType = new RewriteRuleSubtreeStream(adaptor,"rule stringType");
        RewriteRuleSubtreeStream stream_objectIdentifier = new RewriteRuleSubtreeStream(adaptor,"rule objectIdentifier");
        RewriteRuleSubtreeStream stream_choiceType = new RewriteRuleSubtreeStream(adaptor,"rule choiceType");
        RewriteRuleSubtreeStream stream_typeTag = new RewriteRuleSubtreeStream(adaptor,"rule typeTag");
        RewriteRuleSubtreeStream stream_booleanType = new RewriteRuleSubtreeStream(adaptor,"rule booleanType");
        RewriteRuleSubtreeStream stream_enumeratedType = new RewriteRuleSubtreeStream(adaptor,"rule enumeratedType");
        RewriteRuleSubtreeStream stream_bitStringType = new RewriteRuleSubtreeStream(adaptor,"rule bitStringType");
        RewriteRuleSubtreeStream stream_sequenceOfType = new RewriteRuleSubtreeStream(adaptor,"rule sequenceOfType");
        RewriteRuleSubtreeStream stream_setType = new RewriteRuleSubtreeStream(adaptor,"rule setType");
        RewriteRuleSubtreeStream stream_sequenceType = new RewriteRuleSubtreeStream(adaptor,"rule sequenceType");
        RewriteRuleSubtreeStream stream_constraint = new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        RewriteRuleSubtreeStream stream_referencedType = new RewriteRuleSubtreeStream(adaptor,"rule referencedType");
        RewriteRuleSubtreeStream stream_setOfType = new RewriteRuleSubtreeStream(adaptor,"rule setOfType");
        RewriteRuleSubtreeStream stream_selectionType = new RewriteRuleSubtreeStream(adaptor,"rule selectionType");
        RewriteRuleSubtreeStream stream_realType = new RewriteRuleSubtreeStream(adaptor,"rule realType");
        RewriteRuleSubtreeStream stream_relativeOID = new RewriteRuleSubtreeStream(adaptor,"rule relativeOID");
        RewriteRuleSubtreeStream stream_integerType = new RewriteRuleSubtreeStream(adaptor,"rule integerType");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:250:6: ( ( typeTag )? ( nULL -> ^( TYPE_DEF ( typeTag )? nULL ) | bitStringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* ) | booleanType ( constraint )* -> ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* ) | enumeratedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* ) | integerType ( constraint )* -> ^( TYPE_DEF ( typeTag )? integerType ( constraint )* ) | realType ( constraint )* -> ^( TYPE_DEF ( typeTag )? realType ( constraint )* ) | stringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? stringType ( constraint )* ) | referencedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* ) | sequenceOfType -> ^( TYPE_DEF ( typeTag )? sequenceOfType ) | choiceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* ) | sequenceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* ) | setType ( constraint )* -> ^( TYPE_DEF ( typeTag )? setType ) | setOfType -> ^( TYPE_DEF ( typeTag )? setOfType ) | objectIdentifier ( constraint )* -> ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* ) | relativeOID ( constraint )* -> ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* ) | selectionType -> ^( TYPE_DEF ( typeTag )? selectionType ) ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:250:8: ( typeTag )? ( nULL -> ^( TYPE_DEF ( typeTag )? nULL ) | bitStringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* ) | booleanType ( constraint )* -> ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* ) | enumeratedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* ) | integerType ( constraint )* -> ^( TYPE_DEF ( typeTag )? integerType ( constraint )* ) | realType ( constraint )* -> ^( TYPE_DEF ( typeTag )? realType ( constraint )* ) | stringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? stringType ( constraint )* ) | referencedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* ) | sequenceOfType -> ^( TYPE_DEF ( typeTag )? sequenceOfType ) | choiceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* ) | sequenceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* ) | setType ( constraint )* -> ^( TYPE_DEF ( typeTag )? setType ) | setOfType -> ^( TYPE_DEF ( typeTag )? setOfType ) | objectIdentifier ( constraint )* -> ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* ) | relativeOID ( constraint )* -> ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* ) | selectionType -> ^( TYPE_DEF ( typeTag )? selectionType ) )
            {
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:250:8: ( typeTag )?
            	int alt24 = 2;
            	int LA24_0 = input.LA(1);
            	
            	if ( (LA24_0 == 163) )
            	{
            	    alt24 = 1;
            	}
            	switch (alt24) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:250:8: typeTag
            	        {
            	        	PushFollow(FOLLOW_typeTag_in_type921);
            	        	typeTag53 = typeTag();
            	        	followingStackPointer_--;
            	        	
            	        	stream_typeTag.Add(typeTag53.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:251:1: ( nULL -> ^( TYPE_DEF ( typeTag )? nULL ) | bitStringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* ) | booleanType ( constraint )* -> ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* ) | enumeratedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* ) | integerType ( constraint )* -> ^( TYPE_DEF ( typeTag )? integerType ( constraint )* ) | realType ( constraint )* -> ^( TYPE_DEF ( typeTag )? realType ( constraint )* ) | stringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? stringType ( constraint )* ) | referencedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* ) | sequenceOfType -> ^( TYPE_DEF ( typeTag )? sequenceOfType ) | choiceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* ) | sequenceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* ) | setType ( constraint )* -> ^( TYPE_DEF ( typeTag )? setType ) | setOfType -> ^( TYPE_DEF ( typeTag )? setOfType ) | objectIdentifier ( constraint )* -> ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* ) | relativeOID ( constraint )* -> ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* ) | selectionType -> ^( TYPE_DEF ( typeTag )? selectionType ) )
            	int alt37 = 16;
            	switch ( input.LA(1) ) 
            	{
            	case NULL:
            		{
            	    alt37 = 1;
            	    }
            	    break;
            	case BIT:
            		{
            	    alt37 = 2;
            	    }
            	    break;
            	case BOOLEAN:
            		{
            	    alt37 = 3;
            	    }
            	    break;
            	case ENUMERATED:
            		{
            	    alt37 = 4;
            	    }
            	    break;
            	case INTEGER:
            		{
            	    alt37 = 5;
            	    }
            	    break;
            	case REAL:
            		{
            	    alt37 = 6;
            	    }
            	    break;
            	case OCTET:
            	case NumericString:
            	case PrintableString:
            	case VisibleString:
            	case IA5String:
            	case TeletexString:
            	case VideotexString:
            	case GraphicString:
            	case GeneralString:
            	case UniversalString:
            	case BMPString:
            	case UTF8String:
            	case GeneralizedTime:
            	case UTCTime:
            		{
            	    alt37 = 7;
            	    }
            	    break;
            	case UID:
            		{
            	    alt37 = 8;
            	    }
            	    break;
            	case SEQUENCE:
            		{
            	    int LA37_9 = input.LA(2);
            	    
            	    if ( (LA37_9 == L_BRACKET) )
            	    {
            	        alt37 = 11;
            	    }
            	    else if ( (LA37_9 == L_PAREN || LA37_9 == SIZE || LA37_9 == OF) )
            	    {
            	        alt37 = 9;
            	    }
            	    else 
            	    {
            	        NoViableAltException nvae_d37s9 =
            	            new NoViableAltException("251:1: ( nULL -> ^( TYPE_DEF ( typeTag )? nULL ) | bitStringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* ) | booleanType ( constraint )* -> ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* ) | enumeratedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* ) | integerType ( constraint )* -> ^( TYPE_DEF ( typeTag )? integerType ( constraint )* ) | realType ( constraint )* -> ^( TYPE_DEF ( typeTag )? realType ( constraint )* ) | stringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? stringType ( constraint )* ) | referencedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* ) | sequenceOfType -> ^( TYPE_DEF ( typeTag )? sequenceOfType ) | choiceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* ) | sequenceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* ) | setType ( constraint )* -> ^( TYPE_DEF ( typeTag )? setType ) | setOfType -> ^( TYPE_DEF ( typeTag )? setOfType ) | objectIdentifier ( constraint )* -> ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* ) | relativeOID ( constraint )* -> ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* ) | selectionType -> ^( TYPE_DEF ( typeTag )? selectionType ) )", 37, 9, input);
            	    
            	        throw nvae_d37s9;
            	    }
            	    }
            	    break;
            	case CHOICE:
            		{
            	    alt37 = 10;
            	    }
            	    break;
            	case SET:
            		{
            	    int LA37_11 = input.LA(2);
            	    
            	    if ( (LA37_11 == L_BRACKET) )
            	    {
            	        alt37 = 12;
            	    }
            	    else if ( (LA37_11 == L_PAREN || LA37_11 == SIZE || LA37_11 == OF) )
            	    {
            	        alt37 = 13;
            	    }
            	    else 
            	    {
            	        NoViableAltException nvae_d37s11 =
            	            new NoViableAltException("251:1: ( nULL -> ^( TYPE_DEF ( typeTag )? nULL ) | bitStringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* ) | booleanType ( constraint )* -> ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* ) | enumeratedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* ) | integerType ( constraint )* -> ^( TYPE_DEF ( typeTag )? integerType ( constraint )* ) | realType ( constraint )* -> ^( TYPE_DEF ( typeTag )? realType ( constraint )* ) | stringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? stringType ( constraint )* ) | referencedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* ) | sequenceOfType -> ^( TYPE_DEF ( typeTag )? sequenceOfType ) | choiceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* ) | sequenceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* ) | setType ( constraint )* -> ^( TYPE_DEF ( typeTag )? setType ) | setOfType -> ^( TYPE_DEF ( typeTag )? setOfType ) | objectIdentifier ( constraint )* -> ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* ) | relativeOID ( constraint )* -> ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* ) | selectionType -> ^( TYPE_DEF ( typeTag )? selectionType ) )", 37, 11, input);
            	    
            	        throw nvae_d37s11;
            	    }
            	    }
            	    break;
            	case OBJECT:
            		{
            	    alt37 = 14;
            	    }
            	    break;
            	case RELATIVE_OID:
            		{
            	    alt37 = 15;
            	    }
            	    break;
            	case LID:
            		{
            	    alt37 = 16;
            	    }
            	    break;
            		default:
            		    NoViableAltException nvae_d37s0 =
            		        new NoViableAltException("251:1: ( nULL -> ^( TYPE_DEF ( typeTag )? nULL ) | bitStringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* ) | booleanType ( constraint )* -> ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* ) | enumeratedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* ) | integerType ( constraint )* -> ^( TYPE_DEF ( typeTag )? integerType ( constraint )* ) | realType ( constraint )* -> ^( TYPE_DEF ( typeTag )? realType ( constraint )* ) | stringType ( constraint )* -> ^( TYPE_DEF ( typeTag )? stringType ( constraint )* ) | referencedType ( constraint )* -> ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* ) | sequenceOfType -> ^( TYPE_DEF ( typeTag )? sequenceOfType ) | choiceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* ) | sequenceType ( constraint )* -> ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* ) | setType ( constraint )* -> ^( TYPE_DEF ( typeTag )? setType ) | setOfType -> ^( TYPE_DEF ( typeTag )? setOfType ) | objectIdentifier ( constraint )* -> ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* ) | relativeOID ( constraint )* -> ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* ) | selectionType -> ^( TYPE_DEF ( typeTag )? selectionType ) )", 37, 0, input);
            	
            		    throw nvae_d37s0;
            	}
            	
            	switch (alt37) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:251:4: nULL
            	        {
            	        	PushFollow(FOLLOW_nULL_in_type927);
            	        	nULL54 = nULL();
            	        	followingStackPointer_--;
            	        	
            	        	stream_nULL.Add(nULL54.Tree);
            	        	
            	        	// AST REWRITE
            	        	// elements:          nULL, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 251:21: -> ^( TYPE_DEF ( typeTag )? nULL )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:251:24: ^( TYPE_DEF ( typeTag )? nULL )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:251:35: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_nULL.Next());
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:252:3: bitStringType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_bitStringType_in_type954);
            	        	bitStringType55 = bitStringType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_bitStringType.Add(bitStringType55.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:252:17: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt25 = 2;
            	        	    int LA25_0 = input.LA(1);
            	        	    
            	        	    if ( (LA25_0 == L_PAREN) )
            	        	    {
            	        	        alt25 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt25) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:252:17: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type956);
            	        			    	constraint56 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint56.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop25;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop25:
            	        		;	// Stops C# compiler whinging that label 'loop25' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          bitStringType, typeTag, constraint
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 252:36: -> ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:252:39: ^( TYPE_DEF ( typeTag )? bitStringType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:252:50: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_bitStringType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:252:73: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 3 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:253:3: booleanType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_booleanType_in_type982);
            	        	booleanType57 = booleanType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_booleanType.Add(booleanType57.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:253:15: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt26 = 2;
            	        	    int LA26_0 = input.LA(1);
            	        	    
            	        	    if ( (LA26_0 == L_PAREN) )
            	        	    {
            	        	        alt26 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt26) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:253:15: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type984);
            	        			    	constraint58 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint58.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop26;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop26:
            	        		;	// Stops C# compiler whinging that label 'loop26' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          typeTag, booleanType, constraint
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 253:34: -> ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:253:37: ^( TYPE_DEF ( typeTag )? booleanType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:253:48: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_booleanType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:253:69: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 4 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:254:3: enumeratedType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_enumeratedType_in_type1010);
            	        	enumeratedType59 = enumeratedType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_enumeratedType.Add(enumeratedType59.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:254:18: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt27 = 2;
            	        	    int LA27_0 = input.LA(1);
            	        	    
            	        	    if ( (LA27_0 == L_PAREN) )
            	        	    {
            	        	        alt27 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt27) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:254:18: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1012);
            	        			    	constraint60 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint60.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop27;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop27:
            	        		;	// Stops C# compiler whinging that label 'loop27' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          constraint, typeTag, enumeratedType
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 254:37: -> ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:254:40: ^( TYPE_DEF ( typeTag )? enumeratedType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:254:51: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_enumeratedType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:254:75: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 5 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:255:3: integerType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_integerType_in_type1038);
            	        	integerType61 = integerType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_integerType.Add(integerType61.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:255:15: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt28 = 2;
            	        	    int LA28_0 = input.LA(1);
            	        	    
            	        	    if ( (LA28_0 == L_PAREN) )
            	        	    {
            	        	        alt28 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt28) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:255:15: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1040);
            	        			    	constraint62 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint62.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop28;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop28:
            	        		;	// Stops C# compiler whinging that label 'loop28' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          constraint, integerType, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 255:34: -> ^( TYPE_DEF ( typeTag )? integerType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:255:37: ^( TYPE_DEF ( typeTag )? integerType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:255:48: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_integerType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:255:69: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 6 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:256:6: realType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_realType_in_type1069);
            	        	realType63 = realType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_realType.Add(realType63.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:256:15: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt29 = 2;
            	        	    int LA29_0 = input.LA(1);
            	        	    
            	        	    if ( (LA29_0 == L_PAREN) )
            	        	    {
            	        	        alt29 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt29) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:256:15: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1071);
            	        			    	constraint64 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint64.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop29;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop29:
            	        		;	// Stops C# compiler whinging that label 'loop29' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          typeTag, realType, constraint
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 256:35: -> ^( TYPE_DEF ( typeTag )? realType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:256:38: ^( TYPE_DEF ( typeTag )? realType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:256:49: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_realType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:256:67: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 7 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:257:3: stringType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_stringType_in_type1098);
            	        	stringType65 = stringType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_stringType.Add(stringType65.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:257:14: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt30 = 2;
            	        	    int LA30_0 = input.LA(1);
            	        	    
            	        	    if ( (LA30_0 == L_PAREN) )
            	        	    {
            	        	        alt30 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt30) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:257:14: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1100);
            	        			    	constraint66 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint66.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop30;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop30:
            	        		;	// Stops C# compiler whinging that label 'loop30' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          stringType, typeTag, constraint
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 257:34: -> ^( TYPE_DEF ( typeTag )? stringType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:257:37: ^( TYPE_DEF ( typeTag )? stringType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:257:48: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_stringType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:257:68: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 8 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:258:3: referencedType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_referencedType_in_type1127);
            	        	referencedType67 = referencedType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_referencedType.Add(referencedType67.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:258:18: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt31 = 2;
            	        	    int LA31_0 = input.LA(1);
            	        	    
            	        	    if ( (LA31_0 == L_PAREN) )
            	        	    {
            	        	        alt31 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt31) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:258:18: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1129);
            	        			    	constraint68 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint68.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop31;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop31:
            	        		;	// Stops C# compiler whinging that label 'loop31' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          referencedType, typeTag, constraint
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 258:37: -> ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:258:40: ^( TYPE_DEF ( typeTag )? referencedType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:258:51: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_referencedType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:258:75: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 9 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:259:3: sequenceOfType
            	        {
            	        	PushFollow(FOLLOW_sequenceOfType_in_type1155);
            	        	sequenceOfType69 = sequenceOfType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_sequenceOfType.Add(sequenceOfType69.Tree);
            	        	
            	        	// AST REWRITE
            	        	// elements:          sequenceOfType, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 259:28: -> ^( TYPE_DEF ( typeTag )? sequenceOfType )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:259:31: ^( TYPE_DEF ( typeTag )? sequenceOfType )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:259:42: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_sequenceOfType.Next());
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 10 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:260:3: choiceType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_choiceType_in_type1180);
            	        	choiceType70 = choiceType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_choiceType.Add(choiceType70.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:260:14: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt32 = 2;
            	        	    int LA32_0 = input.LA(1);
            	        	    
            	        	    if ( (LA32_0 == L_PAREN) )
            	        	    {
            	        	        alt32 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt32) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:260:14: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1182);
            	        			    	constraint71 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint71.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop32;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop32:
            	        		;	// Stops C# compiler whinging that label 'loop32' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          choiceType, constraint, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 260:34: -> ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:260:37: ^( TYPE_DEF ( typeTag )? choiceType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:260:48: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_choiceType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:260:68: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 11 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:261:6: sequenceType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_sequenceType_in_type1212);
            	        	sequenceType72 = sequenceType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_sequenceType.Add(sequenceType72.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:261:19: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt33 = 2;
            	        	    int LA33_0 = input.LA(1);
            	        	    
            	        	    if ( (LA33_0 == L_PAREN) )
            	        	    {
            	        	        alt33 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt33) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:261:19: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1214);
            	        			    	constraint73 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint73.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop33;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop33:
            	        		;	// Stops C# compiler whinging that label 'loop33' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          typeTag, sequenceType, constraint
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 261:38: -> ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:261:41: ^( TYPE_DEF ( typeTag )? sequenceType ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:261:52: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_sequenceType.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:261:74: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 12 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:262:6: setType ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_setType_in_type1243);
            	        	setType74 = setType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_setType.Add(setType74.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:262:14: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt34 = 2;
            	        	    int LA34_0 = input.LA(1);
            	        	    
            	        	    if ( (LA34_0 == L_PAREN) )
            	        	    {
            	        	        alt34 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt34) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:262:14: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1245);
            	        			    	constraint75 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint75.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop34;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop34:
            	        		;	// Stops C# compiler whinging that label 'loop34' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          setType, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 262:36: -> ^( TYPE_DEF ( typeTag )? setType )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:262:39: ^( TYPE_DEF ( typeTag )? setType )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:262:50: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_setType.Next());
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 13 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:263:6: setOfType
            	        {
            	        	PushFollow(FOLLOW_setOfType_in_type1274);
            	        	setOfType76 = setOfType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_setOfType.Add(setOfType76.Tree);
            	        	
            	        	// AST REWRITE
            	        	// elements:          setOfType, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 263:27: -> ^( TYPE_DEF ( typeTag )? setOfType )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:263:30: ^( TYPE_DEF ( typeTag )? setOfType )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:263:41: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_setOfType.Next());
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 14 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:264:6: objectIdentifier ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_objectIdentifier_in_type1303);
            	        	objectIdentifier77 = objectIdentifier();
            	        	followingStackPointer_--;
            	        	
            	        	stream_objectIdentifier.Add(objectIdentifier77.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:264:23: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt35 = 2;
            	        	    int LA35_0 = input.LA(1);
            	        	    
            	        	    if ( (LA35_0 == L_PAREN) )
            	        	    {
            	        	        alt35 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt35) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:264:23: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1305);
            	        			    	constraint78 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint78.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop35;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop35:
            	        		;	// Stops C# compiler whinging that label 'loop35' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          constraint, objectIdentifier, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 264:41: -> ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:264:44: ^( TYPE_DEF ( typeTag )? objectIdentifier ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:264:55: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_objectIdentifier.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:264:81: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 15 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:265:6: relativeOID ( constraint )*
            	        {
            	        	PushFollow(FOLLOW_relativeOID_in_type1333);
            	        	relativeOID79 = relativeOID();
            	        	followingStackPointer_--;
            	        	
            	        	stream_relativeOID.Add(relativeOID79.Tree);
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:265:18: ( constraint )*
            	        	do 
            	        	{
            	        	    int alt36 = 2;
            	        	    int LA36_0 = input.LA(1);
            	        	    
            	        	    if ( (LA36_0 == L_PAREN) )
            	        	    {
            	        	        alt36 = 1;
            	        	    }
            	        	    
            	        	
            	        	    switch (alt36) 
            	        		{
            	        			case 1 :
            	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:265:18: constraint
            	        			    {
            	        			    	PushFollow(FOLLOW_constraint_in_type1335);
            	        			    	constraint80 = constraint();
            	        			    	followingStackPointer_--;
            	        			    	
            	        			    	stream_constraint.Add(constraint80.Tree);
            	        			    
            	        			    }
            	        			    break;
            	        	
            	        			default:
            	        			    goto loop36;
            	        	    }
            	        	} while (true);
            	        	
            	        	loop36:
            	        		;	// Stops C# compiler whinging that label 'loop36' has no statements

            	        	
            	        	// AST REWRITE
            	        	// elements:          constraint, relativeOID, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 265:37: -> ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:265:40: ^( TYPE_DEF ( typeTag )? relativeOID ( constraint )* )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:265:51: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_relativeOID.Next());
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:265:72: ( constraint )*
            	        	    while ( stream_constraint.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_constraint.Next());
            	        	    
            	        	    }
            	        	    stream_constraint.Reset();
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 16 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:266:6: selectionType
            	        {
            	        	PushFollow(FOLLOW_selectionType_in_type1364);
            	        	selectionType81 = selectionType();
            	        	followingStackPointer_--;
            	        	
            	        	stream_selectionType.Add(selectionType81.Tree);
            	        	
            	        	// AST REWRITE
            	        	// elements:          selectionType, typeTag
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 266:30: -> ^( TYPE_DEF ( typeTag )? selectionType )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:266:33: ^( TYPE_DEF ( typeTag )? selectionType )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(TYPE_DEF, "TYPE_DEF"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:266:44: ( typeTag )?
            	        	    if ( stream_typeTag.HasNext() )
            	        	    {
            	        	        adaptor.AddChild(root_1, stream_typeTag.Next());
            	        	    
            	        	    }
            	        	    stream_typeTag.Reset();
            	        	    adaptor.AddChild(root_1, stream_selectionType.Next());
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	
            	}

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end type

    public class selectionType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start selectionType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:270:1: selectionType : identifier a= '<' type -> ^( SELECTION_TYPE[$a] identifier type ) ;
    public selectionType_return selectionType() // throws RecognitionException [1]
    {   
        selectionType_return retval = new selectionType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        identifier_return identifier82 = null;

        type_return type83 = null;
        
        
        object a_tree=null;
        RewriteRuleTokenStream stream_165 = new RewriteRuleTokenStream(adaptor,"token 165");
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:270:15: ( identifier a= '<' type -> ^( SELECTION_TYPE[$a] identifier type ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:271:2: identifier a= '<' type
            {
            	PushFollow(FOLLOW_identifier_in_selectionType1398);
            	identifier82 = identifier();
            	followingStackPointer_--;
            	
            	stream_identifier.Add(identifier82.Tree);
            	a = (IToken)input.LT(1);
            	Match(input,165,FOLLOW_165_in_selectionType1402); 
            	stream_165.Add(a);

            	PushFollow(FOLLOW_type_in_selectionType1404);
            	type83 = type();
            	followingStackPointer_--;
            	
            	stream_type.Add(type83.Tree);
            	
            	// AST REWRITE
            	// elements:          type, identifier
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 271:34: -> ^( SELECTION_TYPE[$a] identifier type )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:271:36: ^( SELECTION_TYPE[$a] identifier type )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SELECTION_TYPE, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_identifier.Next());
            	    adaptor.AddChild(root_1, stream_type.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end selectionType

    public class sizeShortConstraint_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start sizeShortConstraint
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:274:1: sizeShortConstraint : a= SIZE constraint -> ^( SIMPLIFIED_SIZE_CONSTRAINT[$a] constraint ) ;
    public sizeShortConstraint_return sizeShortConstraint() // throws RecognitionException [1]
    {   
        sizeShortConstraint_return retval = new sizeShortConstraint_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        constraint_return constraint84 = null;
        
        
        object a_tree=null;
        RewriteRuleTokenStream stream_SIZE = new RewriteRuleTokenStream(adaptor,"token SIZE");
        RewriteRuleSubtreeStream stream_constraint = new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:275:2: (a= SIZE constraint -> ^( SIMPLIFIED_SIZE_CONSTRAINT[$a] constraint ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:275:4: a= SIZE constraint
            {
            	a = (IToken)input.LT(1);
            	Match(input,SIZE,FOLLOW_SIZE_in_sizeShortConstraint1436); 
            	stream_SIZE.Add(a);

            	PushFollow(FOLLOW_constraint_in_sizeShortConstraint1438);
            	constraint84 = constraint();
            	followingStackPointer_--;
            	
            	stream_constraint.Add(constraint84.Tree);
            	
            	// AST REWRITE
            	// elements:          constraint
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 275:31: -> ^( SIMPLIFIED_SIZE_CONSTRAINT[$a] constraint )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:275:34: ^( SIMPLIFIED_SIZE_CONSTRAINT[$a] constraint )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SIMPLIFIED_SIZE_CONSTRAINT, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_constraint.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end sizeShortConstraint

    public class nULL_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start nULL
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:278:1: nULL : NULL ;
    public nULL_return nULL() // throws RecognitionException [1]
    {   
        nULL_return retval = new nULL_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken NULL85 = null;
        
        object NULL85_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:278:5: ( NULL )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:278:7: NULL
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	NULL85 = (IToken)input.LT(1);
            	Match(input,NULL,FOLLOW_NULL_in_nULL1465); 
            	NULL85_tree = (object)adaptor.Create(NULL85);
            	adaptor.AddChild(root_0, NULL85_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end nULL

    public class bitStringType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start bitStringType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:280:1: bitStringType : a= BIT STRING ( L_BRACKET ( bitStringItem ( COMMA bitStringItem )* )? R_BRACKET )? -> ^( BIT_STRING_TYPE[$a] ( bitStringItem )* ) ;
    public bitStringType_return bitStringType() // throws RecognitionException [1]
    {   
        bitStringType_return retval = new bitStringType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken STRING86 = null;
        IToken L_BRACKET87 = null;
        IToken COMMA89 = null;
        IToken R_BRACKET91 = null;
        bitStringItem_return bitStringItem88 = null;

        bitStringItem_return bitStringItem90 = null;
        
        
        object a_tree=null;
        object STRING86_tree=null;
        object L_BRACKET87_tree=null;
        object COMMA89_tree=null;
        object R_BRACKET91_tree=null;
        RewriteRuleTokenStream stream_BIT = new RewriteRuleTokenStream(adaptor,"token BIT");
        RewriteRuleTokenStream stream_L_BRACKET = new RewriteRuleTokenStream(adaptor,"token L_BRACKET");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_R_BRACKET = new RewriteRuleTokenStream(adaptor,"token R_BRACKET");
        RewriteRuleTokenStream stream_STRING = new RewriteRuleTokenStream(adaptor,"token STRING");
        RewriteRuleSubtreeStream stream_bitStringItem = new RewriteRuleSubtreeStream(adaptor,"rule bitStringItem");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:2: (a= BIT STRING ( L_BRACKET ( bitStringItem ( COMMA bitStringItem )* )? R_BRACKET )? -> ^( BIT_STRING_TYPE[$a] ( bitStringItem )* ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:4: a= BIT STRING ( L_BRACKET ( bitStringItem ( COMMA bitStringItem )* )? R_BRACKET )?
            {
            	a = (IToken)input.LT(1);
            	Match(input,BIT,FOLLOW_BIT_in_bitStringType1476); 
            	stream_BIT.Add(a);

            	STRING86 = (IToken)input.LT(1);
            	Match(input,STRING,FOLLOW_STRING_in_bitStringType1478); 
            	stream_STRING.Add(STRING86);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:17: ( L_BRACKET ( bitStringItem ( COMMA bitStringItem )* )? R_BRACKET )?
            	int alt40 = 2;
            	int LA40_0 = input.LA(1);
            	
            	if ( (LA40_0 == L_BRACKET) )
            	{
            	    alt40 = 1;
            	}
            	switch (alt40) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:18: L_BRACKET ( bitStringItem ( COMMA bitStringItem )* )? R_BRACKET
            	        {
            	        	L_BRACKET87 = (IToken)input.LT(1);
            	        	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_bitStringType1481); 
            	        	stream_L_BRACKET.Add(L_BRACKET87);

            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:28: ( bitStringItem ( COMMA bitStringItem )* )?
            	        	int alt39 = 2;
            	        	int LA39_0 = input.LA(1);
            	        	
            	        	if ( (LA39_0 == LID) )
            	        	{
            	        	    alt39 = 1;
            	        	}
            	        	switch (alt39) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:29: bitStringItem ( COMMA bitStringItem )*
            	        	        {
            	        	        	PushFollow(FOLLOW_bitStringItem_in_bitStringType1484);
            	        	        	bitStringItem88 = bitStringItem();
            	        	        	followingStackPointer_--;
            	        	        	
            	        	        	stream_bitStringItem.Add(bitStringItem88.Tree);
            	        	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:43: ( COMMA bitStringItem )*
            	        	        	do 
            	        	        	{
            	        	        	    int alt38 = 2;
            	        	        	    int LA38_0 = input.LA(1);
            	        	        	    
            	        	        	    if ( (LA38_0 == COMMA) )
            	        	        	    {
            	        	        	        alt38 = 1;
            	        	        	    }
            	        	        	    
            	        	        	
            	        	        	    switch (alt38) 
            	        	        		{
            	        	        			case 1 :
            	        	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:44: COMMA bitStringItem
            	        	        			    {
            	        	        			    	COMMA89 = (IToken)input.LT(1);
            	        	        			    	Match(input,COMMA,FOLLOW_COMMA_in_bitStringType1487); 
            	        	        			    	stream_COMMA.Add(COMMA89);

            	        	        			    	PushFollow(FOLLOW_bitStringItem_in_bitStringType1489);
            	        	        			    	bitStringItem90 = bitStringItem();
            	        	        			    	followingStackPointer_--;
            	        	        			    	
            	        	        			    	stream_bitStringItem.Add(bitStringItem90.Tree);
            	        	        			    
            	        	        			    }
            	        	        			    break;
            	        	        	
            	        	        			default:
            	        	        			    goto loop38;
            	        	        	    }
            	        	        	} while (true);
            	        	        	
            	        	        	loop38:
            	        	        		;	// Stops C# compiler whinging that label 'loop38' has no statements

            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        	R_BRACKET91 = (IToken)input.LT(1);
            	        	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_bitStringType1497); 
            	        	stream_R_BRACKET.Add(R_BRACKET91);

            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          bitStringItem
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 281:83: -> ^( BIT_STRING_TYPE[$a] ( bitStringItem )* )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:86: ^( BIT_STRING_TYPE[$a] ( bitStringItem )* )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(BIT_STRING_TYPE, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:281:108: ( bitStringItem )*
            	    while ( stream_bitStringItem.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_bitStringItem.Next());
            	    
            	    }
            	    stream_bitStringItem.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end bitStringType

    public class bitStringItem_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start bitStringItem
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:284:1: bitStringItem : identifier a= L_PAREN ( INT | valuereference ) R_PAREN -> ^( NUMBER_LST_ITEM[$a] identifier ( INT )? ( valuereference )? ) ;
    public bitStringItem_return bitStringItem() // throws RecognitionException [1]
    {   
        bitStringItem_return retval = new bitStringItem_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken INT93 = null;
        IToken R_PAREN95 = null;
        identifier_return identifier92 = null;

        valuereference_return valuereference94 = null;
        
        
        object a_tree=null;
        object INT93_tree=null;
        object R_PAREN95_tree=null;
        RewriteRuleTokenStream stream_INT = new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_R_PAREN = new RewriteRuleTokenStream(adaptor,"token R_PAREN");
        RewriteRuleTokenStream stream_L_PAREN = new RewriteRuleTokenStream(adaptor,"token L_PAREN");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:285:2: ( identifier a= L_PAREN ( INT | valuereference ) R_PAREN -> ^( NUMBER_LST_ITEM[$a] identifier ( INT )? ( valuereference )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:285:4: identifier a= L_PAREN ( INT | valuereference ) R_PAREN
            {
            	PushFollow(FOLLOW_identifier_in_bitStringItem1522);
            	identifier92 = identifier();
            	followingStackPointer_--;
            	
            	stream_identifier.Add(identifier92.Tree);
            	a = (IToken)input.LT(1);
            	Match(input,L_PAREN,FOLLOW_L_PAREN_in_bitStringItem1526); 
            	stream_L_PAREN.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:285:25: ( INT | valuereference )
            	int alt41 = 2;
            	int LA41_0 = input.LA(1);
            	
            	if ( (LA41_0 == INT) )
            	{
            	    alt41 = 1;
            	}
            	else if ( (LA41_0 == LID) )
            	{
            	    alt41 = 2;
            	}
            	else 
            	{
            	    NoViableAltException nvae_d41s0 =
            	        new NoViableAltException("285:25: ( INT | valuereference )", 41, 0, input);
            	
            	    throw nvae_d41s0;
            	}
            	switch (alt41) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:285:26: INT
            	        {
            	        	INT93 = (IToken)input.LT(1);
            	        	Match(input,INT,FOLLOW_INT_in_bitStringItem1529); 
            	        	stream_INT.Add(INT93);

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:285:30: valuereference
            	        {
            	        	PushFollow(FOLLOW_valuereference_in_bitStringItem1531);
            	        	valuereference94 = valuereference();
            	        	followingStackPointer_--;
            	        	
            	        	stream_valuereference.Add(valuereference94.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	R_PAREN95 = (IToken)input.LT(1);
            	Match(input,R_PAREN,FOLLOW_R_PAREN_in_bitStringItem1534); 
            	stream_R_PAREN.Add(R_PAREN95);

            	
            	// AST REWRITE
            	// elements:          INT, valuereference, identifier
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 285:55: -> ^( NUMBER_LST_ITEM[$a] identifier ( INT )? ( valuereference )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:285:59: ^( NUMBER_LST_ITEM[$a] identifier ( INT )? ( valuereference )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(NUMBER_LST_ITEM, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_identifier.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:285:92: ( INT )?
            	    if ( stream_INT.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_INT.Next());
            	    
            	    }
            	    stream_INT.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:285:97: ( valuereference )?
            	    if ( stream_valuereference.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_valuereference.Next());
            	    
            	    }
            	    stream_valuereference.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end bitStringItem

    public class booleanType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start booleanType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:288:1: booleanType : BOOLEAN ;
    public booleanType_return booleanType() // throws RecognitionException [1]
    {   
        booleanType_return retval = new booleanType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken BOOLEAN96 = null;
        
        object BOOLEAN96_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:289:2: ( BOOLEAN )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:289:4: BOOLEAN
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	BOOLEAN96 = (IToken)input.LT(1);
            	Match(input,BOOLEAN,FOLLOW_BOOLEAN_in_booleanType1564); 
            	BOOLEAN96_tree = (object)adaptor.Create(BOOLEAN96);
            	adaptor.AddChild(root_0, BOOLEAN96_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end booleanType

    public class enumeratedType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start enumeratedType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:292:1: enumeratedType : a= ENUMERATED L_BRACKET en1= enumeratedTypeItems ( COMMA ext= EXT_MARK ( exceptionSpec )? ( COMMA en2= enumeratedTypeItems )? )? R_BRACKET -> ^( ENUMERATED_TYPE[$a] $en1 ( $ext ( exceptionSpec )? ( $en2)? )? ) ;
    public enumeratedType_return enumeratedType() // throws RecognitionException [1]
    {   
        enumeratedType_return retval = new enumeratedType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken ext = null;
        IToken L_BRACKET97 = null;
        IToken COMMA98 = null;
        IToken COMMA100 = null;
        IToken R_BRACKET101 = null;
        enumeratedTypeItems_return en1 = null;

        enumeratedTypeItems_return en2 = null;

        exceptionSpec_return exceptionSpec99 = null;
        
        
        object a_tree=null;
        object ext_tree=null;
        object L_BRACKET97_tree=null;
        object COMMA98_tree=null;
        object COMMA100_tree=null;
        object R_BRACKET101_tree=null;
        RewriteRuleTokenStream stream_ENUMERATED = new RewriteRuleTokenStream(adaptor,"token ENUMERATED");
        RewriteRuleTokenStream stream_EXT_MARK = new RewriteRuleTokenStream(adaptor,"token EXT_MARK");
        RewriteRuleTokenStream stream_L_BRACKET = new RewriteRuleTokenStream(adaptor,"token L_BRACKET");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_R_BRACKET = new RewriteRuleTokenStream(adaptor,"token R_BRACKET");
        RewriteRuleSubtreeStream stream_enumeratedTypeItems = new RewriteRuleSubtreeStream(adaptor,"rule enumeratedTypeItems");
        RewriteRuleSubtreeStream stream_exceptionSpec = new RewriteRuleSubtreeStream(adaptor,"rule exceptionSpec");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:293:2: (a= ENUMERATED L_BRACKET en1= enumeratedTypeItems ( COMMA ext= EXT_MARK ( exceptionSpec )? ( COMMA en2= enumeratedTypeItems )? )? R_BRACKET -> ^( ENUMERATED_TYPE[$a] $en1 ( $ext ( exceptionSpec )? ( $en2)? )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:293:4: a= ENUMERATED L_BRACKET en1= enumeratedTypeItems ( COMMA ext= EXT_MARK ( exceptionSpec )? ( COMMA en2= enumeratedTypeItems )? )? R_BRACKET
            {
            	a = (IToken)input.LT(1);
            	Match(input,ENUMERATED,FOLLOW_ENUMERATED_in_enumeratedType1579); 
            	stream_ENUMERATED.Add(a);

            	L_BRACKET97 = (IToken)input.LT(1);
            	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_enumeratedType1581); 
            	stream_L_BRACKET.Add(L_BRACKET97);

            	PushFollow(FOLLOW_enumeratedTypeItems_in_enumeratedType1585);
            	en1 = enumeratedTypeItems();
            	followingStackPointer_--;
            	
            	stream_enumeratedTypeItems.Add(en1.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:293:52: ( COMMA ext= EXT_MARK ( exceptionSpec )? ( COMMA en2= enumeratedTypeItems )? )?
            	int alt44 = 2;
            	int LA44_0 = input.LA(1);
            	
            	if ( (LA44_0 == COMMA) )
            	{
            	    alt44 = 1;
            	}
            	switch (alt44) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:293:54: COMMA ext= EXT_MARK ( exceptionSpec )? ( COMMA en2= enumeratedTypeItems )?
            	        {
            	        	COMMA98 = (IToken)input.LT(1);
            	        	Match(input,COMMA,FOLLOW_COMMA_in_enumeratedType1590); 
            	        	stream_COMMA.Add(COMMA98);

            	        	ext = (IToken)input.LT(1);
            	        	Match(input,EXT_MARK,FOLLOW_EXT_MARK_in_enumeratedType1594); 
            	        	stream_EXT_MARK.Add(ext);

            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:293:73: ( exceptionSpec )?
            	        	int alt42 = 2;
            	        	int LA42_0 = input.LA(1);
            	        	
            	        	if ( (LA42_0 == 169) )
            	        	{
            	        	    alt42 = 1;
            	        	}
            	        	switch (alt42) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:293:73: exceptionSpec
            	        	        {
            	        	        	PushFollow(FOLLOW_exceptionSpec_in_enumeratedType1596);
            	        	        	exceptionSpec99 = exceptionSpec();
            	        	        	followingStackPointer_--;
            	        	        	
            	        	        	stream_exceptionSpec.Add(exceptionSpec99.Tree);
            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:293:88: ( COMMA en2= enumeratedTypeItems )?
            	        	int alt43 = 2;
            	        	int LA43_0 = input.LA(1);
            	        	
            	        	if ( (LA43_0 == COMMA) )
            	        	{
            	        	    alt43 = 1;
            	        	}
            	        	switch (alt43) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:293:89: COMMA en2= enumeratedTypeItems
            	        	        {
            	        	        	COMMA100 = (IToken)input.LT(1);
            	        	        	Match(input,COMMA,FOLLOW_COMMA_in_enumeratedType1600); 
            	        	        	stream_COMMA.Add(COMMA100);

            	        	        	PushFollow(FOLLOW_enumeratedTypeItems_in_enumeratedType1604);
            	        	        	en2 = enumeratedTypeItems();
            	        	        	followingStackPointer_--;
            	        	        	
            	        	        	stream_enumeratedTypeItems.Add(en2.Tree);
            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        
            	        }
            	        break;
            	
            	}

            	R_BRACKET101 = (IToken)input.LT(1);
            	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_enumeratedType1611); 
            	stream_R_BRACKET.Add(R_BRACKET101);

            	
            	// AST REWRITE
            	// elements:          en2, ext, exceptionSpec, en1
            	// token labels:      ext
            	// rule labels:       retval, en1, en2
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_ext = new RewriteRuleTokenStream(adaptor, "token ext", ext);
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	RewriteRuleSubtreeStream stream_en1 = new RewriteRuleSubtreeStream(adaptor, "token en1", (en1!=null ? en1.Tree : null));
            	RewriteRuleSubtreeStream stream_en2 = new RewriteRuleSubtreeStream(adaptor, "token en2", (en2!=null ? en2.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 294:2: -> ^( ENUMERATED_TYPE[$a] $en1 ( $ext ( exceptionSpec )? ( $en2)? )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:294:5: ^( ENUMERATED_TYPE[$a] $en1 ( $ext ( exceptionSpec )? ( $en2)? )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(ENUMERATED_TYPE, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_en1.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:294:32: ( $ext ( exceptionSpec )? ( $en2)? )?
            	    if ( stream_en2.HasNext() || stream_ext.HasNext() || stream_exceptionSpec.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_ext.Next());
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:294:38: ( exceptionSpec )?
            	        if ( stream_exceptionSpec.HasNext() )
            	        {
            	            adaptor.AddChild(root_1, stream_exceptionSpec.Next());
            	        
            	        }
            	        stream_exceptionSpec.Reset();
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:294:53: ( $en2)?
            	        if ( stream_en2.HasNext() )
            	        {
            	            adaptor.AddChild(root_1, stream_en2.Next());
            	        
            	        }
            	        stream_en2.Reset();
            	    
            	    }
            	    stream_en2.Reset();
            	    stream_ext.Reset();
            	    stream_exceptionSpec.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end enumeratedType

    public class enumeratedTypeItems_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start enumeratedTypeItems
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:297:1: enumeratedTypeItems : enumeratedLstItem ( COMMA enumeratedLstItem )* -> ( enumeratedLstItem )+ ;
    public enumeratedTypeItems_return enumeratedTypeItems() // throws RecognitionException [1]
    {   
        enumeratedTypeItems_return retval = new enumeratedTypeItems_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken COMMA103 = null;
        enumeratedLstItem_return enumeratedLstItem102 = null;

        enumeratedLstItem_return enumeratedLstItem104 = null;
        
        
        object COMMA103_tree=null;
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_enumeratedLstItem = new RewriteRuleSubtreeStream(adaptor,"rule enumeratedLstItem");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:298:2: ( enumeratedLstItem ( COMMA enumeratedLstItem )* -> ( enumeratedLstItem )+ )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:298:5: enumeratedLstItem ( COMMA enumeratedLstItem )*
            {
            	PushFollow(FOLLOW_enumeratedLstItem_in_enumeratedTypeItems1649);
            	enumeratedLstItem102 = enumeratedLstItem();
            	followingStackPointer_--;
            	
            	stream_enumeratedLstItem.Add(enumeratedLstItem102.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:298:23: ( COMMA enumeratedLstItem )*
            	do 
            	{
            	    int alt45 = 2;
            	    int LA45_0 = input.LA(1);
            	    
            	    if ( (LA45_0 == COMMA) )
            	    {
            	        int LA45_1 = input.LA(2);
            	        
            	        if ( (LA45_1 == LID) )
            	        {
            	            alt45 = 1;
            	        }
            	        
            	    
            	    }
            	    
            	
            	    switch (alt45) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:298:24: COMMA enumeratedLstItem
            			    {
            			    	COMMA103 = (IToken)input.LT(1);
            			    	Match(input,COMMA,FOLLOW_COMMA_in_enumeratedTypeItems1652); 
            			    	stream_COMMA.Add(COMMA103);

            			    	PushFollow(FOLLOW_enumeratedLstItem_in_enumeratedTypeItems1654);
            			    	enumeratedLstItem104 = enumeratedLstItem();
            			    	followingStackPointer_--;
            			    	
            			    	stream_enumeratedLstItem.Add(enumeratedLstItem104.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop45;
            	    }
            	} while (true);
            	
            	loop45:
            		;	// Stops C# compiler whinging that label 'loop45' has no statements

            	
            	// AST REWRITE
            	// elements:          enumeratedLstItem
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 298:50: -> ( enumeratedLstItem )+
            	{
            	    if ( !(stream_enumeratedLstItem.HasNext()) ) {
            	        throw new RewriteEarlyExitException();
            	    }
            	    while ( stream_enumeratedLstItem.HasNext() )
            	    {
            	        adaptor.AddChild(root_0, stream_enumeratedLstItem.Next());
            	    
            	    }
            	    stream_enumeratedLstItem.Reset();
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end enumeratedTypeItems

    public class enumeratedLstItem_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start enumeratedLstItem
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:300:1: enumeratedLstItem : identifier ( L_PAREN ( INT | valuereference ) R_PAREN )? -> ^( NUMBER_LST_ITEM identifier ( INT )? ( valuereference )? ) ;
    public enumeratedLstItem_return enumeratedLstItem() // throws RecognitionException [1]
    {   
        enumeratedLstItem_return retval = new enumeratedLstItem_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken L_PAREN106 = null;
        IToken INT107 = null;
        IToken R_PAREN109 = null;
        identifier_return identifier105 = null;

        valuereference_return valuereference108 = null;
        
        
        object L_PAREN106_tree=null;
        object INT107_tree=null;
        object R_PAREN109_tree=null;
        RewriteRuleTokenStream stream_INT = new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_R_PAREN = new RewriteRuleTokenStream(adaptor,"token R_PAREN");
        RewriteRuleTokenStream stream_L_PAREN = new RewriteRuleTokenStream(adaptor,"token L_PAREN");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:300:19: ( identifier ( L_PAREN ( INT | valuereference ) R_PAREN )? -> ^( NUMBER_LST_ITEM identifier ( INT )? ( valuereference )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:2: identifier ( L_PAREN ( INT | valuereference ) R_PAREN )?
            {
            	PushFollow(FOLLOW_identifier_in_enumeratedLstItem1673);
            	identifier105 = identifier();
            	followingStackPointer_--;
            	
            	stream_identifier.Add(identifier105.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:13: ( L_PAREN ( INT | valuereference ) R_PAREN )?
            	int alt47 = 2;
            	int LA47_0 = input.LA(1);
            	
            	if ( (LA47_0 == L_PAREN) )
            	{
            	    alt47 = 1;
            	}
            	switch (alt47) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:15: L_PAREN ( INT | valuereference ) R_PAREN
            	        {
            	        	L_PAREN106 = (IToken)input.LT(1);
            	        	Match(input,L_PAREN,FOLLOW_L_PAREN_in_enumeratedLstItem1677); 
            	        	stream_L_PAREN.Add(L_PAREN106);

            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:23: ( INT | valuereference )
            	        	int alt46 = 2;
            	        	int LA46_0 = input.LA(1);
            	        	
            	        	if ( (LA46_0 == INT) )
            	        	{
            	        	    alt46 = 1;
            	        	}
            	        	else if ( (LA46_0 == LID) )
            	        	{
            	        	    alt46 = 2;
            	        	}
            	        	else 
            	        	{
            	        	    NoViableAltException nvae_d46s0 =
            	        	        new NoViableAltException("301:23: ( INT | valuereference )", 46, 0, input);
            	        	
            	        	    throw nvae_d46s0;
            	        	}
            	        	switch (alt46) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:24: INT
            	        	        {
            	        	        	INT107 = (IToken)input.LT(1);
            	        	        	Match(input,INT,FOLLOW_INT_in_enumeratedLstItem1680); 
            	        	        	stream_INT.Add(INT107);

            	        	        
            	        	        }
            	        	        break;
            	        	    case 2 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:28: valuereference
            	        	        {
            	        	        	PushFollow(FOLLOW_valuereference_in_enumeratedLstItem1682);
            	        	        	valuereference108 = valuereference();
            	        	        	followingStackPointer_--;
            	        	        	
            	        	        	stream_valuereference.Add(valuereference108.Tree);
            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        	R_PAREN109 = (IToken)input.LT(1);
            	        	Match(input,R_PAREN,FOLLOW_R_PAREN_in_enumeratedLstItem1685); 
            	        	stream_R_PAREN.Add(R_PAREN109);

            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          valuereference, identifier, INT
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 301:54: -> ^( NUMBER_LST_ITEM identifier ( INT )? ( valuereference )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:57: ^( NUMBER_LST_ITEM identifier ( INT )? ( valuereference )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(NUMBER_LST_ITEM, "NUMBER_LST_ITEM"), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_identifier.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:86: ( INT )?
            	    if ( stream_INT.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_INT.Next());
            	    
            	    }
            	    stream_INT.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:301:91: ( valuereference )?
            	    if ( stream_valuereference.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_valuereference.Next());
            	    
            	    }
            	    stream_valuereference.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end enumeratedLstItem

    public class integerType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start integerType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:303:1: integerType : a= INTEGER ( L_BRACKET ( integerTypeListItem ( COMMA integerTypeListItem )* )? R_BRACKET )? -> ^( INTEGER_TYPE[$a] ( integerTypeListItem )* ) ;
    public integerType_return integerType() // throws RecognitionException [1]
    {   
        integerType_return retval = new integerType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken L_BRACKET110 = null;
        IToken COMMA112 = null;
        IToken R_BRACKET114 = null;
        integerTypeListItem_return integerTypeListItem111 = null;

        integerTypeListItem_return integerTypeListItem113 = null;
        
        
        object a_tree=null;
        object L_BRACKET110_tree=null;
        object COMMA112_tree=null;
        object R_BRACKET114_tree=null;
        RewriteRuleTokenStream stream_INTEGER = new RewriteRuleTokenStream(adaptor,"token INTEGER");
        RewriteRuleTokenStream stream_L_BRACKET = new RewriteRuleTokenStream(adaptor,"token L_BRACKET");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_R_BRACKET = new RewriteRuleTokenStream(adaptor,"token R_BRACKET");
        RewriteRuleSubtreeStream stream_integerTypeListItem = new RewriteRuleSubtreeStream(adaptor,"rule integerTypeListItem");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:2: (a= INTEGER ( L_BRACKET ( integerTypeListItem ( COMMA integerTypeListItem )* )? R_BRACKET )? -> ^( INTEGER_TYPE[$a] ( integerTypeListItem )* ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:4: a= INTEGER ( L_BRACKET ( integerTypeListItem ( COMMA integerTypeListItem )* )? R_BRACKET )?
            {
            	a = (IToken)input.LT(1);
            	Match(input,INTEGER,FOLLOW_INTEGER_in_integerType1712); 
            	stream_INTEGER.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:14: ( L_BRACKET ( integerTypeListItem ( COMMA integerTypeListItem )* )? R_BRACKET )?
            	int alt50 = 2;
            	int LA50_0 = input.LA(1);
            	
            	if ( (LA50_0 == L_BRACKET) )
            	{
            	    alt50 = 1;
            	}
            	switch (alt50) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:16: L_BRACKET ( integerTypeListItem ( COMMA integerTypeListItem )* )? R_BRACKET
            	        {
            	        	L_BRACKET110 = (IToken)input.LT(1);
            	        	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_integerType1716); 
            	        	stream_L_BRACKET.Add(L_BRACKET110);

            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:26: ( integerTypeListItem ( COMMA integerTypeListItem )* )?
            	        	int alt49 = 2;
            	        	int LA49_0 = input.LA(1);
            	        	
            	        	if ( (LA49_0 == LID) )
            	        	{
            	        	    alt49 = 1;
            	        	}
            	        	switch (alt49) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:27: integerTypeListItem ( COMMA integerTypeListItem )*
            	        	        {
            	        	        	PushFollow(FOLLOW_integerTypeListItem_in_integerType1719);
            	        	        	integerTypeListItem111 = integerTypeListItem();
            	        	        	followingStackPointer_--;
            	        	        	
            	        	        	stream_integerTypeListItem.Add(integerTypeListItem111.Tree);
            	        	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:47: ( COMMA integerTypeListItem )*
            	        	        	do 
            	        	        	{
            	        	        	    int alt48 = 2;
            	        	        	    int LA48_0 = input.LA(1);
            	        	        	    
            	        	        	    if ( (LA48_0 == COMMA) )
            	        	        	    {
            	        	        	        alt48 = 1;
            	        	        	    }
            	        	        	    
            	        	        	
            	        	        	    switch (alt48) 
            	        	        		{
            	        	        			case 1 :
            	        	        			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:48: COMMA integerTypeListItem
            	        	        			    {
            	        	        			    	COMMA112 = (IToken)input.LT(1);
            	        	        			    	Match(input,COMMA,FOLLOW_COMMA_in_integerType1722); 
            	        	        			    	stream_COMMA.Add(COMMA112);

            	        	        			    	PushFollow(FOLLOW_integerTypeListItem_in_integerType1724);
            	        	        			    	integerTypeListItem113 = integerTypeListItem();
            	        	        			    	followingStackPointer_--;
            	        	        			    	
            	        	        			    	stream_integerTypeListItem.Add(integerTypeListItem113.Tree);
            	        	        			    
            	        	        			    }
            	        	        			    break;
            	        	        	
            	        	        			default:
            	        	        			    goto loop48;
            	        	        	    }
            	        	        	} while (true);
            	        	        	
            	        	        	loop48:
            	        	        		;	// Stops C# compiler whinging that label 'loop48' has no statements

            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        	R_BRACKET114 = (IToken)input.LT(1);
            	        	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_integerType1730); 
            	        	stream_R_BRACKET.Add(R_BRACKET114);

            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          integerTypeListItem
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 304:90: -> ^( INTEGER_TYPE[$a] ( integerTypeListItem )* )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:93: ^( INTEGER_TYPE[$a] ( integerTypeListItem )* )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(INTEGER_TYPE, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:304:112: ( integerTypeListItem )*
            	    while ( stream_integerTypeListItem.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_integerTypeListItem.Next());
            	    
            	    }
            	    stream_integerTypeListItem.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end integerType

    public class integerTypeListItem_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start integerTypeListItem
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:307:1: integerTypeListItem : identifier a= L_PAREN ( INT | valuereference ) R_PAREN -> ^( NUMBER_LST_ITEM[$a] identifier ( INT )? ( valuereference )? ) ;
    public integerTypeListItem_return integerTypeListItem() // throws RecognitionException [1]
    {   
        integerTypeListItem_return retval = new integerTypeListItem_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken INT116 = null;
        IToken R_PAREN118 = null;
        identifier_return identifier115 = null;

        valuereference_return valuereference117 = null;
        
        
        object a_tree=null;
        object INT116_tree=null;
        object R_PAREN118_tree=null;
        RewriteRuleTokenStream stream_INT = new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_R_PAREN = new RewriteRuleTokenStream(adaptor,"token R_PAREN");
        RewriteRuleTokenStream stream_L_PAREN = new RewriteRuleTokenStream(adaptor,"token L_PAREN");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:308:2: ( identifier a= L_PAREN ( INT | valuereference ) R_PAREN -> ^( NUMBER_LST_ITEM[$a] identifier ( INT )? ( valuereference )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:308:4: identifier a= L_PAREN ( INT | valuereference ) R_PAREN
            {
            	PushFollow(FOLLOW_identifier_in_integerTypeListItem1755);
            	identifier115 = identifier();
            	followingStackPointer_--;
            	
            	stream_identifier.Add(identifier115.Tree);
            	a = (IToken)input.LT(1);
            	Match(input,L_PAREN,FOLLOW_L_PAREN_in_integerTypeListItem1759); 
            	stream_L_PAREN.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:308:25: ( INT | valuereference )
            	int alt51 = 2;
            	int LA51_0 = input.LA(1);
            	
            	if ( (LA51_0 == INT) )
            	{
            	    alt51 = 1;
            	}
            	else if ( (LA51_0 == LID) )
            	{
            	    alt51 = 2;
            	}
            	else 
            	{
            	    NoViableAltException nvae_d51s0 =
            	        new NoViableAltException("308:25: ( INT | valuereference )", 51, 0, input);
            	
            	    throw nvae_d51s0;
            	}
            	switch (alt51) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:308:26: INT
            	        {
            	        	INT116 = (IToken)input.LT(1);
            	        	Match(input,INT,FOLLOW_INT_in_integerTypeListItem1762); 
            	        	stream_INT.Add(INT116);

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:308:30: valuereference
            	        {
            	        	PushFollow(FOLLOW_valuereference_in_integerTypeListItem1764);
            	        	valuereference117 = valuereference();
            	        	followingStackPointer_--;
            	        	
            	        	stream_valuereference.Add(valuereference117.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	R_PAREN118 = (IToken)input.LT(1);
            	Match(input,R_PAREN,FOLLOW_R_PAREN_in_integerTypeListItem1767); 
            	stream_R_PAREN.Add(R_PAREN118);

            	
            	// AST REWRITE
            	// elements:          valuereference, INT, identifier
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 308:54: -> ^( NUMBER_LST_ITEM[$a] identifier ( INT )? ( valuereference )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:308:57: ^( NUMBER_LST_ITEM[$a] identifier ( INT )? ( valuereference )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(NUMBER_LST_ITEM, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_identifier.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:308:90: ( INT )?
            	    if ( stream_INT.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_INT.Next());
            	    
            	    }
            	    stream_INT.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:308:95: ( valuereference )?
            	    if ( stream_valuereference.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_valuereference.Next());
            	    
            	    }
            	    stream_valuereference.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end integerTypeListItem

    public class realType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start realType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:311:1: realType : REAL ;
    public realType_return realType() // throws RecognitionException [1]
    {   
        realType_return retval = new realType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken REAL119 = null;
        
        object REAL119_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:312:2: ( REAL )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:312:4: REAL
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	REAL119 = (IToken)input.LT(1);
            	Match(input,REAL,FOLLOW_REAL_in_realType1796); 
            	REAL119_tree = (object)adaptor.Create(REAL119);
            	adaptor.AddChild(root_0, REAL119_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end realType

    public class choiceType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start choiceType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:316:1: choiceType : a= CHOICE L_BRACKET choiceItemsList ( choiceExtensionBody )? R_BRACKET -> ^( CHOICE_TYPE[$a] choiceItemsList ( choiceExtensionBody )? ) ;
    public choiceType_return choiceType() // throws RecognitionException [1]
    {   
        choiceType_return retval = new choiceType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken L_BRACKET120 = null;
        IToken R_BRACKET123 = null;
        choiceItemsList_return choiceItemsList121 = null;

        choiceExtensionBody_return choiceExtensionBody122 = null;
        
        
        object a_tree=null;
        object L_BRACKET120_tree=null;
        object R_BRACKET123_tree=null;
        RewriteRuleTokenStream stream_L_BRACKET = new RewriteRuleTokenStream(adaptor,"token L_BRACKET");
        RewriteRuleTokenStream stream_R_BRACKET = new RewriteRuleTokenStream(adaptor,"token R_BRACKET");
        RewriteRuleTokenStream stream_CHOICE = new RewriteRuleTokenStream(adaptor,"token CHOICE");
        RewriteRuleSubtreeStream stream_choiceItemsList = new RewriteRuleSubtreeStream(adaptor,"rule choiceItemsList");
        RewriteRuleSubtreeStream stream_choiceExtensionBody = new RewriteRuleSubtreeStream(adaptor,"rule choiceExtensionBody");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:317:2: (a= CHOICE L_BRACKET choiceItemsList ( choiceExtensionBody )? R_BRACKET -> ^( CHOICE_TYPE[$a] choiceItemsList ( choiceExtensionBody )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:317:4: a= CHOICE L_BRACKET choiceItemsList ( choiceExtensionBody )? R_BRACKET
            {
            	a = (IToken)input.LT(1);
            	Match(input,CHOICE,FOLLOW_CHOICE_in_choiceType1812); 
            	stream_CHOICE.Add(a);

            	L_BRACKET120 = (IToken)input.LT(1);
            	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_choiceType1814); 
            	stream_L_BRACKET.Add(L_BRACKET120);

            	PushFollow(FOLLOW_choiceItemsList_in_choiceType1816);
            	choiceItemsList121 = choiceItemsList();
            	followingStackPointer_--;
            	
            	stream_choiceItemsList.Add(choiceItemsList121.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:317:39: ( choiceExtensionBody )?
            	int alt52 = 2;
            	int LA52_0 = input.LA(1);
            	
            	if ( (LA52_0 == COMMA) )
            	{
            	    alt52 = 1;
            	}
            	switch (alt52) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:317:39: choiceExtensionBody
            	        {
            	        	PushFollow(FOLLOW_choiceExtensionBody_in_choiceType1818);
            	        	choiceExtensionBody122 = choiceExtensionBody();
            	        	followingStackPointer_--;
            	        	
            	        	stream_choiceExtensionBody.Add(choiceExtensionBody122.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	R_BRACKET123 = (IToken)input.LT(1);
            	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_choiceType1821); 
            	stream_R_BRACKET.Add(R_BRACKET123);

            	
            	// AST REWRITE
            	// elements:          choiceExtensionBody, choiceItemsList
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 318:2: -> ^( CHOICE_TYPE[$a] choiceItemsList ( choiceExtensionBody )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:318:5: ^( CHOICE_TYPE[$a] choiceItemsList ( choiceExtensionBody )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(CHOICE_TYPE, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_choiceItemsList.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:318:39: ( choiceExtensionBody )?
            	    if ( stream_choiceExtensionBody.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_choiceExtensionBody.Next());
            	    
            	    }
            	    stream_choiceExtensionBody.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end choiceType

    public class choiceExtensionBody_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start choiceExtensionBody
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:321:1: choiceExtensionBody : COMMA a= EXT_MARK ( exceptionSpec )? ( choiceListExtension )? ( COMMA extMark2= EXT_MARK )? -> ^( CHOICE_EXT_BODY[$a] ( exceptionSpec )? ( choiceListExtension )? ( $extMark2)? ) ;
    public choiceExtensionBody_return choiceExtensionBody() // throws RecognitionException [1]
    {   
        choiceExtensionBody_return retval = new choiceExtensionBody_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken extMark2 = null;
        IToken COMMA124 = null;
        IToken COMMA127 = null;
        exceptionSpec_return exceptionSpec125 = null;

        choiceListExtension_return choiceListExtension126 = null;
        
        
        object a_tree=null;
        object extMark2_tree=null;
        object COMMA124_tree=null;
        object COMMA127_tree=null;
        RewriteRuleTokenStream stream_EXT_MARK = new RewriteRuleTokenStream(adaptor,"token EXT_MARK");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_choiceListExtension = new RewriteRuleSubtreeStream(adaptor,"rule choiceListExtension");
        RewriteRuleSubtreeStream stream_exceptionSpec = new RewriteRuleSubtreeStream(adaptor,"rule exceptionSpec");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:322:2: ( COMMA a= EXT_MARK ( exceptionSpec )? ( choiceListExtension )? ( COMMA extMark2= EXT_MARK )? -> ^( CHOICE_EXT_BODY[$a] ( exceptionSpec )? ( choiceListExtension )? ( $extMark2)? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:322:4: COMMA a= EXT_MARK ( exceptionSpec )? ( choiceListExtension )? ( COMMA extMark2= EXT_MARK )?
            {
            	COMMA124 = (IToken)input.LT(1);
            	Match(input,COMMA,FOLLOW_COMMA_in_choiceExtensionBody1846); 
            	stream_COMMA.Add(COMMA124);

            	a = (IToken)input.LT(1);
            	Match(input,EXT_MARK,FOLLOW_EXT_MARK_in_choiceExtensionBody1850); 
            	stream_EXT_MARK.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:322:21: ( exceptionSpec )?
            	int alt53 = 2;
            	int LA53_0 = input.LA(1);
            	
            	if ( (LA53_0 == 169) )
            	{
            	    alt53 = 1;
            	}
            	switch (alt53) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:322:21: exceptionSpec
            	        {
            	        	PushFollow(FOLLOW_exceptionSpec_in_choiceExtensionBody1852);
            	        	exceptionSpec125 = exceptionSpec();
            	        	followingStackPointer_--;
            	        	
            	        	stream_exceptionSpec.Add(exceptionSpec125.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:322:37: ( choiceListExtension )?
            	int alt54 = 2;
            	int LA54_0 = input.LA(1);
            	
            	if ( (LA54_0 == COMMA) )
            	{
            	    int LA54_1 = input.LA(2);
            	    
            	    if ( (LA54_1 == LID || LA54_1 == 166) )
            	    {
            	        alt54 = 1;
            	    }
            	}
            	switch (alt54) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:322:37: choiceListExtension
            	        {
            	        	PushFollow(FOLLOW_choiceListExtension_in_choiceExtensionBody1856);
            	        	choiceListExtension126 = choiceListExtension();
            	        	followingStackPointer_--;
            	        	
            	        	stream_choiceListExtension.Add(choiceListExtension126.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:322:60: ( COMMA extMark2= EXT_MARK )?
            	int alt55 = 2;
            	int LA55_0 = input.LA(1);
            	
            	if ( (LA55_0 == COMMA) )
            	{
            	    alt55 = 1;
            	}
            	switch (alt55) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:322:61: COMMA extMark2= EXT_MARK
            	        {
            	        	COMMA127 = (IToken)input.LT(1);
            	        	Match(input,COMMA,FOLLOW_COMMA_in_choiceExtensionBody1862); 
            	        	stream_COMMA.Add(COMMA127);

            	        	extMark2 = (IToken)input.LT(1);
            	        	Match(input,EXT_MARK,FOLLOW_EXT_MARK_in_choiceExtensionBody1866); 
            	        	stream_EXT_MARK.Add(extMark2);

            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          exceptionSpec, extMark2, choiceListExtension
            	// token labels:      extMark2
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_extMark2 = new RewriteRuleTokenStream(adaptor, "token extMark2", extMark2);
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 323:3: -> ^( CHOICE_EXT_BODY[$a] ( exceptionSpec )? ( choiceListExtension )? ( $extMark2)? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:323:6: ^( CHOICE_EXT_BODY[$a] ( exceptionSpec )? ( choiceListExtension )? ( $extMark2)? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(CHOICE_EXT_BODY, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:323:28: ( exceptionSpec )?
            	    if ( stream_exceptionSpec.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_exceptionSpec.Next());
            	    
            	    }
            	    stream_exceptionSpec.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:323:43: ( choiceListExtension )?
            	    if ( stream_choiceListExtension.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_choiceListExtension.Next());
            	    
            	    }
            	    stream_choiceListExtension.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:323:64: ( $extMark2)?
            	    if ( stream_extMark2.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_extMark2.Next());
            	    
            	    }
            	    stream_extMark2.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end choiceExtensionBody

    public class choiceItemsList_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start choiceItemsList
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:326:1: choiceItemsList : choiceItem ( COMMA choiceItem )* -> ( choiceItem )+ ;
    public choiceItemsList_return choiceItemsList() // throws RecognitionException [1]
    {   
        choiceItemsList_return retval = new choiceItemsList_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken COMMA129 = null;
        choiceItem_return choiceItem128 = null;

        choiceItem_return choiceItem130 = null;
        
        
        object COMMA129_tree=null;
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_choiceItem = new RewriteRuleSubtreeStream(adaptor,"rule choiceItem");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:327:2: ( choiceItem ( COMMA choiceItem )* -> ( choiceItem )+ )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:327:4: choiceItem ( COMMA choiceItem )*
            {
            	PushFollow(FOLLOW_choiceItem_in_choiceItemsList1901);
            	choiceItem128 = choiceItem();
            	followingStackPointer_--;
            	
            	stream_choiceItem.Add(choiceItem128.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:327:15: ( COMMA choiceItem )*
            	do 
            	{
            	    int alt56 = 2;
            	    int LA56_0 = input.LA(1);
            	    
            	    if ( (LA56_0 == COMMA) )
            	    {
            	        int LA56_1 = input.LA(2);
            	        
            	        if ( (LA56_1 == LID) )
            	        {
            	            alt56 = 1;
            	        }
            	        
            	    
            	    }
            	    
            	
            	    switch (alt56) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:327:16: COMMA choiceItem
            			    {
            			    	COMMA129 = (IToken)input.LT(1);
            			    	Match(input,COMMA,FOLLOW_COMMA_in_choiceItemsList1904); 
            			    	stream_COMMA.Add(COMMA129);

            			    	PushFollow(FOLLOW_choiceItem_in_choiceItemsList1906);
            			    	choiceItem130 = choiceItem();
            			    	followingStackPointer_--;
            			    	
            			    	stream_choiceItem.Add(choiceItem130.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop56;
            	    }
            	} while (true);
            	
            	loop56:
            		;	// Stops C# compiler whinging that label 'loop56' has no statements

            	
            	// AST REWRITE
            	// elements:          choiceItem
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 327:35: -> ( choiceItem )+
            	{
            	    if ( !(stream_choiceItem.HasNext()) ) {
            	        throw new RewriteEarlyExitException();
            	    }
            	    while ( stream_choiceItem.HasNext() )
            	    {
            	        adaptor.AddChild(root_0, stream_choiceItem.Next());
            	    
            	    }
            	    stream_choiceItem.Reset();
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end choiceItemsList

    public class choiceItem_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start choiceItem
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:330:1: choiceItem : identifier type -> ^( CHOICE_ITEM identifier type ) ;
    public choiceItem_return choiceItem() // throws RecognitionException [1]
    {   
        choiceItem_return retval = new choiceItem_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        identifier_return identifier131 = null;

        type_return type132 = null;
        
        
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:331:2: ( identifier type -> ^( CHOICE_ITEM identifier type ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:331:4: identifier type
            {
            	PushFollow(FOLLOW_identifier_in_choiceItem1925);
            	identifier131 = identifier();
            	followingStackPointer_--;
            	
            	stream_identifier.Add(identifier131.Tree);
            	PushFollow(FOLLOW_type_in_choiceItem1927);
            	type132 = type();
            	followingStackPointer_--;
            	
            	stream_type.Add(type132.Tree);
            	
            	// AST REWRITE
            	// elements:          identifier, type
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 331:23: -> ^( CHOICE_ITEM identifier type )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:331:27: ^( CHOICE_ITEM identifier type )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(CHOICE_ITEM, "CHOICE_ITEM"), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_identifier.Next());
            	    adaptor.AddChild(root_1, stream_type.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end choiceItem

    public class choiceListExtension_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start choiceListExtension
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:334:1: choiceListExtension : COMMA extensionAdditionAlternative ( COMMA extensionAdditionAlternative )* -> ( extensionAdditionAlternative )+ ;
    public choiceListExtension_return choiceListExtension() // throws RecognitionException [1]
    {   
        choiceListExtension_return retval = new choiceListExtension_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken COMMA133 = null;
        IToken COMMA135 = null;
        extensionAdditionAlternative_return extensionAdditionAlternative134 = null;

        extensionAdditionAlternative_return extensionAdditionAlternative136 = null;
        
        
        object COMMA133_tree=null;
        object COMMA135_tree=null;
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_extensionAdditionAlternative = new RewriteRuleSubtreeStream(adaptor,"rule extensionAdditionAlternative");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:335:2: ( COMMA extensionAdditionAlternative ( COMMA extensionAdditionAlternative )* -> ( extensionAdditionAlternative )+ )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:335:4: COMMA extensionAdditionAlternative ( COMMA extensionAdditionAlternative )*
            {
            	COMMA133 = (IToken)input.LT(1);
            	Match(input,COMMA,FOLLOW_COMMA_in_choiceListExtension1954); 
            	stream_COMMA.Add(COMMA133);

            	PushFollow(FOLLOW_extensionAdditionAlternative_in_choiceListExtension1956);
            	extensionAdditionAlternative134 = extensionAdditionAlternative();
            	followingStackPointer_--;
            	
            	stream_extensionAdditionAlternative.Add(extensionAdditionAlternative134.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:335:39: ( COMMA extensionAdditionAlternative )*
            	do 
            	{
            	    int alt57 = 2;
            	    int LA57_0 = input.LA(1);
            	    
            	    if ( (LA57_0 == COMMA) )
            	    {
            	        int LA57_1 = input.LA(2);
            	        
            	        if ( (LA57_1 == LID || LA57_1 == 166) )
            	        {
            	            alt57 = 1;
            	        }
            	        
            	    
            	    }
            	    
            	
            	    switch (alt57) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:335:40: COMMA extensionAdditionAlternative
            			    {
            			    	COMMA135 = (IToken)input.LT(1);
            			    	Match(input,COMMA,FOLLOW_COMMA_in_choiceListExtension1959); 
            			    	stream_COMMA.Add(COMMA135);

            			    	PushFollow(FOLLOW_extensionAdditionAlternative_in_choiceListExtension1961);
            			    	extensionAdditionAlternative136 = extensionAdditionAlternative();
            			    	followingStackPointer_--;
            			    	
            			    	stream_extensionAdditionAlternative.Add(extensionAdditionAlternative136.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop57;
            	    }
            	} while (true);
            	
            	loop57:
            		;	// Stops C# compiler whinging that label 'loop57' has no statements

            	
            	// AST REWRITE
            	// elements:          extensionAdditionAlternative
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 335:77: -> ( extensionAdditionAlternative )+
            	{
            	    if ( !(stream_extensionAdditionAlternative.HasNext()) ) {
            	        throw new RewriteEarlyExitException();
            	    }
            	    while ( stream_extensionAdditionAlternative.HasNext() )
            	    {
            	        adaptor.AddChild(root_0, stream_extensionAdditionAlternative.Next());
            	    
            	    }
            	    stream_extensionAdditionAlternative.Reset();
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end choiceListExtension

    public class extensionAdditionAlternative_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start extensionAdditionAlternative
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:338:1: extensionAdditionAlternative : (a= '[[' ( versionNumber )? choiceItemsList ']]' -> ^( CHOICE_EXT_ITEM[$a] ( versionNumber )? choiceItemsList ) | choiceItem );
    public extensionAdditionAlternative_return extensionAdditionAlternative() // throws RecognitionException [1]
    {   
        extensionAdditionAlternative_return retval = new extensionAdditionAlternative_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken string_literal139 = null;
        versionNumber_return versionNumber137 = null;

        choiceItemsList_return choiceItemsList138 = null;

        choiceItem_return choiceItem140 = null;
        
        
        object a_tree=null;
        object string_literal139_tree=null;
        RewriteRuleTokenStream stream_166 = new RewriteRuleTokenStream(adaptor,"token 166");
        RewriteRuleTokenStream stream_167 = new RewriteRuleTokenStream(adaptor,"token 167");
        RewriteRuleSubtreeStream stream_choiceItemsList = new RewriteRuleSubtreeStream(adaptor,"rule choiceItemsList");
        RewriteRuleSubtreeStream stream_versionNumber = new RewriteRuleSubtreeStream(adaptor,"rule versionNumber");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:339:2: (a= '[[' ( versionNumber )? choiceItemsList ']]' -> ^( CHOICE_EXT_ITEM[$a] ( versionNumber )? choiceItemsList ) | choiceItem )
            int alt59 = 2;
            int LA59_0 = input.LA(1);
            
            if ( (LA59_0 == 166) )
            {
                alt59 = 1;
            }
            else if ( (LA59_0 == LID) )
            {
                alt59 = 2;
            }
            else 
            {
                NoViableAltException nvae_d59s0 =
                    new NoViableAltException("338:1: extensionAdditionAlternative : (a= '[[' ( versionNumber )? choiceItemsList ']]' -> ^( CHOICE_EXT_ITEM[$a] ( versionNumber )? choiceItemsList ) | choiceItem );", 59, 0, input);
            
                throw nvae_d59s0;
            }
            switch (alt59) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:339:5: a= '[[' ( versionNumber )? choiceItemsList ']]'
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,166,FOLLOW_166_in_extensionAdditionAlternative1984); 
                    	stream_166.Add(a);

                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:339:12: ( versionNumber )?
                    	int alt58 = 2;
                    	int LA58_0 = input.LA(1);
                    	
                    	if ( (LA58_0 == INT) )
                    	{
                    	    alt58 = 1;
                    	}
                    	switch (alt58) 
                    	{
                    	    case 1 :
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:339:12: versionNumber
                    	        {
                    	        	PushFollow(FOLLOW_versionNumber_in_extensionAdditionAlternative1986);
                    	        	versionNumber137 = versionNumber();
                    	        	followingStackPointer_--;
                    	        	
                    	        	stream_versionNumber.Add(versionNumber137.Tree);
                    	        
                    	        }
                    	        break;
                    	
                    	}

                    	PushFollow(FOLLOW_choiceItemsList_in_extensionAdditionAlternative1989);
                    	choiceItemsList138 = choiceItemsList();
                    	followingStackPointer_--;
                    	
                    	stream_choiceItemsList.Add(choiceItemsList138.Tree);
                    	string_literal139 = (IToken)input.LT(1);
                    	Match(input,167,FOLLOW_167_in_extensionAdditionAlternative1991); 
                    	stream_167.Add(string_literal139);

                    	
                    	// AST REWRITE
                    	// elements:          choiceItemsList, versionNumber
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 339:48: -> ^( CHOICE_EXT_ITEM[$a] ( versionNumber )? choiceItemsList )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:339:51: ^( CHOICE_EXT_ITEM[$a] ( versionNumber )? choiceItemsList )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(CHOICE_EXT_ITEM, a), root_1);
                    	    
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:339:73: ( versionNumber )?
                    	    if ( stream_versionNumber.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_versionNumber.Next());
                    	    
                    	    }
                    	    stream_versionNumber.Reset();
                    	    adaptor.AddChild(root_1, stream_choiceItemsList.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:340:5: choiceItem
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_choiceItem_in_extensionAdditionAlternative2009);
                    	choiceItem140 = choiceItem();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, choiceItem140.Tree);
                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end extensionAdditionAlternative

    public class sequenceType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start sequenceType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:343:1: sequenceType : a= SEQUENCE L_BRACKET ( sequenceOrSetBody )? R_BRACKET -> ^( SEQUENCE_TYPE[$a] ( sequenceOrSetBody )? ) ;
    public sequenceType_return sequenceType() // throws RecognitionException [1]
    {   
        sequenceType_return retval = new sequenceType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken L_BRACKET141 = null;
        IToken R_BRACKET143 = null;
        sequenceOrSetBody_return sequenceOrSetBody142 = null;
        
        
        object a_tree=null;
        object L_BRACKET141_tree=null;
        object R_BRACKET143_tree=null;
        RewriteRuleTokenStream stream_SEQUENCE = new RewriteRuleTokenStream(adaptor,"token SEQUENCE");
        RewriteRuleTokenStream stream_L_BRACKET = new RewriteRuleTokenStream(adaptor,"token L_BRACKET");
        RewriteRuleTokenStream stream_R_BRACKET = new RewriteRuleTokenStream(adaptor,"token R_BRACKET");
        RewriteRuleSubtreeStream stream_sequenceOrSetBody = new RewriteRuleSubtreeStream(adaptor,"rule sequenceOrSetBody");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:344:2: (a= SEQUENCE L_BRACKET ( sequenceOrSetBody )? R_BRACKET -> ^( SEQUENCE_TYPE[$a] ( sequenceOrSetBody )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:344:4: a= SEQUENCE L_BRACKET ( sequenceOrSetBody )? R_BRACKET
            {
            	a = (IToken)input.LT(1);
            	Match(input,SEQUENCE,FOLLOW_SEQUENCE_in_sequenceType2023); 
            	stream_SEQUENCE.Add(a);

            	L_BRACKET141 = (IToken)input.LT(1);
            	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_sequenceType2025); 
            	stream_L_BRACKET.Add(L_BRACKET141);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:344:25: ( sequenceOrSetBody )?
            	int alt60 = 2;
            	int LA60_0 = input.LA(1);
            	
            	if ( (LA60_0 == EXT_MARK || LA60_0 == COMPONENTS || LA60_0 == LID) )
            	{
            	    alt60 = 1;
            	}
            	switch (alt60) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:344:25: sequenceOrSetBody
            	        {
            	        	PushFollow(FOLLOW_sequenceOrSetBody_in_sequenceType2027);
            	        	sequenceOrSetBody142 = sequenceOrSetBody();
            	        	followingStackPointer_--;
            	        	
            	        	stream_sequenceOrSetBody.Add(sequenceOrSetBody142.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	R_BRACKET143 = (IToken)input.LT(1);
            	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_sequenceType2031); 
            	stream_R_BRACKET.Add(R_BRACKET143);

            	
            	// AST REWRITE
            	// elements:          sequenceOrSetBody
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 344:55: -> ^( SEQUENCE_TYPE[$a] ( sequenceOrSetBody )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:344:58: ^( SEQUENCE_TYPE[$a] ( sequenceOrSetBody )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SEQUENCE_TYPE, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:344:78: ( sequenceOrSetBody )?
            	    if ( stream_sequenceOrSetBody.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_sequenceOrSetBody.Next());
            	    
            	    }
            	    stream_sequenceOrSetBody.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end sequenceType

    public class setType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start setType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:347:1: setType : a= SET L_BRACKET ( sequenceOrSetBody )? R_BRACKET -> ^( SET_TYPE[$a] ( sequenceOrSetBody )? ) ;
    public setType_return setType() // throws RecognitionException [1]
    {   
        setType_return retval = new setType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken L_BRACKET144 = null;
        IToken R_BRACKET146 = null;
        sequenceOrSetBody_return sequenceOrSetBody145 = null;
        
        
        object a_tree=null;
        object L_BRACKET144_tree=null;
        object R_BRACKET146_tree=null;
        RewriteRuleTokenStream stream_SET = new RewriteRuleTokenStream(adaptor,"token SET");
        RewriteRuleTokenStream stream_L_BRACKET = new RewriteRuleTokenStream(adaptor,"token L_BRACKET");
        RewriteRuleTokenStream stream_R_BRACKET = new RewriteRuleTokenStream(adaptor,"token R_BRACKET");
        RewriteRuleSubtreeStream stream_sequenceOrSetBody = new RewriteRuleSubtreeStream(adaptor,"rule sequenceOrSetBody");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:347:9: (a= SET L_BRACKET ( sequenceOrSetBody )? R_BRACKET -> ^( SET_TYPE[$a] ( sequenceOrSetBody )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:347:11: a= SET L_BRACKET ( sequenceOrSetBody )? R_BRACKET
            {
            	a = (IToken)input.LT(1);
            	Match(input,SET,FOLLOW_SET_in_setType2054); 
            	stream_SET.Add(a);

            	L_BRACKET144 = (IToken)input.LT(1);
            	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_setType2056); 
            	stream_L_BRACKET.Add(L_BRACKET144);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:347:27: ( sequenceOrSetBody )?
            	int alt61 = 2;
            	int LA61_0 = input.LA(1);
            	
            	if ( (LA61_0 == EXT_MARK || LA61_0 == COMPONENTS || LA61_0 == LID) )
            	{
            	    alt61 = 1;
            	}
            	switch (alt61) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:347:27: sequenceOrSetBody
            	        {
            	        	PushFollow(FOLLOW_sequenceOrSetBody_in_setType2058);
            	        	sequenceOrSetBody145 = sequenceOrSetBody();
            	        	followingStackPointer_--;
            	        	
            	        	stream_sequenceOrSetBody.Add(sequenceOrSetBody145.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	R_BRACKET146 = (IToken)input.LT(1);
            	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_setType2062); 
            	stream_R_BRACKET.Add(R_BRACKET146);

            	
            	// AST REWRITE
            	// elements:          sequenceOrSetBody
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 347:57: -> ^( SET_TYPE[$a] ( sequenceOrSetBody )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:347:60: ^( SET_TYPE[$a] ( sequenceOrSetBody )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SET_TYPE, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:347:75: ( sequenceOrSetBody )?
            	    if ( stream_sequenceOrSetBody.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_sequenceOrSetBody.Next());
            	    
            	    }
            	    stream_sequenceOrSetBody.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end setType

    public class sequenceOrSetBody_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start sequenceOrSetBody
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:350:1: sequenceOrSetBody : ( componentTypeList ( COMMA seqOrSetExtBody )? -> ^( SEQUENCE_BODY componentTypeList ( seqOrSetExtBody )? ) | seqOrSetExtBody -> ^( SEQUENCE_BODY seqOrSetExtBody ) );
    public sequenceOrSetBody_return sequenceOrSetBody() // throws RecognitionException [1]
    {   
        sequenceOrSetBody_return retval = new sequenceOrSetBody_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken COMMA148 = null;
        componentTypeList_return componentTypeList147 = null;

        seqOrSetExtBody_return seqOrSetExtBody149 = null;

        seqOrSetExtBody_return seqOrSetExtBody150 = null;
        
        
        object COMMA148_tree=null;
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_seqOrSetExtBody = new RewriteRuleSubtreeStream(adaptor,"rule seqOrSetExtBody");
        RewriteRuleSubtreeStream stream_componentTypeList = new RewriteRuleSubtreeStream(adaptor,"rule componentTypeList");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:350:19: ( componentTypeList ( COMMA seqOrSetExtBody )? -> ^( SEQUENCE_BODY componentTypeList ( seqOrSetExtBody )? ) | seqOrSetExtBody -> ^( SEQUENCE_BODY seqOrSetExtBody ) )
            int alt63 = 2;
            int LA63_0 = input.LA(1);
            
            if ( (LA63_0 == COMPONENTS || LA63_0 == LID) )
            {
                alt63 = 1;
            }
            else if ( (LA63_0 == EXT_MARK) )
            {
                alt63 = 2;
            }
            else 
            {
                NoViableAltException nvae_d63s0 =
                    new NoViableAltException("350:1: sequenceOrSetBody : ( componentTypeList ( COMMA seqOrSetExtBody )? -> ^( SEQUENCE_BODY componentTypeList ( seqOrSetExtBody )? ) | seqOrSetExtBody -> ^( SEQUENCE_BODY seqOrSetExtBody ) );", 63, 0, input);
            
                throw nvae_d63s0;
            }
            switch (alt63) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:351:5: componentTypeList ( COMMA seqOrSetExtBody )?
                    {
                    	PushFollow(FOLLOW_componentTypeList_in_sequenceOrSetBody2088);
                    	componentTypeList147 = componentTypeList();
                    	followingStackPointer_--;
                    	
                    	stream_componentTypeList.Add(componentTypeList147.Tree);
                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:351:23: ( COMMA seqOrSetExtBody )?
                    	int alt62 = 2;
                    	int LA62_0 = input.LA(1);
                    	
                    	if ( (LA62_0 == COMMA) )
                    	{
                    	    alt62 = 1;
                    	}
                    	switch (alt62) 
                    	{
                    	    case 1 :
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:351:25: COMMA seqOrSetExtBody
                    	        {
                    	        	COMMA148 = (IToken)input.LT(1);
                    	        	Match(input,COMMA,FOLLOW_COMMA_in_sequenceOrSetBody2092); 
                    	        	stream_COMMA.Add(COMMA148);

                    	        	PushFollow(FOLLOW_seqOrSetExtBody_in_sequenceOrSetBody2094);
                    	        	seqOrSetExtBody149 = seqOrSetExtBody();
                    	        	followingStackPointer_--;
                    	        	
                    	        	stream_seqOrSetExtBody.Add(seqOrSetExtBody149.Tree);
                    	        
                    	        }
                    	        break;
                    	
                    	}

                    	
                    	// AST REWRITE
                    	// elements:          componentTypeList, seqOrSetExtBody
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 351:50: -> ^( SEQUENCE_BODY componentTypeList ( seqOrSetExtBody )? )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:351:53: ^( SEQUENCE_BODY componentTypeList ( seqOrSetExtBody )? )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SEQUENCE_BODY, "SEQUENCE_BODY"), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_componentTypeList.Next());
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:351:87: ( seqOrSetExtBody )?
                    	    if ( stream_seqOrSetExtBody.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_seqOrSetExtBody.Next());
                    	    
                    	    }
                    	    stream_seqOrSetExtBody.Reset();
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:352:5: seqOrSetExtBody
                    {
                    	PushFollow(FOLLOW_seqOrSetExtBody_in_sequenceOrSetBody2114);
                    	seqOrSetExtBody150 = seqOrSetExtBody();
                    	followingStackPointer_--;
                    	
                    	stream_seqOrSetExtBody.Add(seqOrSetExtBody150.Tree);
                    	
                    	// AST REWRITE
                    	// elements:          seqOrSetExtBody
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 352:28: -> ^( SEQUENCE_BODY seqOrSetExtBody )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:352:31: ^( SEQUENCE_BODY seqOrSetExtBody )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SEQUENCE_BODY, "SEQUENCE_BODY"), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_seqOrSetExtBody.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end sequenceOrSetBody

    public class seqOrSetExtBody_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start seqOrSetExtBody
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:355:1: seqOrSetExtBody : a= EXT_MARK ( exceptionSpec )? ( COMMA extensionAdditionList )? ( COMMA extMark2= EXT_MARK ( COMMA componentTypeList )? )? -> ^( SEQUENCE_EXT_BODY[$a] ( exceptionSpec )? ( extensionAdditionList )? ( $extMark2)? ( componentTypeList )? ) ;
    public seqOrSetExtBody_return seqOrSetExtBody() // throws RecognitionException [1]
    {   
        seqOrSetExtBody_return retval = new seqOrSetExtBody_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken extMark2 = null;
        IToken COMMA152 = null;
        IToken COMMA154 = null;
        IToken COMMA155 = null;
        exceptionSpec_return exceptionSpec151 = null;

        extensionAdditionList_return extensionAdditionList153 = null;

        componentTypeList_return componentTypeList156 = null;
        
        
        object a_tree=null;
        object extMark2_tree=null;
        object COMMA152_tree=null;
        object COMMA154_tree=null;
        object COMMA155_tree=null;
        RewriteRuleTokenStream stream_EXT_MARK = new RewriteRuleTokenStream(adaptor,"token EXT_MARK");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_componentTypeList = new RewriteRuleSubtreeStream(adaptor,"rule componentTypeList");
        RewriteRuleSubtreeStream stream_extensionAdditionList = new RewriteRuleSubtreeStream(adaptor,"rule extensionAdditionList");
        RewriteRuleSubtreeStream stream_exceptionSpec = new RewriteRuleSubtreeStream(adaptor,"rule exceptionSpec");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:2: (a= EXT_MARK ( exceptionSpec )? ( COMMA extensionAdditionList )? ( COMMA extMark2= EXT_MARK ( COMMA componentTypeList )? )? -> ^( SEQUENCE_EXT_BODY[$a] ( exceptionSpec )? ( extensionAdditionList )? ( $extMark2)? ( componentTypeList )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:4: a= EXT_MARK ( exceptionSpec )? ( COMMA extensionAdditionList )? ( COMMA extMark2= EXT_MARK ( COMMA componentTypeList )? )?
            {
            	a = (IToken)input.LT(1);
            	Match(input,EXT_MARK,FOLLOW_EXT_MARK_in_seqOrSetExtBody2143); 
            	stream_EXT_MARK.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:15: ( exceptionSpec )?
            	int alt64 = 2;
            	int LA64_0 = input.LA(1);
            	
            	if ( (LA64_0 == 169) )
            	{
            	    alt64 = 1;
            	}
            	switch (alt64) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:15: exceptionSpec
            	        {
            	        	PushFollow(FOLLOW_exceptionSpec_in_seqOrSetExtBody2145);
            	        	exceptionSpec151 = exceptionSpec();
            	        	followingStackPointer_--;
            	        	
            	        	stream_exceptionSpec.Add(exceptionSpec151.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:30: ( COMMA extensionAdditionList )?
            	int alt65 = 2;
            	int LA65_0 = input.LA(1);
            	
            	if ( (LA65_0 == COMMA) )
            	{
            	    int LA65_1 = input.LA(2);
            	    
            	    if ( (LA65_1 == COMPONENTS || LA65_1 == LID || LA65_1 == 166) )
            	    {
            	        alt65 = 1;
            	    }
            	}
            	switch (alt65) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:31: COMMA extensionAdditionList
            	        {
            	        	COMMA152 = (IToken)input.LT(1);
            	        	Match(input,COMMA,FOLLOW_COMMA_in_seqOrSetExtBody2149); 
            	        	stream_COMMA.Add(COMMA152);

            	        	PushFollow(FOLLOW_extensionAdditionList_in_seqOrSetExtBody2151);
            	        	extensionAdditionList153 = extensionAdditionList();
            	        	followingStackPointer_--;
            	        	
            	        	stream_extensionAdditionList.Add(extensionAdditionList153.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:61: ( COMMA extMark2= EXT_MARK ( COMMA componentTypeList )? )?
            	int alt67 = 2;
            	int LA67_0 = input.LA(1);
            	
            	if ( (LA67_0 == COMMA) )
            	{
            	    alt67 = 1;
            	}
            	switch (alt67) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:62: COMMA extMark2= EXT_MARK ( COMMA componentTypeList )?
            	        {
            	        	COMMA154 = (IToken)input.LT(1);
            	        	Match(input,COMMA,FOLLOW_COMMA_in_seqOrSetExtBody2156); 
            	        	stream_COMMA.Add(COMMA154);

            	        	extMark2 = (IToken)input.LT(1);
            	        	Match(input,EXT_MARK,FOLLOW_EXT_MARK_in_seqOrSetExtBody2160); 
            	        	stream_EXT_MARK.Add(extMark2);

            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:88: ( COMMA componentTypeList )?
            	        	int alt66 = 2;
            	        	int LA66_0 = input.LA(1);
            	        	
            	        	if ( (LA66_0 == COMMA) )
            	        	{
            	        	    alt66 = 1;
            	        	}
            	        	switch (alt66) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:356:89: COMMA componentTypeList
            	        	        {
            	        	        	COMMA155 = (IToken)input.LT(1);
            	        	        	Match(input,COMMA,FOLLOW_COMMA_in_seqOrSetExtBody2165); 
            	        	        	stream_COMMA.Add(COMMA155);

            	        	        	PushFollow(FOLLOW_componentTypeList_in_seqOrSetExtBody2167);
            	        	        	componentTypeList156 = componentTypeList();
            	        	        	followingStackPointer_--;
            	        	        	
            	        	        	stream_componentTypeList.Add(componentTypeList156.Tree);
            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          exceptionSpec, extensionAdditionList, componentTypeList, extMark2
            	// token labels:      extMark2
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_extMark2 = new RewriteRuleTokenStream(adaptor, "token extMark2", extMark2);
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 357:2: -> ^( SEQUENCE_EXT_BODY[$a] ( exceptionSpec )? ( extensionAdditionList )? ( $extMark2)? ( componentTypeList )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:357:5: ^( SEQUENCE_EXT_BODY[$a] ( exceptionSpec )? ( extensionAdditionList )? ( $extMark2)? ( componentTypeList )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SEQUENCE_EXT_BODY, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:357:29: ( exceptionSpec )?
            	    if ( stream_exceptionSpec.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_exceptionSpec.Next());
            	    
            	    }
            	    stream_exceptionSpec.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:357:44: ( extensionAdditionList )?
            	    if ( stream_extensionAdditionList.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_extensionAdditionList.Next());
            	    
            	    }
            	    stream_extensionAdditionList.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:357:67: ( $extMark2)?
            	    if ( stream_extMark2.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_extMark2.Next());
            	    
            	    }
            	    stream_extMark2.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:357:78: ( componentTypeList )?
            	    if ( stream_componentTypeList.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_componentTypeList.Next());
            	    
            	    }
            	    stream_componentTypeList.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end seqOrSetExtBody

    public class extensionAdditionList_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start extensionAdditionList
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:360:1: extensionAdditionList : extensionAddition ( COMMA extensionAddition )* -> ( extensionAddition )+ ;
    public extensionAdditionList_return extensionAdditionList() // throws RecognitionException [1]
    {   
        extensionAdditionList_return retval = new extensionAdditionList_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken COMMA158 = null;
        extensionAddition_return extensionAddition157 = null;

        extensionAddition_return extensionAddition159 = null;
        
        
        object COMMA158_tree=null;
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_extensionAddition = new RewriteRuleSubtreeStream(adaptor,"rule extensionAddition");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:361:2: ( extensionAddition ( COMMA extensionAddition )* -> ( extensionAddition )+ )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:361:4: extensionAddition ( COMMA extensionAddition )*
            {
            	PushFollow(FOLLOW_extensionAddition_in_extensionAdditionList2207);
            	extensionAddition157 = extensionAddition();
            	followingStackPointer_--;
            	
            	stream_extensionAddition.Add(extensionAddition157.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:361:22: ( COMMA extensionAddition )*
            	do 
            	{
            	    int alt68 = 2;
            	    int LA68_0 = input.LA(1);
            	    
            	    if ( (LA68_0 == COMMA) )
            	    {
            	        int LA68_1 = input.LA(2);
            	        
            	        if ( (LA68_1 == COMPONENTS || LA68_1 == LID || LA68_1 == 166) )
            	        {
            	            alt68 = 1;
            	        }
            	        
            	    
            	    }
            	    
            	
            	    switch (alt68) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:361:23: COMMA extensionAddition
            			    {
            			    	COMMA158 = (IToken)input.LT(1);
            			    	Match(input,COMMA,FOLLOW_COMMA_in_extensionAdditionList2210); 
            			    	stream_COMMA.Add(COMMA158);

            			    	PushFollow(FOLLOW_extensionAddition_in_extensionAdditionList2212);
            			    	extensionAddition159 = extensionAddition();
            			    	followingStackPointer_--;
            			    	
            			    	stream_extensionAddition.Add(extensionAddition159.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop68;
            	    }
            	} while (true);
            	
            	loop68:
            		;	// Stops C# compiler whinging that label 'loop68' has no statements

            	
            	// AST REWRITE
            	// elements:          extensionAddition
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 361:50: -> ( extensionAddition )+
            	{
            	    if ( !(stream_extensionAddition.HasNext()) ) {
            	        throw new RewriteEarlyExitException();
            	    }
            	    while ( stream_extensionAddition.HasNext() )
            	    {
            	        adaptor.AddChild(root_0, stream_extensionAddition.Next());
            	    
            	    }
            	    stream_extensionAddition.Reset();
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end extensionAdditionList

    public class extensionAddition_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start extensionAddition
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:364:1: extensionAddition : ( componentType | extensionAdditionGroup );
    public extensionAddition_return extensionAddition() // throws RecognitionException [1]
    {   
        extensionAddition_return retval = new extensionAddition_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        componentType_return componentType160 = null;

        extensionAdditionGroup_return extensionAdditionGroup161 = null;
        
        
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:365:2: ( componentType | extensionAdditionGroup )
            int alt69 = 2;
            int LA69_0 = input.LA(1);
            
            if ( (LA69_0 == COMPONENTS || LA69_0 == LID) )
            {
                alt69 = 1;
            }
            else if ( (LA69_0 == 166) )
            {
                alt69 = 2;
            }
            else 
            {
                NoViableAltException nvae_d69s0 =
                    new NoViableAltException("364:1: extensionAddition : ( componentType | extensionAdditionGroup );", 69, 0, input);
            
                throw nvae_d69s0;
            }
            switch (alt69) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:365:4: componentType
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_componentType_in_extensionAddition2232);
                    	componentType160 = componentType();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, componentType160.Tree);
                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:366:10: extensionAdditionGroup
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_extensionAdditionGroup_in_extensionAddition2243);
                    	extensionAdditionGroup161 = extensionAdditionGroup();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, extensionAdditionGroup161.Tree);
                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end extensionAddition

    public class extensionAdditionGroup_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start extensionAdditionGroup
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:368:1: extensionAdditionGroup : a= '[[' ( versionNumber )? componentTypeList ']]' -> ^( SEQUENCE_EXT_GROUP[$a] ( versionNumber )? componentTypeList ) ;
    public extensionAdditionGroup_return extensionAdditionGroup() // throws RecognitionException [1]
    {   
        extensionAdditionGroup_return retval = new extensionAdditionGroup_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken string_literal164 = null;
        versionNumber_return versionNumber162 = null;

        componentTypeList_return componentTypeList163 = null;
        
        
        object a_tree=null;
        object string_literal164_tree=null;
        RewriteRuleTokenStream stream_166 = new RewriteRuleTokenStream(adaptor,"token 166");
        RewriteRuleTokenStream stream_167 = new RewriteRuleTokenStream(adaptor,"token 167");
        RewriteRuleSubtreeStream stream_componentTypeList = new RewriteRuleSubtreeStream(adaptor,"rule componentTypeList");
        RewriteRuleSubtreeStream stream_versionNumber = new RewriteRuleSubtreeStream(adaptor,"rule versionNumber");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:369:2: (a= '[[' ( versionNumber )? componentTypeList ']]' -> ^( SEQUENCE_EXT_GROUP[$a] ( versionNumber )? componentTypeList ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:369:4: a= '[[' ( versionNumber )? componentTypeList ']]'
            {
            	a = (IToken)input.LT(1);
            	Match(input,166,FOLLOW_166_in_extensionAdditionGroup2255); 
            	stream_166.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:369:11: ( versionNumber )?
            	int alt70 = 2;
            	int LA70_0 = input.LA(1);
            	
            	if ( (LA70_0 == INT) )
            	{
            	    alt70 = 1;
            	}
            	switch (alt70) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:369:11: versionNumber
            	        {
            	        	PushFollow(FOLLOW_versionNumber_in_extensionAdditionGroup2257);
            	        	versionNumber162 = versionNumber();
            	        	followingStackPointer_--;
            	        	
            	        	stream_versionNumber.Add(versionNumber162.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	PushFollow(FOLLOW_componentTypeList_in_extensionAdditionGroup2260);
            	componentTypeList163 = componentTypeList();
            	followingStackPointer_--;
            	
            	stream_componentTypeList.Add(componentTypeList163.Tree);
            	string_literal164 = (IToken)input.LT(1);
            	Match(input,167,FOLLOW_167_in_extensionAdditionGroup2262); 
            	stream_167.Add(string_literal164);

            	
            	// AST REWRITE
            	// elements:          componentTypeList, versionNumber
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 369:49: -> ^( SEQUENCE_EXT_GROUP[$a] ( versionNumber )? componentTypeList )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:369:52: ^( SEQUENCE_EXT_GROUP[$a] ( versionNumber )? componentTypeList )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SEQUENCE_EXT_GROUP, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:369:77: ( versionNumber )?
            	    if ( stream_versionNumber.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_versionNumber.Next());
            	    
            	    }
            	    stream_versionNumber.Reset();
            	    adaptor.AddChild(root_1, stream_componentTypeList.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end extensionAdditionGroup

    public class componentTypeList_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start componentTypeList
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:372:1: componentTypeList : componentType ( COMMA componentType )* -> ( componentType )+ ;
    public componentTypeList_return componentTypeList() // throws RecognitionException [1]
    {   
        componentTypeList_return retval = new componentTypeList_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken COMMA166 = null;
        componentType_return componentType165 = null;

        componentType_return componentType167 = null;
        
        
        object COMMA166_tree=null;
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_componentType = new RewriteRuleSubtreeStream(adaptor,"rule componentType");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:373:2: ( componentType ( COMMA componentType )* -> ( componentType )+ )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:373:4: componentType ( COMMA componentType )*
            {
            	PushFollow(FOLLOW_componentType_in_componentTypeList2286);
            	componentType165 = componentType();
            	followingStackPointer_--;
            	
            	stream_componentType.Add(componentType165.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:373:19: ( COMMA componentType )*
            	do 
            	{
            	    int alt71 = 2;
            	    int LA71_0 = input.LA(1);
            	    
            	    if ( (LA71_0 == COMMA) )
            	    {
            	        int LA71_1 = input.LA(2);
            	        
            	        if ( (LA71_1 == COMPONENTS || LA71_1 == LID) )
            	        {
            	            alt71 = 1;
            	        }
            	        
            	    
            	    }
            	    
            	
            	    switch (alt71) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:373:20: COMMA componentType
            			    {
            			    	COMMA166 = (IToken)input.LT(1);
            			    	Match(input,COMMA,FOLLOW_COMMA_in_componentTypeList2290); 
            			    	stream_COMMA.Add(COMMA166);

            			    	PushFollow(FOLLOW_componentType_in_componentTypeList2292);
            			    	componentType167 = componentType();
            			    	followingStackPointer_--;
            			    	
            			    	stream_componentType.Add(componentType167.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop71;
            	    }
            	} while (true);
            	
            	loop71:
            		;	// Stops C# compiler whinging that label 'loop71' has no statements

            	
            	// AST REWRITE
            	// elements:          componentType
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 373:44: -> ( componentType )+
            	{
            	    if ( !(stream_componentType.HasNext()) ) {
            	        throw new RewriteEarlyExitException();
            	    }
            	    while ( stream_componentType.HasNext() )
            	    {
            	        adaptor.AddChild(root_0, stream_componentType.Next());
            	    
            	    }
            	    stream_componentType.Reset();
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end componentTypeList

    public class componentType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start componentType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:376:1: componentType : ( identifier type (optOrDef= OPTIONAL | optOrDef= DEFAULT value )? -> ^( SEQUENCE_ITEM identifier type ( $optOrDef)? ( ^( DEFAULT_VALUE value ) )? ) | a= COMPONENTS OF type -> ^( COMPONENTS_OF[$a] type ) );
    public componentType_return componentType() // throws RecognitionException [1]
    {   
        componentType_return retval = new componentType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken optOrDef = null;
        IToken a = null;
        IToken OF171 = null;
        identifier_return identifier168 = null;

        type_return type169 = null;

        value_return value170 = null;

        type_return type172 = null;
        
        
        object optOrDef_tree=null;
        object a_tree=null;
        object OF171_tree=null;
        RewriteRuleTokenStream stream_COMPONENTS = new RewriteRuleTokenStream(adaptor,"token COMPONENTS");
        RewriteRuleTokenStream stream_OF = new RewriteRuleTokenStream(adaptor,"token OF");
        RewriteRuleTokenStream stream_OPTIONAL = new RewriteRuleTokenStream(adaptor,"token OPTIONAL");
        RewriteRuleTokenStream stream_DEFAULT = new RewriteRuleTokenStream(adaptor,"token DEFAULT");
        RewriteRuleSubtreeStream stream_value = new RewriteRuleSubtreeStream(adaptor,"rule value");
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:2: ( identifier type (optOrDef= OPTIONAL | optOrDef= DEFAULT value )? -> ^( SEQUENCE_ITEM identifier type ( $optOrDef)? ( ^( DEFAULT_VALUE value ) )? ) | a= COMPONENTS OF type -> ^( COMPONENTS_OF[$a] type ) )
            int alt73 = 2;
            int LA73_0 = input.LA(1);
            
            if ( (LA73_0 == LID) )
            {
                alt73 = 1;
            }
            else if ( (LA73_0 == COMPONENTS) )
            {
                alt73 = 2;
            }
            else 
            {
                NoViableAltException nvae_d73s0 =
                    new NoViableAltException("376:1: componentType : ( identifier type (optOrDef= OPTIONAL | optOrDef= DEFAULT value )? -> ^( SEQUENCE_ITEM identifier type ( $optOrDef)? ( ^( DEFAULT_VALUE value ) )? ) | a= COMPONENTS OF type -> ^( COMPONENTS_OF[$a] type ) );", 73, 0, input);
            
                throw nvae_d73s0;
            }
            switch (alt73) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:5: identifier type (optOrDef= OPTIONAL | optOrDef= DEFAULT value )?
                    {
                    	PushFollow(FOLLOW_identifier_in_componentType2314);
                    	identifier168 = identifier();
                    	followingStackPointer_--;
                    	
                    	stream_identifier.Add(identifier168.Tree);
                    	PushFollow(FOLLOW_type_in_componentType2316);
                    	type169 = type();
                    	followingStackPointer_--;
                    	
                    	stream_type.Add(type169.Tree);
                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:21: (optOrDef= OPTIONAL | optOrDef= DEFAULT value )?
                    	int alt72 = 3;
                    	int LA72_0 = input.LA(1);
                    	
                    	if ( (LA72_0 == OPTIONAL) )
                    	{
                    	    alt72 = 1;
                    	}
                    	else if ( (LA72_0 == DEFAULT) )
                    	{
                    	    alt72 = 2;
                    	}
                    	switch (alt72) 
                    	{
                    	    case 1 :
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:22: optOrDef= OPTIONAL
                    	        {
                    	        	optOrDef = (IToken)input.LT(1);
                    	        	Match(input,OPTIONAL,FOLLOW_OPTIONAL_in_componentType2321); 
                    	        	stream_OPTIONAL.Add(optOrDef);

                    	        
                    	        }
                    	        break;
                    	    case 2 :
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:42: optOrDef= DEFAULT value
                    	        {
                    	        	optOrDef = (IToken)input.LT(1);
                    	        	Match(input,DEFAULT,FOLLOW_DEFAULT_in_componentType2327); 
                    	        	stream_DEFAULT.Add(optOrDef);

                    	        	PushFollow(FOLLOW_value_in_componentType2329);
                    	        	value170 = value();
                    	        	followingStackPointer_--;
                    	        	
                    	        	stream_value.Add(value170.Tree);
                    	        
                    	        }
                    	        break;
                    	
                    	}

                    	
                    	// AST REWRITE
                    	// elements:          optOrDef, identifier, value, type
                    	// token labels:      optOrDef
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleTokenStream stream_optOrDef = new RewriteRuleTokenStream(adaptor, "token optOrDef", optOrDef);
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 377:67: -> ^( SEQUENCE_ITEM identifier type ( $optOrDef)? ( ^( DEFAULT_VALUE value ) )? )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:70: ^( SEQUENCE_ITEM identifier type ( $optOrDef)? ( ^( DEFAULT_VALUE value ) )? )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SEQUENCE_ITEM, "SEQUENCE_ITEM"), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_identifier.Next());
                    	    adaptor.AddChild(root_1, stream_type.Next());
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:102: ( $optOrDef)?
                    	    if ( stream_optOrDef.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_optOrDef.Next());
                    	    
                    	    }
                    	    stream_optOrDef.Reset();
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:113: ( ^( DEFAULT_VALUE value ) )?
                    	    if ( stream_value.HasNext() )
                    	    {
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:377:113: ^( DEFAULT_VALUE value )
                    	        {
                    	        object root_2 = (object)adaptor.GetNilNode();
                    	        root_2 = (object)adaptor.BecomeRoot(adaptor.Create(DEFAULT_VALUE, "DEFAULT_VALUE"), root_2);
                    	        
                    	        adaptor.AddChild(root_2, stream_value.Next());
                    	        
                    	        adaptor.AddChild(root_1, root_2);
                    	        }
                    	    
                    	    }
                    	    stream_value.Reset();
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:378:5: a= COMPONENTS OF type
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,COMPONENTS,FOLLOW_COMPONENTS_in_componentType2361); 
                    	stream_COMPONENTS.Add(a);

                    	OF171 = (IToken)input.LT(1);
                    	Match(input,OF,FOLLOW_OF_in_componentType2363); 
                    	stream_OF.Add(OF171);

                    	PushFollow(FOLLOW_type_in_componentType2365);
                    	type172 = type();
                    	followingStackPointer_--;
                    	
                    	stream_type.Add(type172.Tree);
                    	
                    	// AST REWRITE
                    	// elements:          type
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 378:36: -> ^( COMPONENTS_OF[$a] type )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:378:39: ^( COMPONENTS_OF[$a] type )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(COMPONENTS_OF, a), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_type.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end componentType

    public class sequenceOfType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start sequenceOfType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:381:1: sequenceOfType : a= SEQUENCE ( sizeShortConstraint | constraint )? OF ( identifier )? type -> ^( SEQUENCE_OF_TYPE[$a] ( sizeShortConstraint )? ( constraint )? ( identifier )? type ) ;
    public sequenceOfType_return sequenceOfType() // throws RecognitionException [1]
    {   
        sequenceOfType_return retval = new sequenceOfType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken OF175 = null;
        sizeShortConstraint_return sizeShortConstraint173 = null;

        constraint_return constraint174 = null;

        identifier_return identifier176 = null;

        type_return type177 = null;
        
        
        object a_tree=null;
        object OF175_tree=null;
        RewriteRuleTokenStream stream_SEQUENCE = new RewriteRuleTokenStream(adaptor,"token SEQUENCE");
        RewriteRuleTokenStream stream_OF = new RewriteRuleTokenStream(adaptor,"token OF");
        RewriteRuleSubtreeStream stream_sizeShortConstraint = new RewriteRuleSubtreeStream(adaptor,"rule sizeShortConstraint");
        RewriteRuleSubtreeStream stream_constraint = new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:2: (a= SEQUENCE ( sizeShortConstraint | constraint )? OF ( identifier )? type -> ^( SEQUENCE_OF_TYPE[$a] ( sizeShortConstraint )? ( constraint )? ( identifier )? type ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:4: a= SEQUENCE ( sizeShortConstraint | constraint )? OF ( identifier )? type
            {
            	a = (IToken)input.LT(1);
            	Match(input,SEQUENCE,FOLLOW_SEQUENCE_in_sequenceOfType2399); 
            	stream_SEQUENCE.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:15: ( sizeShortConstraint | constraint )?
            	int alt74 = 3;
            	int LA74_0 = input.LA(1);
            	
            	if ( (LA74_0 == SIZE) )
            	{
            	    alt74 = 1;
            	}
            	else if ( (LA74_0 == L_PAREN) )
            	{
            	    alt74 = 2;
            	}
            	switch (alt74) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:16: sizeShortConstraint
            	        {
            	        	PushFollow(FOLLOW_sizeShortConstraint_in_sequenceOfType2402);
            	        	sizeShortConstraint173 = sizeShortConstraint();
            	        	followingStackPointer_--;
            	        	
            	        	stream_sizeShortConstraint.Add(sizeShortConstraint173.Tree);
            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:38: constraint
            	        {
            	        	PushFollow(FOLLOW_constraint_in_sequenceOfType2406);
            	        	constraint174 = constraint();
            	        	followingStackPointer_--;
            	        	
            	        	stream_constraint.Add(constraint174.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	OF175 = (IToken)input.LT(1);
            	Match(input,OF,FOLLOW_OF_in_sequenceOfType2410); 
            	stream_OF.Add(OF175);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:54: ( identifier )?
            	int alt75 = 2;
            	int LA75_0 = input.LA(1);
            	
            	if ( (LA75_0 == LID) )
            	{
            	    int LA75_1 = input.LA(2);
            	    
            	    if ( ((LA75_1 >= NULL && LA75_1 <= BIT) || (LA75_1 >= BOOLEAN && LA75_1 <= ENUMERATED) || (LA75_1 >= INTEGER && LA75_1 <= SET) || (LA75_1 >= OCTET && LA75_1 <= UID) || (LA75_1 >= LID && LA75_1 <= OBJECT) || LA75_1 == RELATIVE_OID || LA75_1 == 163) )
            	    {
            	        alt75 = 1;
            	    }
            	}
            	switch (alt75) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:55: identifier
            	        {
            	        	PushFollow(FOLLOW_identifier_in_sequenceOfType2413);
            	        	identifier176 = identifier();
            	        	followingStackPointer_--;
            	        	
            	        	stream_identifier.Add(identifier176.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	PushFollow(FOLLOW_type_in_sequenceOfType2417);
            	type177 = type();
            	followingStackPointer_--;
            	
            	stream_type.Add(type177.Tree);
            	
            	// AST REWRITE
            	// elements:          identifier, sizeShortConstraint, constraint, type
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 382:75: -> ^( SEQUENCE_OF_TYPE[$a] ( sizeShortConstraint )? ( constraint )? ( identifier )? type )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:78: ^( SEQUENCE_OF_TYPE[$a] ( sizeShortConstraint )? ( constraint )? ( identifier )? type )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SEQUENCE_OF_TYPE, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:101: ( sizeShortConstraint )?
            	    if ( stream_sizeShortConstraint.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_sizeShortConstraint.Next());
            	    
            	    }
            	    stream_sizeShortConstraint.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:122: ( constraint )?
            	    if ( stream_constraint.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_constraint.Next());
            	    
            	    }
            	    stream_constraint.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:382:134: ( identifier )?
            	    if ( stream_identifier.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_identifier.Next());
            	    
            	    }
            	    stream_identifier.Reset();
            	    adaptor.AddChild(root_1, stream_type.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end sequenceOfType

    public class setOfType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start setOfType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:385:1: setOfType : a= SET ( sizeShortConstraint | constraint )? OF ( identifier )? type -> ^( SET_OF_TYPE[$a] ( sizeShortConstraint )? ( constraint )? ( identifier )? type ) ;
    public setOfType_return setOfType() // throws RecognitionException [1]
    {   
        setOfType_return retval = new setOfType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken OF180 = null;
        sizeShortConstraint_return sizeShortConstraint178 = null;

        constraint_return constraint179 = null;

        identifier_return identifier181 = null;

        type_return type182 = null;
        
        
        object a_tree=null;
        object OF180_tree=null;
        RewriteRuleTokenStream stream_SET = new RewriteRuleTokenStream(adaptor,"token SET");
        RewriteRuleTokenStream stream_OF = new RewriteRuleTokenStream(adaptor,"token OF");
        RewriteRuleSubtreeStream stream_sizeShortConstraint = new RewriteRuleSubtreeStream(adaptor,"rule sizeShortConstraint");
        RewriteRuleSubtreeStream stream_constraint = new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:2: (a= SET ( sizeShortConstraint | constraint )? OF ( identifier )? type -> ^( SET_OF_TYPE[$a] ( sizeShortConstraint )? ( constraint )? ( identifier )? type ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:4: a= SET ( sizeShortConstraint | constraint )? OF ( identifier )? type
            {
            	a = (IToken)input.LT(1);
            	Match(input,SET,FOLLOW_SET_in_setOfType2451); 
            	stream_SET.Add(a);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:10: ( sizeShortConstraint | constraint )?
            	int alt76 = 3;
            	int LA76_0 = input.LA(1);
            	
            	if ( (LA76_0 == SIZE) )
            	{
            	    alt76 = 1;
            	}
            	else if ( (LA76_0 == L_PAREN) )
            	{
            	    alt76 = 2;
            	}
            	switch (alt76) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:11: sizeShortConstraint
            	        {
            	        	PushFollow(FOLLOW_sizeShortConstraint_in_setOfType2454);
            	        	sizeShortConstraint178 = sizeShortConstraint();
            	        	followingStackPointer_--;
            	        	
            	        	stream_sizeShortConstraint.Add(sizeShortConstraint178.Tree);
            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:33: constraint
            	        {
            	        	PushFollow(FOLLOW_constraint_in_setOfType2458);
            	        	constraint179 = constraint();
            	        	followingStackPointer_--;
            	        	
            	        	stream_constraint.Add(constraint179.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	OF180 = (IToken)input.LT(1);
            	Match(input,OF,FOLLOW_OF_in_setOfType2462); 
            	stream_OF.Add(OF180);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:49: ( identifier )?
            	int alt77 = 2;
            	int LA77_0 = input.LA(1);
            	
            	if ( (LA77_0 == LID) )
            	{
            	    int LA77_1 = input.LA(2);
            	    
            	    if ( ((LA77_1 >= NULL && LA77_1 <= BIT) || (LA77_1 >= BOOLEAN && LA77_1 <= ENUMERATED) || (LA77_1 >= INTEGER && LA77_1 <= SET) || (LA77_1 >= OCTET && LA77_1 <= UID) || (LA77_1 >= LID && LA77_1 <= OBJECT) || LA77_1 == RELATIVE_OID || LA77_1 == 163) )
            	    {
            	        alt77 = 1;
            	    }
            	}
            	switch (alt77) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:50: identifier
            	        {
            	        	PushFollow(FOLLOW_identifier_in_setOfType2465);
            	        	identifier181 = identifier();
            	        	followingStackPointer_--;
            	        	
            	        	stream_identifier.Add(identifier181.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	PushFollow(FOLLOW_type_in_setOfType2469);
            	type182 = type();
            	followingStackPointer_--;
            	
            	stream_type.Add(type182.Tree);
            	
            	// AST REWRITE
            	// elements:          type, sizeShortConstraint, constraint, identifier
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 386:71: -> ^( SET_OF_TYPE[$a] ( sizeShortConstraint )? ( constraint )? ( identifier )? type )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:74: ^( SET_OF_TYPE[$a] ( sizeShortConstraint )? ( constraint )? ( identifier )? type )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SET_OF_TYPE, a), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:92: ( sizeShortConstraint )?
            	    if ( stream_sizeShortConstraint.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_sizeShortConstraint.Next());
            	    
            	    }
            	    stream_sizeShortConstraint.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:113: ( constraint )?
            	    if ( stream_constraint.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_constraint.Next());
            	    
            	    }
            	    stream_constraint.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:386:125: ( identifier )?
            	    if ( stream_identifier.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_identifier.Next());
            	    
            	    }
            	    stream_identifier.Reset();
            	    adaptor.AddChild(root_1, stream_type.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end setOfType

    public class stringType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start stringType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:390:1: stringType : ( OCTET STRING -> OCTECT_STING | NumericString | PrintableString | VisibleString | IA5String | TeletexString | VideotexString | GraphicString | GeneralString | UniversalString | BMPString | UTF8String | GeneralizedTime | UTCTime );
    public stringType_return stringType() // throws RecognitionException [1]
    {   
        stringType_return retval = new stringType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken OCTET183 = null;
        IToken STRING184 = null;
        IToken NumericString185 = null;
        IToken PrintableString186 = null;
        IToken VisibleString187 = null;
        IToken IA5String188 = null;
        IToken TeletexString189 = null;
        IToken VideotexString190 = null;
        IToken GraphicString191 = null;
        IToken GeneralString192 = null;
        IToken UniversalString193 = null;
        IToken BMPString194 = null;
        IToken UTF8String195 = null;
        IToken GeneralizedTime196 = null;
        IToken UTCTime197 = null;
        
        object OCTET183_tree=null;
        object STRING184_tree=null;
        object NumericString185_tree=null;
        object PrintableString186_tree=null;
        object VisibleString187_tree=null;
        object IA5String188_tree=null;
        object TeletexString189_tree=null;
        object VideotexString190_tree=null;
        object GraphicString191_tree=null;
        object GeneralString192_tree=null;
        object UniversalString193_tree=null;
        object BMPString194_tree=null;
        object UTF8String195_tree=null;
        object GeneralizedTime196_tree=null;
        object UTCTime197_tree=null;
        RewriteRuleTokenStream stream_OCTET = new RewriteRuleTokenStream(adaptor,"token OCTET");
        RewriteRuleTokenStream stream_STRING = new RewriteRuleTokenStream(adaptor,"token STRING");
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:390:12: ( OCTET STRING -> OCTECT_STING | NumericString | PrintableString | VisibleString | IA5String | TeletexString | VideotexString | GraphicString | GeneralString | UniversalString | BMPString | UTF8String | GeneralizedTime | UTCTime )
            int alt78 = 14;
            switch ( input.LA(1) ) 
            {
            case OCTET:
            	{
                alt78 = 1;
                }
                break;
            case NumericString:
            	{
                alt78 = 2;
                }
                break;
            case PrintableString:
            	{
                alt78 = 3;
                }
                break;
            case VisibleString:
            	{
                alt78 = 4;
                }
                break;
            case IA5String:
            	{
                alt78 = 5;
                }
                break;
            case TeletexString:
            	{
                alt78 = 6;
                }
                break;
            case VideotexString:
            	{
                alt78 = 7;
                }
                break;
            case GraphicString:
            	{
                alt78 = 8;
                }
                break;
            case GeneralString:
            	{
                alt78 = 9;
                }
                break;
            case UniversalString:
            	{
                alt78 = 10;
                }
                break;
            case BMPString:
            	{
                alt78 = 11;
                }
                break;
            case UTF8String:
            	{
                alt78 = 12;
                }
                break;
            case GeneralizedTime:
            	{
                alt78 = 13;
                }
                break;
            case UTCTime:
            	{
                alt78 = 14;
                }
                break;
            	default:
            	    NoViableAltException nvae_d78s0 =
            	        new NoViableAltException("390:1: stringType : ( OCTET STRING -> OCTECT_STING | NumericString | PrintableString | VisibleString | IA5String | TeletexString | VideotexString | GraphicString | GeneralString | UniversalString | BMPString | UTF8String | GeneralizedTime | UTCTime );", 78, 0, input);
            
            	    throw nvae_d78s0;
            }
            
            switch (alt78) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:391:3: OCTET STRING
                    {
                    	OCTET183 = (IToken)input.LT(1);
                    	Match(input,OCTET,FOLLOW_OCTET_in_stringType2506); 
                    	stream_OCTET.Add(OCTET183);

                    	STRING184 = (IToken)input.LT(1);
                    	Match(input,STRING,FOLLOW_STRING_in_stringType2508); 
                    	stream_STRING.Add(STRING184);

                    	
                    	// AST REWRITE
                    	// elements:          
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 391:16: -> OCTECT_STING
                    	{
                    	    adaptor.AddChild(root_0, adaptor.Create(OCTECT_STING, "OCTECT_STING"));
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:392:3: NumericString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	NumericString185 = (IToken)input.LT(1);
                    	Match(input,NumericString,FOLLOW_NumericString_in_stringType2516); 
                    	NumericString185_tree = (object)adaptor.Create(NumericString185);
                    	adaptor.AddChild(root_0, NumericString185_tree);

                    
                    }
                    break;
                case 3 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:393:3: PrintableString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PrintableString186 = (IToken)input.LT(1);
                    	Match(input,PrintableString,FOLLOW_PrintableString_in_stringType2520); 
                    	PrintableString186_tree = (object)adaptor.Create(PrintableString186);
                    	adaptor.AddChild(root_0, PrintableString186_tree);

                    
                    }
                    break;
                case 4 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:394:3: VisibleString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	VisibleString187 = (IToken)input.LT(1);
                    	Match(input,VisibleString,FOLLOW_VisibleString_in_stringType2524); 
                    	VisibleString187_tree = (object)adaptor.Create(VisibleString187);
                    	adaptor.AddChild(root_0, VisibleString187_tree);

                    
                    }
                    break;
                case 5 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:395:3: IA5String
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	IA5String188 = (IToken)input.LT(1);
                    	Match(input,IA5String,FOLLOW_IA5String_in_stringType2528); 
                    	IA5String188_tree = (object)adaptor.Create(IA5String188);
                    	adaptor.AddChild(root_0, IA5String188_tree);

                    
                    }
                    break;
                case 6 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:396:3: TeletexString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	TeletexString189 = (IToken)input.LT(1);
                    	Match(input,TeletexString,FOLLOW_TeletexString_in_stringType2532); 
                    	TeletexString189_tree = (object)adaptor.Create(TeletexString189);
                    	adaptor.AddChild(root_0, TeletexString189_tree);

                    
                    }
                    break;
                case 7 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:397:3: VideotexString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	VideotexString190 = (IToken)input.LT(1);
                    	Match(input,VideotexString,FOLLOW_VideotexString_in_stringType2536); 
                    	VideotexString190_tree = (object)adaptor.Create(VideotexString190);
                    	adaptor.AddChild(root_0, VideotexString190_tree);

                    
                    }
                    break;
                case 8 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:398:3: GraphicString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	GraphicString191 = (IToken)input.LT(1);
                    	Match(input,GraphicString,FOLLOW_GraphicString_in_stringType2540); 
                    	GraphicString191_tree = (object)adaptor.Create(GraphicString191);
                    	adaptor.AddChild(root_0, GraphicString191_tree);

                    
                    }
                    break;
                case 9 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:399:3: GeneralString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	GeneralString192 = (IToken)input.LT(1);
                    	Match(input,GeneralString,FOLLOW_GeneralString_in_stringType2544); 
                    	GeneralString192_tree = (object)adaptor.Create(GeneralString192);
                    	adaptor.AddChild(root_0, GeneralString192_tree);

                    
                    }
                    break;
                case 10 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:400:3: UniversalString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	UniversalString193 = (IToken)input.LT(1);
                    	Match(input,UniversalString,FOLLOW_UniversalString_in_stringType2548); 
                    	UniversalString193_tree = (object)adaptor.Create(UniversalString193);
                    	adaptor.AddChild(root_0, UniversalString193_tree);

                    
                    }
                    break;
                case 11 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:401:3: BMPString
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	BMPString194 = (IToken)input.LT(1);
                    	Match(input,BMPString,FOLLOW_BMPString_in_stringType2552); 
                    	BMPString194_tree = (object)adaptor.Create(BMPString194);
                    	adaptor.AddChild(root_0, BMPString194_tree);

                    
                    }
                    break;
                case 12 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:402:3: UTF8String
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	UTF8String195 = (IToken)input.LT(1);
                    	Match(input,UTF8String,FOLLOW_UTF8String_in_stringType2556); 
                    	UTF8String195_tree = (object)adaptor.Create(UTF8String195);
                    	adaptor.AddChild(root_0, UTF8String195_tree);

                    
                    }
                    break;
                case 13 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:403:3: GeneralizedTime
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	GeneralizedTime196 = (IToken)input.LT(1);
                    	Match(input,GeneralizedTime,FOLLOW_GeneralizedTime_in_stringType2560); 
                    	GeneralizedTime196_tree = (object)adaptor.Create(GeneralizedTime196);
                    	adaptor.AddChild(root_0, GeneralizedTime196_tree);

                    
                    }
                    break;
                case 14 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:404:3: UTCTime
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	UTCTime197 = (IToken)input.LT(1);
                    	Match(input,UTCTime,FOLLOW_UTCTime_in_stringType2564); 
                    	UTCTime197_tree = (object)adaptor.Create(UTCTime197);
                    	adaptor.AddChild(root_0, UTCTime197_tree);

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end stringType

    public class referencedType_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start referencedType
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:407:1: referencedType : str1= UID ( '.' str2= UID )? -> ^( REFERENCED_TYPE[$str1] $str1 ( $str2)? ) ;
    public referencedType_return referencedType() // throws RecognitionException [1]
    {   
        referencedType_return retval = new referencedType_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken str1 = null;
        IToken str2 = null;
        IToken char_literal198 = null;
        
        object str1_tree=null;
        object str2_tree=null;
        object char_literal198_tree=null;
        RewriteRuleTokenStream stream_UID = new RewriteRuleTokenStream(adaptor,"token UID");
        RewriteRuleTokenStream stream_DOT = new RewriteRuleTokenStream(adaptor,"token DOT");
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:408:2: (str1= UID ( '.' str2= UID )? -> ^( REFERENCED_TYPE[$str1] $str1 ( $str2)? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:408:4: str1= UID ( '.' str2= UID )?
            {
            	str1 = (IToken)input.LT(1);
            	Match(input,UID,FOLLOW_UID_in_referencedType2578); 
            	stream_UID.Add(str1);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:408:13: ( '.' str2= UID )?
            	int alt79 = 2;
            	int LA79_0 = input.LA(1);
            	
            	if ( (LA79_0 == DOT) )
            	{
            	    alt79 = 1;
            	}
            	switch (alt79) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:408:14: '.' str2= UID
            	        {
            	        	char_literal198 = (IToken)input.LT(1);
            	        	Match(input,DOT,FOLLOW_DOT_in_referencedType2581); 
            	        	stream_DOT.Add(char_literal198);

            	        	str2 = (IToken)input.LT(1);
            	        	Match(input,UID,FOLLOW_UID_in_referencedType2585); 
            	        	stream_UID.Add(str2);

            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          str1, str2
            	// token labels:      str2, str1
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_str2 = new RewriteRuleTokenStream(adaptor, "token str2", str2);
            	RewriteRuleTokenStream stream_str1 = new RewriteRuleTokenStream(adaptor, "token str1", str1);
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 408:29: -> ^( REFERENCED_TYPE[$str1] $str1 ( $str2)? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:408:32: ^( REFERENCED_TYPE[$str1] $str1 ( $str2)? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(REFERENCED_TYPE, str1), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_str1.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:408:63: ( $str2)?
            	    if ( stream_str2.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_str2.Next());
            	    
            	    }
            	    stream_str2.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end referencedType

    public class choiceValue_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start choiceValue
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:416:1: choiceValue : identifier a= ':' value -> ^( CHOICE_VALUE[$a] identifier value ) ;
    public choiceValue_return choiceValue() // throws RecognitionException [1]
    {   
        choiceValue_return retval = new choiceValue_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        identifier_return identifier199 = null;

        value_return value200 = null;
        
        
        object a_tree=null;
        RewriteRuleTokenStream stream_168 = new RewriteRuleTokenStream(adaptor,"token 168");
        RewriteRuleSubtreeStream stream_value = new RewriteRuleSubtreeStream(adaptor,"rule value");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:416:13: ( identifier a= ':' value -> ^( CHOICE_VALUE[$a] identifier value ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:416:15: identifier a= ':' value
            {
            	PushFollow(FOLLOW_identifier_in_choiceValue2621);
            	identifier199 = identifier();
            	followingStackPointer_--;
            	
            	stream_identifier.Add(identifier199.Tree);
            	a = (IToken)input.LT(1);
            	Match(input,168,FOLLOW_168_in_choiceValue2625); 
            	stream_168.Add(a);

            	PushFollow(FOLLOW_value_in_choiceValue2627);
            	value200 = value();
            	followingStackPointer_--;
            	
            	stream_value.Add(value200.Tree);
            	
            	// AST REWRITE
            	// elements:          value, identifier
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 416:38: -> ^( CHOICE_VALUE[$a] identifier value )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:416:40: ^( CHOICE_VALUE[$a] identifier value )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(CHOICE_VALUE, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_identifier.Next());
            	    adaptor.AddChild(root_1, stream_value.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end choiceValue

    public class namedValue_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start namedValue
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:419:1: namedValue : a= identifier value -> ^( NAMED_VALUE[a.start] identifier value ) ;
    public namedValue_return namedValue() // throws RecognitionException [1]
    {   
        namedValue_return retval = new namedValue_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        identifier_return a = null;

        value_return value201 = null;
        
        
        RewriteRuleSubtreeStream stream_value = new RewriteRuleSubtreeStream(adaptor,"rule value");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:419:13: (a= identifier value -> ^( NAMED_VALUE[a.start] identifier value ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:419:15: a= identifier value
            {
            	PushFollow(FOLLOW_identifier_in_namedValue2651);
            	a = identifier();
            	followingStackPointer_--;
            	
            	stream_identifier.Add(a.Tree);
            	PushFollow(FOLLOW_value_in_namedValue2653);
            	value201 = value();
            	followingStackPointer_--;
            	
            	stream_value.Add(value201.Tree);
            	
            	// AST REWRITE
            	// elements:          value, identifier
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 419:35: -> ^( NAMED_VALUE[a.start] identifier value )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:419:37: ^( NAMED_VALUE[a.start] identifier value )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(NAMED_VALUE, a.start), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_identifier.Next());
            	    adaptor.AddChild(root_1, stream_value.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end namedValue

    public class value_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start value
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:437:1: value : ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) );
    public value_return value() // throws RecognitionException [1]
    {   
        value_return retval = new value_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken mant = null;
        IToken bas = null;
        IToken exp = null;
        IToken BitStringLiteral202 = null;
        IToken OctectStringLiteral203 = null;
        IToken TRUE204 = null;
        IToken FALSE205 = null;
        IToken StringLiteral206 = null;
        IToken NULL207 = null;
        IToken PLUS_INFINITY208 = null;
        IToken MINUS_INFINITY209 = null;
        IToken INT210 = null;
        IToken FloatingPointLiteral211 = null;
        IToken R_BRACKET212 = null;
        IToken MANTISSA213 = null;
        IToken COMMA214 = null;
        IToken BASE215 = null;
        IToken COMMA216 = null;
        IToken EXPONENT217 = null;
        IToken R_BRACKET218 = null;
        IToken R_BRACKET220 = null;
        IToken COMMA223 = null;
        IToken R_BRACKET225 = null;
        IToken COMMA227 = null;
        IToken R_BRACKET229 = null;
        valuereference_return val = null;

        objectIdentifierComponent_return objectIdentifierComponent219 = null;

        choiceValue_return choiceValue221 = null;

        namedValue_return namedValue222 = null;

        namedValue_return namedValue224 = null;

        value_return value226 = null;

        value_return value228 = null;
        
        
        object a_tree=null;
        object mant_tree=null;
        object bas_tree=null;
        object exp_tree=null;
        object BitStringLiteral202_tree=null;
        object OctectStringLiteral203_tree=null;
        object TRUE204_tree=null;
        object FALSE205_tree=null;
        object StringLiteral206_tree=null;
        object NULL207_tree=null;
        object PLUS_INFINITY208_tree=null;
        object MINUS_INFINITY209_tree=null;
        object INT210_tree=null;
        object FloatingPointLiteral211_tree=null;
        object R_BRACKET212_tree=null;
        object MANTISSA213_tree=null;
        object COMMA214_tree=null;
        object BASE215_tree=null;
        object COMMA216_tree=null;
        object EXPONENT217_tree=null;
        object R_BRACKET218_tree=null;
        object R_BRACKET220_tree=null;
        object COMMA223_tree=null;
        object R_BRACKET225_tree=null;
        object COMMA227_tree=null;
        object R_BRACKET229_tree=null;
        RewriteRuleTokenStream stream_BASE = new RewriteRuleTokenStream(adaptor,"token BASE");
        RewriteRuleTokenStream stream_MANTISSA = new RewriteRuleTokenStream(adaptor,"token MANTISSA");
        RewriteRuleTokenStream stream_EXPONENT = new RewriteRuleTokenStream(adaptor,"token EXPONENT");
        RewriteRuleTokenStream stream_INT = new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_L_BRACKET = new RewriteRuleTokenStream(adaptor,"token L_BRACKET");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_R_BRACKET = new RewriteRuleTokenStream(adaptor,"token R_BRACKET");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_objectIdentifierComponent = new RewriteRuleSubtreeStream(adaptor,"rule objectIdentifierComponent");
        RewriteRuleSubtreeStream stream_value = new RewriteRuleSubtreeStream(adaptor,"rule value");
        RewriteRuleSubtreeStream stream_namedValue = new RewriteRuleSubtreeStream(adaptor,"rule namedValue");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:437:7: ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) )
            int alt83 = 17;
            switch ( input.LA(1) ) 
            {
            case BitStringLiteral:
            	{
                alt83 = 1;
                }
                break;
            case OctectStringLiteral:
            	{
                alt83 = 2;
                }
                break;
            case TRUE:
            	{
                alt83 = 3;
                }
                break;
            case FALSE:
            	{
                alt83 = 4;
                }
                break;
            case StringLiteral:
            	{
                alt83 = 5;
                }
                break;
            case NULL:
            	{
                alt83 = 6;
                }
                break;
            case PLUS_INFINITY:
            	{
                alt83 = 7;
                }
                break;
            case MINUS_INFINITY:
            	{
                alt83 = 8;
                }
                break;
            case LID:
            	{
                int LA83_9 = input.LA(2);
                
                if ( (LA83_9 == 168) )
                {
                    alt83 = 15;
                }
                else if ( (LA83_9 == R_BRACKET || LA83_9 == R_PAREN || LA83_9 == END || LA83_9 == COMMA || LA83_9 == UID || (LA83_9 >= UnionMark && LA83_9 <= DOUBLE_DOT) || LA83_9 == LID || LA83_9 == 165 || LA83_9 == 167 || LA83_9 == 169) )
                {
                    alt83 = 9;
                }
                else 
                {
                    NoViableAltException nvae_d83s9 =
                        new NoViableAltException("437:1: value : ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) );", 83, 9, input);
                
                    throw nvae_d83s9;
                }
                }
                break;
            case INT:
            	{
                alt83 = 10;
                }
                break;
            case FloatingPointLiteral:
            	{
                alt83 = 11;
                }
                break;
            case L_BRACKET:
            	{
                switch ( input.LA(2) ) 
                {
                case MANTISSA:
                	{
                    alt83 = 13;
                    }
                    break;
                case R_BRACKET:
                	{
                    alt83 = 12;
                    }
                    break;
                case LID:
                	{
                    switch ( input.LA(3) ) 
                    {
                    case L_PAREN:
                    case UID:
                    	{
                        alt83 = 14;
                        }
                        break;
                    case R_BRACKET:
                    	{
                        alt83 = 14;
                        }
                        break;
                    case LID:
                    	{
                        switch ( input.LA(4) ) 
                        {
                        case L_PAREN:
                        	{
                            alt83 = 14;
                            }
                            break;
                        case R_BRACKET:
                        case INT:
                        case LID:
                        	{
                            alt83 = 14;
                            }
                            break;
                        case UID:
                        	{
                            alt83 = 14;
                            }
                            break;
                        case COMMA:
                        case 168:
                        	{
                            alt83 = 16;
                            }
                            break;
                        	default:
                        	    NoViableAltException nvae_d83s22 =
                        	        new NoViableAltException("437:1: value : ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) );", 83, 22, input);
                        
                        	    throw nvae_d83s22;
                        }
                    
                        }
                        break;
                    case INT:
                    	{
                        switch ( input.LA(4) ) 
                        {
                        case COMMA:
                        	{
                            alt83 = 16;
                            }
                            break;
                        case R_BRACKET:
                        case INT:
                        case LID:
                        	{
                            alt83 = 14;
                            }
                            break;
                        case UID:
                        	{
                            alt83 = 14;
                            }
                            break;
                        	default:
                        	    NoViableAltException nvae_d83s23 =
                        	        new NoViableAltException("437:1: value : ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) );", 83, 23, input);
                        
                        	    throw nvae_d83s23;
                        }
                    
                        }
                        break;
                    case COMMA:
                    case 168:
                    	{
                        alt83 = 17;
                        }
                        break;
                    case L_BRACKET:
                    case NULL:
                    case BitStringLiteral:
                    case OctectStringLiteral:
                    case TRUE:
                    case FALSE:
                    case StringLiteral:
                    case PLUS_INFINITY:
                    case MINUS_INFINITY:
                    case FloatingPointLiteral:
                    	{
                        alt83 = 16;
                        }
                        break;
                    	default:
                    	    NoViableAltException nvae_d83s17 =
                    	        new NoViableAltException("437:1: value : ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) );", 83, 17, input);
                    
                    	    throw nvae_d83s17;
                    }
                
                    }
                    break;
                case INT:
                	{
                    switch ( input.LA(3) ) 
                    {
                    case R_BRACKET:
                    case INT:
                    case LID:
                    	{
                        alt83 = 14;
                        }
                        break;
                    case UID:
                    	{
                        alt83 = 14;
                        }
                        break;
                    case COMMA:
                    	{
                        alt83 = 17;
                        }
                        break;
                    	default:
                    	    NoViableAltException nvae_d83s18 =
                    	        new NoViableAltException("437:1: value : ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) );", 83, 18, input);
                    
                    	    throw nvae_d83s18;
                    }
                
                    }
                    break;
                case UID:
                	{
                    alt83 = 14;
                    }
                    break;
                case L_BRACKET:
                case NULL:
                case BitStringLiteral:
                case OctectStringLiteral:
                case TRUE:
                case FALSE:
                case StringLiteral:
                case PLUS_INFINITY:
                case MINUS_INFINITY:
                case FloatingPointLiteral:
                	{
                    alt83 = 17;
                    }
                    break;
                	default:
                	    NoViableAltException nvae_d83s12 =
                	        new NoViableAltException("437:1: value : ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) );", 83, 12, input);
                
                	    throw nvae_d83s12;
                }
            
                }
                break;
            	default:
            	    NoViableAltException nvae_d83s0 =
            	        new NoViableAltException("437:1: value : ( BitStringLiteral | OctectStringLiteral | TRUE | FALSE | StringLiteral | NULL | PLUS_INFINITY | MINUS_INFINITY | val= valuereference -> ^( VALUE_REFERENCE[val.start] $val) | INT | FloatingPointLiteral | a= L_BRACKET R_BRACKET -> ^( EMPTY_LIST[$a] ) | a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp) | a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ ) | choiceValue | a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ ) | a= L_BRACKET value ( COMMA value )* R_BRACKET -> ^( VALUE_LIST[$a] ( value )+ ) );", 83, 0, input);
            
            	    throw nvae_d83s0;
            }
            
            switch (alt83) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:438:3: BitStringLiteral
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	BitStringLiteral202 = (IToken)input.LT(1);
                    	Match(input,BitStringLiteral,FOLLOW_BitStringLiteral_in_value2684); 
                    	BitStringLiteral202_tree = (object)adaptor.Create(BitStringLiteral202);
                    	adaptor.AddChild(root_0, BitStringLiteral202_tree);

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:440:4: OctectStringLiteral
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	OctectStringLiteral203 = (IToken)input.LT(1);
                    	Match(input,OctectStringLiteral,FOLLOW_OctectStringLiteral_in_value2690); 
                    	OctectStringLiteral203_tree = (object)adaptor.Create(OctectStringLiteral203);
                    	adaptor.AddChild(root_0, OctectStringLiteral203_tree);

                    
                    }
                    break;
                case 3 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:441:4: TRUE
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	TRUE204 = (IToken)input.LT(1);
                    	Match(input,TRUE,FOLLOW_TRUE_in_value2695); 
                    	TRUE204_tree = (object)adaptor.Create(TRUE204);
                    	adaptor.AddChild(root_0, TRUE204_tree);

                    
                    }
                    break;
                case 4 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:442:4: FALSE
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	FALSE205 = (IToken)input.LT(1);
                    	Match(input,FALSE,FOLLOW_FALSE_in_value2700); 
                    	FALSE205_tree = (object)adaptor.Create(FALSE205);
                    	adaptor.AddChild(root_0, FALSE205_tree);

                    
                    }
                    break;
                case 5 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:443:4: StringLiteral
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	StringLiteral206 = (IToken)input.LT(1);
                    	Match(input,StringLiteral,FOLLOW_StringLiteral_in_value2705); 
                    	StringLiteral206_tree = (object)adaptor.Create(StringLiteral206);
                    	adaptor.AddChild(root_0, StringLiteral206_tree);

                    
                    }
                    break;
                case 6 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:444:4: NULL
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	NULL207 = (IToken)input.LT(1);
                    	Match(input,NULL,FOLLOW_NULL_in_value2710); 
                    	NULL207_tree = (object)adaptor.Create(NULL207);
                    	adaptor.AddChild(root_0, NULL207_tree);

                    
                    }
                    break;
                case 7 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:445:4: PLUS_INFINITY
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PLUS_INFINITY208 = (IToken)input.LT(1);
                    	Match(input,PLUS_INFINITY,FOLLOW_PLUS_INFINITY_in_value2715); 
                    	PLUS_INFINITY208_tree = (object)adaptor.Create(PLUS_INFINITY208);
                    	adaptor.AddChild(root_0, PLUS_INFINITY208_tree);

                    
                    }
                    break;
                case 8 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:446:6: MINUS_INFINITY
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	MINUS_INFINITY209 = (IToken)input.LT(1);
                    	Match(input,MINUS_INFINITY,FOLLOW_MINUS_INFINITY_in_value2722); 
                    	MINUS_INFINITY209_tree = (object)adaptor.Create(MINUS_INFINITY209);
                    	adaptor.AddChild(root_0, MINUS_INFINITY209_tree);

                    
                    }
                    break;
                case 9 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:447:4: val= valuereference
                    {
                    	PushFollow(FOLLOW_valuereference_in_value2729);
                    	val = valuereference();
                    	followingStackPointer_--;
                    	
                    	stream_valuereference.Add(val.Tree);
                    	
                    	// AST REWRITE
                    	// elements:          val
                    	// token labels:      
                    	// rule labels:       val, retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_val = new RewriteRuleSubtreeStream(adaptor, "token val", (val!=null ? val.Tree : null));
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 447:32: -> ^( VALUE_REFERENCE[val.start] $val)
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:447:34: ^( VALUE_REFERENCE[val.start] $val)
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(VALUE_REFERENCE, val.start), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_val.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 10 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:448:6: INT
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	INT210 = (IToken)input.LT(1);
                    	Match(input,INT,FOLLOW_INT_in_value2754); 
                    	INT210_tree = (object)adaptor.Create(INT210);
                    	adaptor.AddChild(root_0, INT210_tree);

                    
                    }
                    break;
                case 11 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:449:5: FloatingPointLiteral
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	FloatingPointLiteral211 = (IToken)input.LT(1);
                    	Match(input,FloatingPointLiteral,FOLLOW_FloatingPointLiteral_in_value2760); 
                    	FloatingPointLiteral211_tree = (object)adaptor.Create(FloatingPointLiteral211);
                    	adaptor.AddChild(root_0, FloatingPointLiteral211_tree);

                    
                    }
                    break;
                case 12 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:451:4: a= L_BRACKET R_BRACKET
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_value2768); 
                    	stream_L_BRACKET.Add(a);

                    	R_BRACKET212 = (IToken)input.LT(1);
                    	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_value2770); 
                    	stream_R_BRACKET.Add(R_BRACKET212);

                    	
                    	// AST REWRITE
                    	// elements:          
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 451:35: -> ^( EMPTY_LIST[$a] )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:451:38: ^( EMPTY_LIST[$a] )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(EMPTY_LIST, a), root_1);
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 13 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:452:4: a= L_BRACKET MANTISSA mant= INT COMMA BASE bas= INT COMMA EXPONENT exp= INT R_BRACKET
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_value2794); 
                    	stream_L_BRACKET.Add(a);

                    	MANTISSA213 = (IToken)input.LT(1);
                    	Match(input,MANTISSA,FOLLOW_MANTISSA_in_value2796); 
                    	stream_MANTISSA.Add(MANTISSA213);

                    	mant = (IToken)input.LT(1);
                    	Match(input,INT,FOLLOW_INT_in_value2800); 
                    	stream_INT.Add(mant);

                    	COMMA214 = (IToken)input.LT(1);
                    	Match(input,COMMA,FOLLOW_COMMA_in_value2802); 
                    	stream_COMMA.Add(COMMA214);

                    	BASE215 = (IToken)input.LT(1);
                    	Match(input,BASE,FOLLOW_BASE_in_value2804); 
                    	stream_BASE.Add(BASE215);

                    	bas = (IToken)input.LT(1);
                    	Match(input,INT,FOLLOW_INT_in_value2808); 
                    	stream_INT.Add(bas);

                    	COMMA216 = (IToken)input.LT(1);
                    	Match(input,COMMA,FOLLOW_COMMA_in_value2810); 
                    	stream_COMMA.Add(COMMA216);

                    	EXPONENT217 = (IToken)input.LT(1);
                    	Match(input,EXPONENT,FOLLOW_EXPONENT_in_value2812); 
                    	stream_EXPONENT.Add(EXPONENT217);

                    	exp = (IToken)input.LT(1);
                    	Match(input,INT,FOLLOW_INT_in_value2816); 
                    	stream_INT.Add(exp);

                    	R_BRACKET218 = (IToken)input.LT(1);
                    	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_value2818); 
                    	stream_R_BRACKET.Add(R_BRACKET218);

                    	
                    	// AST REWRITE
                    	// elements:          exp, bas, mant
                    	// token labels:      exp, mant, bas
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleTokenStream stream_exp = new RewriteRuleTokenStream(adaptor, "token exp", exp);
                    	RewriteRuleTokenStream stream_mant = new RewriteRuleTokenStream(adaptor, "token mant", mant);
                    	RewriteRuleTokenStream stream_bas = new RewriteRuleTokenStream(adaptor, "token bas", bas);
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 452:86: -> ^( NUMERIC_VALUE2[$a] $mant $bas $exp)
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:452:89: ^( NUMERIC_VALUE2[$a] $mant $bas $exp)
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(NUMERIC_VALUE2, a), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_mant.Next());
                    	    adaptor.AddChild(root_1, stream_bas.Next());
                    	    adaptor.AddChild(root_1, stream_exp.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 14 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:454:4: a= L_BRACKET ( objectIdentifierComponent )+ R_BRACKET
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_value2842); 
                    	stream_L_BRACKET.Add(a);

                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:454:16: ( objectIdentifierComponent )+
                    	int cnt80 = 0;
                    	do 
                    	{
                    	    int alt80 = 2;
                    	    int LA80_0 = input.LA(1);
                    	    
                    	    if ( (LA80_0 == INT || LA80_0 == UID || LA80_0 == LID) )
                    	    {
                    	        alt80 = 1;
                    	    }
                    	    
                    	
                    	    switch (alt80) 
                    		{
                    			case 1 :
                    			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:454:16: objectIdentifierComponent
                    			    {
                    			    	PushFollow(FOLLOW_objectIdentifierComponent_in_value2844);
                    			    	objectIdentifierComponent219 = objectIdentifierComponent();
                    			    	followingStackPointer_--;
                    			    	
                    			    	stream_objectIdentifierComponent.Add(objectIdentifierComponent219.Tree);
                    			    
                    			    }
                    			    break;
                    	
                    			default:
                    			    if ( cnt80 >= 1 ) goto loop80;
                    		            EarlyExitException eee =
                    		                new EarlyExitException(80, input);
                    		            throw eee;
                    	    }
                    	    cnt80++;
                    	} while (true);
                    	
                    	loop80:
                    		;	// Stops C# compiler whinging that label 'loop80' has no statements

                    	R_BRACKET220 = (IToken)input.LT(1);
                    	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_value2847); 
                    	stream_R_BRACKET.Add(R_BRACKET220);

                    	
                    	// AST REWRITE
                    	// elements:          objectIdentifierComponent
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 454:54: -> ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:454:56: ^( OBJECT_ID_VALUE[$a] ( objectIdentifierComponent )+ )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(OBJECT_ID_VALUE, a), root_1);
                    	    
                    	    if ( !(stream_objectIdentifierComponent.HasNext()) ) {
                    	        throw new RewriteEarlyExitException();
                    	    }
                    	    while ( stream_objectIdentifierComponent.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_objectIdentifierComponent.Next());
                    	    
                    	    }
                    	    stream_objectIdentifierComponent.Reset();
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 15 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:455:6: choiceValue
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_choiceValue_in_value2865);
                    	choiceValue221 = choiceValue();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, choiceValue221.Tree);
                    
                    }
                    break;
                case 16 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:456:4: a= L_BRACKET namedValue ( COMMA namedValue )* R_BRACKET
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_value2872); 
                    	stream_L_BRACKET.Add(a);

                    	PushFollow(FOLLOW_namedValue_in_value2874);
                    	namedValue222 = namedValue();
                    	followingStackPointer_--;
                    	
                    	stream_namedValue.Add(namedValue222.Tree);
                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:456:27: ( COMMA namedValue )*
                    	do 
                    	{
                    	    int alt81 = 2;
                    	    int LA81_0 = input.LA(1);
                    	    
                    	    if ( (LA81_0 == COMMA) )
                    	    {
                    	        alt81 = 1;
                    	    }
                    	    
                    	
                    	    switch (alt81) 
                    		{
                    			case 1 :
                    			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:456:28: COMMA namedValue
                    			    {
                    			    	COMMA223 = (IToken)input.LT(1);
                    			    	Match(input,COMMA,FOLLOW_COMMA_in_value2877); 
                    			    	stream_COMMA.Add(COMMA223);

                    			    	PushFollow(FOLLOW_namedValue_in_value2879);
                    			    	namedValue224 = namedValue();
                    			    	followingStackPointer_--;
                    			    	
                    			    	stream_namedValue.Add(namedValue224.Tree);
                    			    
                    			    }
                    			    break;
                    	
                    			default:
                    			    goto loop81;
                    	    }
                    	} while (true);
                    	
                    	loop81:
                    		;	// Stops C# compiler whinging that label 'loop81' has no statements

                    	R_BRACKET225 = (IToken)input.LT(1);
                    	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_value2883); 
                    	stream_R_BRACKET.Add(R_BRACKET225);

                    	
                    	// AST REWRITE
                    	// elements:          namedValue
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 456:61: -> ^( NAMED_VALUE_LIST[$a] ( namedValue )+ )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:456:63: ^( NAMED_VALUE_LIST[$a] ( namedValue )+ )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(NAMED_VALUE_LIST, a), root_1);
                    	    
                    	    if ( !(stream_namedValue.HasNext()) ) {
                    	        throw new RewriteEarlyExitException();
                    	    }
                    	    while ( stream_namedValue.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_namedValue.Next());
                    	    
                    	    }
                    	    stream_namedValue.Reset();
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 17 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:457:4: a= L_BRACKET value ( COMMA value )* R_BRACKET
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_value2903); 
                    	stream_L_BRACKET.Add(a);

                    	PushFollow(FOLLOW_value_in_value2905);
                    	value226 = value();
                    	followingStackPointer_--;
                    	
                    	stream_value.Add(value226.Tree);
                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:457:22: ( COMMA value )*
                    	do 
                    	{
                    	    int alt82 = 2;
                    	    int LA82_0 = input.LA(1);
                    	    
                    	    if ( (LA82_0 == COMMA) )
                    	    {
                    	        alt82 = 1;
                    	    }
                    	    
                    	
                    	    switch (alt82) 
                    		{
                    			case 1 :
                    			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:457:23: COMMA value
                    			    {
                    			    	COMMA227 = (IToken)input.LT(1);
                    			    	Match(input,COMMA,FOLLOW_COMMA_in_value2908); 
                    			    	stream_COMMA.Add(COMMA227);

                    			    	PushFollow(FOLLOW_value_in_value2910);
                    			    	value228 = value();
                    			    	followingStackPointer_--;
                    			    	
                    			    	stream_value.Add(value228.Tree);
                    			    
                    			    }
                    			    break;
                    	
                    			default:
                    			    goto loop82;
                    	    }
                    	} while (true);
                    	
                    	loop82:
                    		;	// Stops C# compiler whinging that label 'loop82' has no statements

                    	R_BRACKET229 = (IToken)input.LT(1);
                    	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_value2914); 
                    	stream_R_BRACKET.Add(R_BRACKET229);

                    	
                    	// AST REWRITE
                    	// elements:          value
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 457:52: -> ^( VALUE_LIST[$a] ( value )+ )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:457:54: ^( VALUE_LIST[$a] ( value )+ )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(VALUE_LIST, a), root_1);
                    	    
                    	    if ( !(stream_value.HasNext()) ) {
                    	        throw new RewriteEarlyExitException();
                    	    }
                    	    while ( stream_value.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_value.Next());
                    	    
                    	    }
                    	    stream_value.Reset();
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end value

    public class objectIdentifierComponent_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start objectIdentifierComponent
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:467:1: objectIdentifierComponent : ( identifier ( L_PAREN ( INT | definedValue ) R_PAREN )? -> ^( OBJ_LST_ITEM1 identifier ( INT )? ( definedValue )? ) | a= INT -> ^( OBJ_LST_ITEM2[$a] INT ) | modulereference '.' valuereference -> ^( DEFINED_VALUE modulereference valuereference ) );
    public objectIdentifierComponent_return objectIdentifierComponent() // throws RecognitionException [1]
    {   
        objectIdentifierComponent_return retval = new objectIdentifierComponent_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken L_PAREN231 = null;
        IToken INT232 = null;
        IToken R_PAREN234 = null;
        IToken char_literal236 = null;
        identifier_return identifier230 = null;

        definedValue_return definedValue233 = null;

        modulereference_return modulereference235 = null;

        valuereference_return valuereference237 = null;
        
        
        object a_tree=null;
        object L_PAREN231_tree=null;
        object INT232_tree=null;
        object R_PAREN234_tree=null;
        object char_literal236_tree=null;
        RewriteRuleTokenStream stream_INT = new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_DOT = new RewriteRuleTokenStream(adaptor,"token DOT");
        RewriteRuleTokenStream stream_R_PAREN = new RewriteRuleTokenStream(adaptor,"token R_PAREN");
        RewriteRuleTokenStream stream_L_PAREN = new RewriteRuleTokenStream(adaptor,"token L_PAREN");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_definedValue = new RewriteRuleSubtreeStream(adaptor,"rule definedValue");
        RewriteRuleSubtreeStream stream_modulereference = new RewriteRuleSubtreeStream(adaptor,"rule modulereference");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:2: ( identifier ( L_PAREN ( INT | definedValue ) R_PAREN )? -> ^( OBJ_LST_ITEM1 identifier ( INT )? ( definedValue )? ) | a= INT -> ^( OBJ_LST_ITEM2[$a] INT ) | modulereference '.' valuereference -> ^( DEFINED_VALUE modulereference valuereference ) )
            int alt86 = 3;
            switch ( input.LA(1) ) 
            {
            case LID:
            	{
                alt86 = 1;
                }
                break;
            case INT:
            	{
                alt86 = 2;
                }
                break;
            case UID:
            	{
                alt86 = 3;
                }
                break;
            	default:
            	    NoViableAltException nvae_d86s0 =
            	        new NoViableAltException("467:1: objectIdentifierComponent : ( identifier ( L_PAREN ( INT | definedValue ) R_PAREN )? -> ^( OBJ_LST_ITEM1 identifier ( INT )? ( definedValue )? ) | a= INT -> ^( OBJ_LST_ITEM2[$a] INT ) | modulereference '.' valuereference -> ^( DEFINED_VALUE modulereference valuereference ) );", 86, 0, input);
            
            	    throw nvae_d86s0;
            }
            
            switch (alt86) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:4: identifier ( L_PAREN ( INT | definedValue ) R_PAREN )?
                    {
                    	PushFollow(FOLLOW_identifier_in_objectIdentifierComponent2947);
                    	identifier230 = identifier();
                    	followingStackPointer_--;
                    	
                    	stream_identifier.Add(identifier230.Tree);
                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:15: ( L_PAREN ( INT | definedValue ) R_PAREN )?
                    	int alt85 = 2;
                    	int LA85_0 = input.LA(1);
                    	
                    	if ( (LA85_0 == L_PAREN) )
                    	{
                    	    alt85 = 1;
                    	}
                    	switch (alt85) 
                    	{
                    	    case 1 :
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:17: L_PAREN ( INT | definedValue ) R_PAREN
                    	        {
                    	        	L_PAREN231 = (IToken)input.LT(1);
                    	        	Match(input,L_PAREN,FOLLOW_L_PAREN_in_objectIdentifierComponent2951); 
                    	        	stream_L_PAREN.Add(L_PAREN231);

                    	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:25: ( INT | definedValue )
                    	        	int alt84 = 2;
                    	        	int LA84_0 = input.LA(1);
                    	        	
                    	        	if ( (LA84_0 == INT) )
                    	        	{
                    	        	    alt84 = 1;
                    	        	}
                    	        	else if ( (LA84_0 == UID || LA84_0 == LID) )
                    	        	{
                    	        	    alt84 = 2;
                    	        	}
                    	        	else 
                    	        	{
                    	        	    NoViableAltException nvae_d84s0 =
                    	        	        new NoViableAltException("468:25: ( INT | definedValue )", 84, 0, input);
                    	        	
                    	        	    throw nvae_d84s0;
                    	        	}
                    	        	switch (alt84) 
                    	        	{
                    	        	    case 1 :
                    	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:26: INT
                    	        	        {
                    	        	        	INT232 = (IToken)input.LT(1);
                    	        	        	Match(input,INT,FOLLOW_INT_in_objectIdentifierComponent2954); 
                    	        	        	stream_INT.Add(INT232);

                    	        	        
                    	        	        }
                    	        	        break;
                    	        	    case 2 :
                    	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:32: definedValue
                    	        	        {
                    	        	        	PushFollow(FOLLOW_definedValue_in_objectIdentifierComponent2958);
                    	        	        	definedValue233 = definedValue();
                    	        	        	followingStackPointer_--;
                    	        	        	
                    	        	        	stream_definedValue.Add(definedValue233.Tree);
                    	        	        
                    	        	        }
                    	        	        break;
                    	        	
                    	        	}

                    	        	R_PAREN234 = (IToken)input.LT(1);
                    	        	Match(input,R_PAREN,FOLLOW_R_PAREN_in_objectIdentifierComponent2961); 
                    	        	stream_R_PAREN.Add(R_PAREN234);

                    	        
                    	        }
                    	        break;
                    	
                    	}

                    	
                    	// AST REWRITE
                    	// elements:          INT, definedValue, identifier
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 468:57: -> ^( OBJ_LST_ITEM1 identifier ( INT )? ( definedValue )? )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:59: ^( OBJ_LST_ITEM1 identifier ( INT )? ( definedValue )? )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(OBJ_LST_ITEM1, "OBJ_LST_ITEM1"), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_identifier.Next());
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:86: ( INT )?
                    	    if ( stream_INT.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_INT.Next());
                    	    
                    	    }
                    	    stream_INT.Reset();
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:468:91: ( definedValue )?
                    	    if ( stream_definedValue.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_definedValue.Next());
                    	    
                    	    }
                    	    stream_definedValue.Reset();
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:469:5: a= INT
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,INT,FOLLOW_INT_in_objectIdentifierComponent2986); 
                    	stream_INT.Add(a);

                    	
                    	// AST REWRITE
                    	// elements:          INT
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 469:21: -> ^( OBJ_LST_ITEM2[$a] INT )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:469:23: ^( OBJ_LST_ITEM2[$a] INT )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(OBJ_LST_ITEM2, a), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_INT.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 3 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:470:4: modulereference '.' valuereference
                    {
                    	PushFollow(FOLLOW_modulereference_in_objectIdentifierComponent3009);
                    	modulereference235 = modulereference();
                    	followingStackPointer_--;
                    	
                    	stream_modulereference.Add(modulereference235.Tree);
                    	char_literal236 = (IToken)input.LT(1);
                    	Match(input,DOT,FOLLOW_DOT_in_objectIdentifierComponent3011); 
                    	stream_DOT.Add(char_literal236);

                    	PushFollow(FOLLOW_valuereference_in_objectIdentifierComponent3013);
                    	valuereference237 = valuereference();
                    	followingStackPointer_--;
                    	
                    	stream_valuereference.Add(valuereference237.Tree);
                    	
                    	// AST REWRITE
                    	// elements:          valuereference, modulereference
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 470:41: -> ^( DEFINED_VALUE modulereference valuereference )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:470:43: ^( DEFINED_VALUE modulereference valuereference )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(DEFINED_VALUE, "DEFINED_VALUE"), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_modulereference.Next());
                    	    adaptor.AddChild(root_1, stream_valuereference.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end objectIdentifierComponent

    public class definedValue_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start definedValue
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:474:1: definedValue : ( valuereference -> ^( DEFINED_VALUE valuereference ) | modulereference '.' valuereference -> ^( DEFINED_VALUE modulereference valuereference ) );
    public definedValue_return definedValue() // throws RecognitionException [1]
    {   
        definedValue_return retval = new definedValue_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken char_literal240 = null;
        valuereference_return valuereference238 = null;

        modulereference_return modulereference239 = null;

        valuereference_return valuereference241 = null;
        
        
        object char_literal240_tree=null;
        RewriteRuleTokenStream stream_DOT = new RewriteRuleTokenStream(adaptor,"token DOT");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_modulereference = new RewriteRuleSubtreeStream(adaptor,"rule modulereference");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:475:2: ( valuereference -> ^( DEFINED_VALUE valuereference ) | modulereference '.' valuereference -> ^( DEFINED_VALUE modulereference valuereference ) )
            int alt87 = 2;
            int LA87_0 = input.LA(1);
            
            if ( (LA87_0 == LID) )
            {
                alt87 = 1;
            }
            else if ( (LA87_0 == UID) )
            {
                alt87 = 2;
            }
            else 
            {
                NoViableAltException nvae_d87s0 =
                    new NoViableAltException("474:1: definedValue : ( valuereference -> ^( DEFINED_VALUE valuereference ) | modulereference '.' valuereference -> ^( DEFINED_VALUE modulereference valuereference ) );", 87, 0, input);
            
                throw nvae_d87s0;
            }
            switch (alt87) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:475:4: valuereference
                    {
                    	PushFollow(FOLLOW_valuereference_in_definedValue3036);
                    	valuereference238 = valuereference();
                    	followingStackPointer_--;
                    	
                    	stream_valuereference.Add(valuereference238.Tree);
                    	
                    	// AST REWRITE
                    	// elements:          valuereference
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 475:25: -> ^( DEFINED_VALUE valuereference )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:475:28: ^( DEFINED_VALUE valuereference )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(DEFINED_VALUE, "DEFINED_VALUE"), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_valuereference.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:476:5: modulereference '.' valuereference
                    {
                    	PushFollow(FOLLOW_modulereference_in_definedValue3056);
                    	modulereference239 = modulereference();
                    	followingStackPointer_--;
                    	
                    	stream_modulereference.Add(modulereference239.Tree);
                    	char_literal240 = (IToken)input.LT(1);
                    	Match(input,DOT,FOLLOW_DOT_in_definedValue3058); 
                    	stream_DOT.Add(char_literal240);

                    	PushFollow(FOLLOW_valuereference_in_definedValue3060);
                    	valuereference241 = valuereference();
                    	followingStackPointer_--;
                    	
                    	stream_valuereference.Add(valuereference241.Tree);
                    	
                    	// AST REWRITE
                    	// elements:          valuereference, modulereference
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 476:40: -> ^( DEFINED_VALUE modulereference valuereference )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:476:43: ^( DEFINED_VALUE modulereference valuereference )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(DEFINED_VALUE, "DEFINED_VALUE"), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_modulereference.Next());
                    	    adaptor.AddChild(root_1, stream_valuereference.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end definedValue

    public class constraint_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start constraint
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:482:1: constraint : a= L_PAREN uset1= unionSet ( COMMA extMark= EXT_MARK ( COMMA uset2= unionSet )? )? ( exceptionSpec )? R_PAREN -> ^( CONSTRAINT[$a] $uset1 ( $extMark)? ( $uset2)? ( exceptionSpec )? ) ;
    public constraint_return constraint() // throws RecognitionException [1]
    {   
        constraint_return retval = new constraint_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken extMark = null;
        IToken COMMA242 = null;
        IToken COMMA243 = null;
        IToken R_PAREN245 = null;
        unionSet_return uset1 = null;

        unionSet_return uset2 = null;

        exceptionSpec_return exceptionSpec244 = null;
        
        
        object a_tree=null;
        object extMark_tree=null;
        object COMMA242_tree=null;
        object COMMA243_tree=null;
        object R_PAREN245_tree=null;
        RewriteRuleTokenStream stream_EXT_MARK = new RewriteRuleTokenStream(adaptor,"token EXT_MARK");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_R_PAREN = new RewriteRuleTokenStream(adaptor,"token R_PAREN");
        RewriteRuleTokenStream stream_L_PAREN = new RewriteRuleTokenStream(adaptor,"token L_PAREN");
        RewriteRuleSubtreeStream stream_unionSet = new RewriteRuleSubtreeStream(adaptor,"rule unionSet");
        RewriteRuleSubtreeStream stream_exceptionSpec = new RewriteRuleSubtreeStream(adaptor,"rule exceptionSpec");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:483:2: (a= L_PAREN uset1= unionSet ( COMMA extMark= EXT_MARK ( COMMA uset2= unionSet )? )? ( exceptionSpec )? R_PAREN -> ^( CONSTRAINT[$a] $uset1 ( $extMark)? ( $uset2)? ( exceptionSpec )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:483:4: a= L_PAREN uset1= unionSet ( COMMA extMark= EXT_MARK ( COMMA uset2= unionSet )? )? ( exceptionSpec )? R_PAREN
            {
            	a = (IToken)input.LT(1);
            	Match(input,L_PAREN,FOLLOW_L_PAREN_in_constraint3090); 
            	stream_L_PAREN.Add(a);

            	PushFollow(FOLLOW_unionSet_in_constraint3094);
            	uset1 = unionSet();
            	followingStackPointer_--;
            	
            	stream_unionSet.Add(uset1.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:483:29: ( COMMA extMark= EXT_MARK ( COMMA uset2= unionSet )? )?
            	int alt89 = 2;
            	int LA89_0 = input.LA(1);
            	
            	if ( (LA89_0 == COMMA) )
            	{
            	    alt89 = 1;
            	}
            	switch (alt89) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:483:30: COMMA extMark= EXT_MARK ( COMMA uset2= unionSet )?
            	        {
            	        	COMMA242 = (IToken)input.LT(1);
            	        	Match(input,COMMA,FOLLOW_COMMA_in_constraint3097); 
            	        	stream_COMMA.Add(COMMA242);

            	        	extMark = (IToken)input.LT(1);
            	        	Match(input,EXT_MARK,FOLLOW_EXT_MARK_in_constraint3101); 
            	        	stream_EXT_MARK.Add(extMark);

            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:483:53: ( COMMA uset2= unionSet )?
            	        	int alt88 = 2;
            	        	int LA88_0 = input.LA(1);
            	        	
            	        	if ( (LA88_0 == COMMA) )
            	        	{
            	        	    alt88 = 1;
            	        	}
            	        	switch (alt88) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:483:55: COMMA uset2= unionSet
            	        	        {
            	        	        	COMMA243 = (IToken)input.LT(1);
            	        	        	Match(input,COMMA,FOLLOW_COMMA_in_constraint3105); 
            	        	        	stream_COMMA.Add(COMMA243);

            	        	        	PushFollow(FOLLOW_unionSet_in_constraint3109);
            	        	        	uset2 = unionSet();
            	        	        	followingStackPointer_--;
            	        	        	
            	        	        	stream_unionSet.Add(uset2.Tree);
            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:483:81: ( exceptionSpec )?
            	int alt90 = 2;
            	int LA90_0 = input.LA(1);
            	
            	if ( (LA90_0 == 169) )
            	{
            	    alt90 = 1;
            	}
            	switch (alt90) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:483:81: exceptionSpec
            	        {
            	        	PushFollow(FOLLOW_exceptionSpec_in_constraint3116);
            	        	exceptionSpec244 = exceptionSpec();
            	        	followingStackPointer_--;
            	        	
            	        	stream_exceptionSpec.Add(exceptionSpec244.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	R_PAREN245 = (IToken)input.LT(1);
            	Match(input,R_PAREN,FOLLOW_R_PAREN_in_constraint3119); 
            	stream_R_PAREN.Add(R_PAREN245);

            	
            	// AST REWRITE
            	// elements:          uset1, extMark, exceptionSpec, uset2
            	// token labels:      extMark
            	// rule labels:       retval, uset1, uset2
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_extMark = new RewriteRuleTokenStream(adaptor, "token extMark", extMark);
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	RewriteRuleSubtreeStream stream_uset1 = new RewriteRuleSubtreeStream(adaptor, "token uset1", (uset1!=null ? uset1.Tree : null));
            	RewriteRuleSubtreeStream stream_uset2 = new RewriteRuleSubtreeStream(adaptor, "token uset2", (uset2!=null ? uset2.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 484:7: -> ^( CONSTRAINT[$a] $uset1 ( $extMark)? ( $uset2)? ( exceptionSpec )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:484:9: ^( CONSTRAINT[$a] $uset1 ( $extMark)? ( $uset2)? ( exceptionSpec )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(CONSTRAINT, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_uset1.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:484:33: ( $extMark)?
            	    if ( stream_extMark.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_extMark.Next());
            	    
            	    }
            	    stream_extMark.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:484:43: ( $uset2)?
            	    if ( stream_uset2.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_uset2.Next());
            	    
            	    }
            	    stream_uset2.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:484:52: ( exceptionSpec )?
            	    if ( stream_exceptionSpec.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_exceptionSpec.Next());
            	    
            	    }
            	    stream_exceptionSpec.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end constraint

    public class exceptionSpec_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start exceptionSpec
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:487:1: exceptionSpec : '!' ( INT -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_CONST_INT INT ) ) | val= valuereference -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) ) ) | type ':' value -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_TYPE_VALUE type value ) ) ) ;
    public exceptionSpec_return exceptionSpec() // throws RecognitionException [1]
    {   
        exceptionSpec_return retval = new exceptionSpec_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken char_literal246 = null;
        IToken INT247 = null;
        IToken char_literal249 = null;
        valuereference_return val = null;

        type_return type248 = null;

        value_return value250 = null;
        
        
        object char_literal246_tree=null;
        object INT247_tree=null;
        object char_literal249_tree=null;
        RewriteRuleTokenStream stream_INT = new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_169 = new RewriteRuleTokenStream(adaptor,"token 169");
        RewriteRuleTokenStream stream_168 = new RewriteRuleTokenStream(adaptor,"token 168");
        RewriteRuleSubtreeStream stream_valuereference = new RewriteRuleSubtreeStream(adaptor,"rule valuereference");
        RewriteRuleSubtreeStream stream_value = new RewriteRuleSubtreeStream(adaptor,"rule value");
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:488:2: ( '!' ( INT -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_CONST_INT INT ) ) | val= valuereference -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) ) ) | type ':' value -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_TYPE_VALUE type value ) ) ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:488:4: '!' ( INT -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_CONST_INT INT ) ) | val= valuereference -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) ) ) | type ':' value -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_TYPE_VALUE type value ) ) )
            {
            	char_literal246 = (IToken)input.LT(1);
            	Match(input,169,FOLLOW_169_in_exceptionSpec3161); 
            	stream_169.Add(char_literal246);

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:489:2: ( INT -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_CONST_INT INT ) ) | val= valuereference -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) ) ) | type ':' value -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_TYPE_VALUE type value ) ) )
            	int alt91 = 3;
            	switch ( input.LA(1) ) 
            	{
            	case INT:
            		{
            	    alt91 = 1;
            	    }
            	    break;
            	case LID:
            		{
            	    int LA91_2 = input.LA(2);
            	    
            	    if ( (LA91_2 == R_BRACKET || LA91_2 == R_PAREN || LA91_2 == COMMA) )
            	    {
            	        alt91 = 2;
            	    }
            	    else if ( (LA91_2 == 165) )
            	    {
            	        alt91 = 3;
            	    }
            	    else 
            	    {
            	        NoViableAltException nvae_d91s2 =
            	            new NoViableAltException("489:2: ( INT -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_CONST_INT INT ) ) | val= valuereference -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) ) ) | type ':' value -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_TYPE_VALUE type value ) ) )", 91, 2, input);
            	    
            	        throw nvae_d91s2;
            	    }
            	    }
            	    break;
            	case NULL:
            	case BIT:
            	case BOOLEAN:
            	case ENUMERATED:
            	case INTEGER:
            	case REAL:
            	case CHOICE:
            	case SEQUENCE:
            	case SET:
            	case OCTET:
            	case NumericString:
            	case PrintableString:
            	case VisibleString:
            	case IA5String:
            	case TeletexString:
            	case VideotexString:
            	case GraphicString:
            	case GeneralString:
            	case UniversalString:
            	case BMPString:
            	case UTF8String:
            	case GeneralizedTime:
            	case UTCTime:
            	case UID:
            	case OBJECT:
            	case RELATIVE_OID:
            	case 163:
            		{
            	    alt91 = 3;
            	    }
            	    break;
            		default:
            		    NoViableAltException nvae_d91s0 =
            		        new NoViableAltException("489:2: ( INT -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_CONST_INT INT ) ) | val= valuereference -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) ) ) | type ':' value -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_TYPE_VALUE type value ) ) )", 91, 0, input);
            	
            		    throw nvae_d91s0;
            	}
            	
            	switch (alt91) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:490:4: INT
            	        {
            	        	INT247 = (IToken)input.LT(1);
            	        	Match(input,INT,FOLLOW_INT_in_exceptionSpec3170); 
            	        	stream_INT.Add(INT247);

            	        	
            	        	// AST REWRITE
            	        	// elements:          INT
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 490:18: -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_CONST_INT INT ) )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:490:21: ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_CONST_INT INT ) )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(EXCEPTION_SPEC, "EXCEPTION_SPEC"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:490:39: ^( EXCEPTION_SPEC_CONST_INT INT )
            	        	    {
            	        	    object root_2 = (object)adaptor.GetNilNode();
            	        	    root_2 = (object)adaptor.BecomeRoot(adaptor.Create(EXCEPTION_SPEC_CONST_INT, "EXCEPTION_SPEC_CONST_INT"), root_2);
            	        	    
            	        	    adaptor.AddChild(root_2, stream_INT.Next());
            	        	    
            	        	    adaptor.AddChild(root_1, root_2);
            	        	    }
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:491:4: val= valuereference
            	        {
            	        	PushFollow(FOLLOW_valuereference_in_exceptionSpec3200);
            	        	val = valuereference();
            	        	followingStackPointer_--;
            	        	
            	        	stream_valuereference.Add(val.Tree);
            	        	
            	        	// AST REWRITE
            	        	// elements:          val
            	        	// token labels:      
            	        	// rule labels:       val, retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_val = new RewriteRuleSubtreeStream(adaptor, "token val", (val!=null ? val.Tree : null));
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 491:31: -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) ) )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:491:34: ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) ) )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(EXCEPTION_SPEC, "EXCEPTION_SPEC"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:491:52: ^( EXCEPTION_SPEC_VAL_REF ^( VALUE_REFERENCE[val.start] $val) )
            	        	    {
            	        	    object root_2 = (object)adaptor.GetNilNode();
            	        	    root_2 = (object)adaptor.BecomeRoot(adaptor.Create(EXCEPTION_SPEC_VAL_REF, "EXCEPTION_SPEC_VAL_REF"), root_2);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:491:77: ^( VALUE_REFERENCE[val.start] $val)
            	        	    {
            	        	    object root_3 = (object)adaptor.GetNilNode();
            	        	    root_3 = (object)adaptor.BecomeRoot(adaptor.Create(VALUE_REFERENCE, val.start), root_3);
            	        	    
            	        	    adaptor.AddChild(root_3, stream_val.Next());
            	        	    
            	        	    adaptor.AddChild(root_2, root_3);
            	        	    }
            	        	    
            	        	    adaptor.AddChild(root_1, root_2);
            	        	    }
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	    case 3 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:492:4: type ':' value
            	        {
            	        	PushFollow(FOLLOW_type_in_exceptionSpec3232);
            	        	type248 = type();
            	        	followingStackPointer_--;
            	        	
            	        	stream_type.Add(type248.Tree);
            	        	char_literal249 = (IToken)input.LT(1);
            	        	Match(input,168,FOLLOW_168_in_exceptionSpec3234); 
            	        	stream_168.Add(char_literal249);

            	        	PushFollow(FOLLOW_value_in_exceptionSpec3236);
            	        	value250 = value();
            	        	followingStackPointer_--;
            	        	
            	        	stream_value.Add(value250.Tree);
            	        	
            	        	// AST REWRITE
            	        	// elements:          value, type
            	        	// token labels:      
            	        	// rule labels:       retval
            	        	// token list labels: 
            	        	// rule list labels:  
            	        	retval.tree = root_0;
            	        	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	        	
            	        	root_0 = (object)adaptor.GetNilNode();
            	        	// 492:27: -> ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_TYPE_VALUE type value ) )
            	        	{
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:492:30: ^( EXCEPTION_SPEC ^( EXCEPTION_SPEC_TYPE_VALUE type value ) )
            	        	    {
            	        	    object root_1 = (object)adaptor.GetNilNode();
            	        	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(EXCEPTION_SPEC, "EXCEPTION_SPEC"), root_1);
            	        	    
            	        	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:492:48: ^( EXCEPTION_SPEC_TYPE_VALUE type value )
            	        	    {
            	        	    object root_2 = (object)adaptor.GetNilNode();
            	        	    root_2 = (object)adaptor.BecomeRoot(adaptor.Create(EXCEPTION_SPEC_TYPE_VALUE, "EXCEPTION_SPEC_TYPE_VALUE"), root_2);
            	        	    
            	        	    adaptor.AddChild(root_2, stream_type.Next());
            	        	    adaptor.AddChild(root_2, stream_value.Next());
            	        	    
            	        	    adaptor.AddChild(root_1, root_2);
            	        	    }
            	        	    
            	        	    adaptor.AddChild(root_0, root_1);
            	        	    }
            	        	
            	        	}
            	        	

            	        
            	        }
            	        break;
            	
            	}

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end exceptionSpec

    public class unionSet_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start unionSet
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:498:1: unionSet : ( intersectionSet ( UnionMark intersectionSet )* -> ^( UNION_SET ( intersectionSet )+ ) | a= ALL EXCEPT constraintExpression -> ^( UNION_SET_ALL_EXCEPT[$a] constraintExpression ) );
    public unionSet_return unionSet() // throws RecognitionException [1]
    {   
        unionSet_return retval = new unionSet_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken UnionMark252 = null;
        IToken EXCEPT254 = null;
        intersectionSet_return intersectionSet251 = null;

        intersectionSet_return intersectionSet253 = null;

        constraintExpression_return constraintExpression255 = null;
        
        
        object a_tree=null;
        object UnionMark252_tree=null;
        object EXCEPT254_tree=null;
        RewriteRuleTokenStream stream_UnionMark = new RewriteRuleTokenStream(adaptor,"token UnionMark");
        RewriteRuleTokenStream stream_EXCEPT = new RewriteRuleTokenStream(adaptor,"token EXCEPT");
        RewriteRuleTokenStream stream_ALL = new RewriteRuleTokenStream(adaptor,"token ALL");
        RewriteRuleSubtreeStream stream_constraintExpression = new RewriteRuleSubtreeStream(adaptor,"rule constraintExpression");
        RewriteRuleSubtreeStream stream_intersectionSet = new RewriteRuleSubtreeStream(adaptor,"rule intersectionSet");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:499:2: ( intersectionSet ( UnionMark intersectionSet )* -> ^( UNION_SET ( intersectionSet )+ ) | a= ALL EXCEPT constraintExpression -> ^( UNION_SET_ALL_EXCEPT[$a] constraintExpression ) )
            int alt93 = 2;
            int LA93_0 = input.LA(1);
            
            if ( (LA93_0 == L_BRACKET || (LA93_0 >= L_PAREN && LA93_0 <= INT) || LA93_0 == FROM || (LA93_0 >= SIZE && LA93_0 <= BIT) || (LA93_0 >= BOOLEAN && LA93_0 <= ENUMERATED) || (LA93_0 >= INTEGER && LA93_0 <= SET) || (LA93_0 >= OCTET && LA93_0 <= FloatingPointLiteral) || LA93_0 == MIN || (LA93_0 >= INCLUDES && LA93_0 <= WITH) || (LA93_0 >= PATTERN && LA93_0 <= OBJECT) || LA93_0 == RELATIVE_OID || LA93_0 == 163) )
            {
                alt93 = 1;
            }
            else if ( (LA93_0 == ALL) )
            {
                alt93 = 2;
            }
            else 
            {
                NoViableAltException nvae_d93s0 =
                    new NoViableAltException("498:1: unionSet : ( intersectionSet ( UnionMark intersectionSet )* -> ^( UNION_SET ( intersectionSet )+ ) | a= ALL EXCEPT constraintExpression -> ^( UNION_SET_ALL_EXCEPT[$a] constraintExpression ) );", 93, 0, input);
            
                throw nvae_d93s0;
            }
            switch (alt93) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:499:4: intersectionSet ( UnionMark intersectionSet )*
                    {
                    	PushFollow(FOLLOW_intersectionSet_in_unionSet3289);
                    	intersectionSet251 = intersectionSet();
                    	followingStackPointer_--;
                    	
                    	stream_intersectionSet.Add(intersectionSet251.Tree);
                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:499:20: ( UnionMark intersectionSet )*
                    	do 
                    	{
                    	    int alt92 = 2;
                    	    int LA92_0 = input.LA(1);
                    	    
                    	    if ( (LA92_0 == UnionMark) )
                    	    {
                    	        alt92 = 1;
                    	    }
                    	    
                    	
                    	    switch (alt92) 
                    		{
                    			case 1 :
                    			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:499:21: UnionMark intersectionSet
                    			    {
                    			    	UnionMark252 = (IToken)input.LT(1);
                    			    	Match(input,UnionMark,FOLLOW_UnionMark_in_unionSet3292); 
                    			    	stream_UnionMark.Add(UnionMark252);

                    			    	PushFollow(FOLLOW_intersectionSet_in_unionSet3294);
                    			    	intersectionSet253 = intersectionSet();
                    			    	followingStackPointer_--;
                    			    	
                    			    	stream_intersectionSet.Add(intersectionSet253.Tree);
                    			    
                    			    }
                    			    break;
                    	
                    			default:
                    			    goto loop92;
                    	    }
                    	} while (true);
                    	
                    	loop92:
                    		;	// Stops C# compiler whinging that label 'loop92' has no statements

                    	
                    	// AST REWRITE
                    	// elements:          intersectionSet
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 499:51: -> ^( UNION_SET ( intersectionSet )+ )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:499:54: ^( UNION_SET ( intersectionSet )+ )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(UNION_SET, "UNION_SET"), root_1);
                    	    
                    	    if ( !(stream_intersectionSet.HasNext()) ) {
                    	        throw new RewriteEarlyExitException();
                    	    }
                    	    while ( stream_intersectionSet.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_intersectionSet.Next());
                    	    
                    	    }
                    	    stream_intersectionSet.Reset();
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:500:4: a= ALL EXCEPT constraintExpression
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,ALL,FOLLOW_ALL_in_unionSet3315); 
                    	stream_ALL.Add(a);

                    	EXCEPT254 = (IToken)input.LT(1);
                    	Match(input,EXCEPT,FOLLOW_EXCEPT_in_unionSet3317); 
                    	stream_EXCEPT.Add(EXCEPT254);

                    	PushFollow(FOLLOW_constraintExpression_in_unionSet3319);
                    	constraintExpression255 = constraintExpression();
                    	followingStackPointer_--;
                    	
                    	stream_constraintExpression.Add(constraintExpression255.Tree);
                    	
                    	// AST REWRITE
                    	// elements:          constraintExpression
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 500:44: -> ^( UNION_SET_ALL_EXCEPT[$a] constraintExpression )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:500:47: ^( UNION_SET_ALL_EXCEPT[$a] constraintExpression )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(UNION_SET_ALL_EXCEPT, a), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_constraintExpression.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end unionSet

    public class intersectionSet_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start intersectionSet
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:504:1: intersectionSet : intersectionItem ( IntersectionMark intersectionItem )* -> ^( INTERSECTION_SET ( intersectionItem )+ ) ;
    public intersectionSet_return intersectionSet() // throws RecognitionException [1]
    {   
        intersectionSet_return retval = new intersectionSet_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken IntersectionMark257 = null;
        intersectionItem_return intersectionItem256 = null;

        intersectionItem_return intersectionItem258 = null;
        
        
        object IntersectionMark257_tree=null;
        RewriteRuleTokenStream stream_IntersectionMark = new RewriteRuleTokenStream(adaptor,"token IntersectionMark");
        RewriteRuleSubtreeStream stream_intersectionItem = new RewriteRuleSubtreeStream(adaptor,"rule intersectionItem");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:505:2: ( intersectionItem ( IntersectionMark intersectionItem )* -> ^( INTERSECTION_SET ( intersectionItem )+ ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:505:4: intersectionItem ( IntersectionMark intersectionItem )*
            {
            	PushFollow(FOLLOW_intersectionItem_in_intersectionSet3348);
            	intersectionItem256 = intersectionItem();
            	followingStackPointer_--;
            	
            	stream_intersectionItem.Add(intersectionItem256.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:505:21: ( IntersectionMark intersectionItem )*
            	do 
            	{
            	    int alt94 = 2;
            	    int LA94_0 = input.LA(1);
            	    
            	    if ( (LA94_0 == IntersectionMark) )
            	    {
            	        alt94 = 1;
            	    }
            	    
            	
            	    switch (alt94) 
            		{
            			case 1 :
            			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:505:22: IntersectionMark intersectionItem
            			    {
            			    	IntersectionMark257 = (IToken)input.LT(1);
            			    	Match(input,IntersectionMark,FOLLOW_IntersectionMark_in_intersectionSet3351); 
            			    	stream_IntersectionMark.Add(IntersectionMark257);

            			    	PushFollow(FOLLOW_intersectionItem_in_intersectionSet3353);
            			    	intersectionItem258 = intersectionItem();
            			    	followingStackPointer_--;
            			    	
            			    	stream_intersectionItem.Add(intersectionItem258.Tree);
            			    
            			    }
            			    break;
            	
            			default:
            			    goto loop94;
            	    }
            	} while (true);
            	
            	loop94:
            		;	// Stops C# compiler whinging that label 'loop94' has no statements

            	
            	// AST REWRITE
            	// elements:          intersectionItem
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 505:58: -> ^( INTERSECTION_SET ( intersectionItem )+ )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:505:61: ^( INTERSECTION_SET ( intersectionItem )+ )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(INTERSECTION_SET, "INTERSECTION_SET"), root_1);
            	    
            	    if ( !(stream_intersectionItem.HasNext()) ) {
            	        throw new RewriteEarlyExitException();
            	    }
            	    while ( stream_intersectionItem.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_intersectionItem.Next());
            	    
            	    }
            	    stream_intersectionItem.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end intersectionSet

    public class intersectionItem_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start intersectionItem
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:508:1: intersectionItem : ex1= constraintExpression ( EXCEPT ex2= constraintExpression )? -> ^( INTERSECTION_ELEMENT $ex1 ( $ex2)? ) ;
    public intersectionItem_return intersectionItem() // throws RecognitionException [1]
    {   
        intersectionItem_return retval = new intersectionItem_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken EXCEPT259 = null;
        constraintExpression_return ex1 = null;

        constraintExpression_return ex2 = null;
        
        
        object EXCEPT259_tree=null;
        RewriteRuleTokenStream stream_EXCEPT = new RewriteRuleTokenStream(adaptor,"token EXCEPT");
        RewriteRuleSubtreeStream stream_constraintExpression = new RewriteRuleSubtreeStream(adaptor,"rule constraintExpression");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:509:2: (ex1= constraintExpression ( EXCEPT ex2= constraintExpression )? -> ^( INTERSECTION_ELEMENT $ex1 ( $ex2)? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:509:4: ex1= constraintExpression ( EXCEPT ex2= constraintExpression )?
            {
            	PushFollow(FOLLOW_constraintExpression_in_intersectionItem3382);
            	ex1 = constraintExpression();
            	followingStackPointer_--;
            	
            	stream_constraintExpression.Add(ex1.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:509:29: ( EXCEPT ex2= constraintExpression )?
            	int alt95 = 2;
            	int LA95_0 = input.LA(1);
            	
            	if ( (LA95_0 == EXCEPT) )
            	{
            	    alt95 = 1;
            	}
            	switch (alt95) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:509:30: EXCEPT ex2= constraintExpression
            	        {
            	        	EXCEPT259 = (IToken)input.LT(1);
            	        	Match(input,EXCEPT,FOLLOW_EXCEPT_in_intersectionItem3385); 
            	        	stream_EXCEPT.Add(EXCEPT259);

            	        	PushFollow(FOLLOW_constraintExpression_in_intersectionItem3389);
            	        	ex2 = constraintExpression();
            	        	followingStackPointer_--;
            	        	
            	        	stream_constraintExpression.Add(ex2.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          ex1, ex2
            	// token labels:      
            	// rule labels:       retval, ex2, ex1
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	RewriteRuleSubtreeStream stream_ex2 = new RewriteRuleSubtreeStream(adaptor, "token ex2", (ex2!=null ? ex2.Tree : null));
            	RewriteRuleSubtreeStream stream_ex1 = new RewriteRuleSubtreeStream(adaptor, "token ex1", (ex1!=null ? ex1.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 509:66: -> ^( INTERSECTION_ELEMENT $ex1 ( $ex2)? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:509:69: ^( INTERSECTION_ELEMENT $ex1 ( $ex2)? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(INTERSECTION_ELEMENT, "INTERSECTION_ELEMENT"), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_ex1.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:509:97: ( $ex2)?
            	    if ( stream_ex2.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_ex2.Next());
            	    
            	    }
            	    stream_ex2.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end intersectionItem

    public class constraintExpression_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start constraintExpression
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:514:1: constraintExpression : ( valueRangeExpression | subtypeExpression | sizeExpression | permittedAlphabetExpression | innerTypeExpression | patternExpression | L_PAREN unionSet R_PAREN -> unionSet );
    public constraintExpression_return constraintExpression() // throws RecognitionException [1]
    {   
        constraintExpression_return retval = new constraintExpression_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken L_PAREN266 = null;
        IToken R_PAREN268 = null;
        valueRangeExpression_return valueRangeExpression260 = null;

        subtypeExpression_return subtypeExpression261 = null;

        sizeExpression_return sizeExpression262 = null;

        permittedAlphabetExpression_return permittedAlphabetExpression263 = null;

        innerTypeExpression_return innerTypeExpression264 = null;

        patternExpression_return patternExpression265 = null;

        unionSet_return unionSet267 = null;
        
        
        object L_PAREN266_tree=null;
        object R_PAREN268_tree=null;
        RewriteRuleTokenStream stream_R_PAREN = new RewriteRuleTokenStream(adaptor,"token R_PAREN");
        RewriteRuleTokenStream stream_L_PAREN = new RewriteRuleTokenStream(adaptor,"token L_PAREN");
        RewriteRuleSubtreeStream stream_unionSet = new RewriteRuleSubtreeStream(adaptor,"rule unionSet");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:515:2: ( valueRangeExpression | subtypeExpression | sizeExpression | permittedAlphabetExpression | innerTypeExpression | patternExpression | L_PAREN unionSet R_PAREN -> unionSet )
            int alt96 = 7;
            switch ( input.LA(1) ) 
            {
            case BitStringLiteral:
            case OctectStringLiteral:
            case TRUE:
            case FALSE:
            case StringLiteral:
            	{
                alt96 = 1;
                }
                break;
            case L_BRACKET:
            case INT:
            case NULL:
            case PLUS_INFINITY:
            case MINUS_INFINITY:
            case FloatingPointLiteral:
            case MIN:
            	{
                alt96 = 1;
                }
                break;
            case LID:
            	{
                int LA96_3 = input.LA(2);
                
                if ( (LA96_3 == R_PAREN || LA96_3 == COMMA || (LA96_3 >= UnionMark && LA96_3 <= DOUBLE_DOT) || (LA96_3 >= 168 && LA96_3 <= 169)) )
                {
                    alt96 = 1;
                }
                else if ( (LA96_3 == 165) )
                {
                    int LA96_10 = input.LA(3);
                    
                    if ( (LA96_10 == DOUBLE_DOT) )
                    {
                        alt96 = 1;
                    }
                    else if ( ((LA96_10 >= NULL && LA96_10 <= BIT) || (LA96_10 >= BOOLEAN && LA96_10 <= ENUMERATED) || (LA96_10 >= INTEGER && LA96_10 <= SET) || (LA96_10 >= OCTET && LA96_10 <= UID) || (LA96_10 >= LID && LA96_10 <= OBJECT) || LA96_10 == RELATIVE_OID || LA96_10 == 163) )
                    {
                        alt96 = 2;
                    }
                    else 
                    {
                        NoViableAltException nvae_d96s10 =
                            new NoViableAltException("514:1: constraintExpression : ( valueRangeExpression | subtypeExpression | sizeExpression | permittedAlphabetExpression | innerTypeExpression | patternExpression | L_PAREN unionSet R_PAREN -> unionSet );", 96, 10, input);
                    
                        throw nvae_d96s10;
                    }
                }
                else 
                {
                    NoViableAltException nvae_d96s3 =
                        new NoViableAltException("514:1: constraintExpression : ( valueRangeExpression | subtypeExpression | sizeExpression | permittedAlphabetExpression | innerTypeExpression | patternExpression | L_PAREN unionSet R_PAREN -> unionSet );", 96, 3, input);
                
                    throw nvae_d96s3;
                }
                }
                break;
            case BIT:
            case BOOLEAN:
            case ENUMERATED:
            case INTEGER:
            case REAL:
            case CHOICE:
            case SEQUENCE:
            case SET:
            case OCTET:
            case NumericString:
            case PrintableString:
            case VisibleString:
            case IA5String:
            case TeletexString:
            case VideotexString:
            case GraphicString:
            case GeneralString:
            case UniversalString:
            case BMPString:
            case UTF8String:
            case GeneralizedTime:
            case UTCTime:
            case UID:
            case INCLUDES:
            case OBJECT:
            case RELATIVE_OID:
            case 163:
            	{
                alt96 = 2;
                }
                break;
            case SIZE:
            	{
                alt96 = 3;
                }
                break;
            case FROM:
            	{
                alt96 = 4;
                }
                break;
            case WITH:
            	{
                alt96 = 5;
                }
                break;
            case PATTERN:
            	{
                alt96 = 6;
                }
                break;
            case L_PAREN:
            	{
                alt96 = 7;
                }
                break;
            	default:
            	    NoViableAltException nvae_d96s0 =
            	        new NoViableAltException("514:1: constraintExpression : ( valueRangeExpression | subtypeExpression | sizeExpression | permittedAlphabetExpression | innerTypeExpression | patternExpression | L_PAREN unionSet R_PAREN -> unionSet );", 96, 0, input);
            
            	    throw nvae_d96s0;
            }
            
            switch (alt96) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:515:4: valueRangeExpression
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_valueRangeExpression_in_constraintExpression3422);
                    	valueRangeExpression260 = valueRangeExpression();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, valueRangeExpression260.Tree);
                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:517:4: subtypeExpression
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_subtypeExpression_in_constraintExpression3438);
                    	subtypeExpression261 = subtypeExpression();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, subtypeExpression261.Tree);
                    
                    }
                    break;
                case 3 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:518:4: sizeExpression
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_sizeExpression_in_constraintExpression3450);
                    	sizeExpression262 = sizeExpression();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, sizeExpression262.Tree);
                    
                    }
                    break;
                case 4 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:521:4: permittedAlphabetExpression
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_permittedAlphabetExpression_in_constraintExpression3476);
                    	permittedAlphabetExpression263 = permittedAlphabetExpression();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, permittedAlphabetExpression263.Tree);
                    
                    }
                    break;
                case 5 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:522:4: innerTypeExpression
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_innerTypeExpression_in_constraintExpression3481);
                    	innerTypeExpression264 = innerTypeExpression();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, innerTypeExpression264.Tree);
                    
                    }
                    break;
                case 6 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:523:4: patternExpression
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_patternExpression_in_constraintExpression3486);
                    	patternExpression265 = patternExpression();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, patternExpression265.Tree);
                    
                    }
                    break;
                case 7 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:524:4: L_PAREN unionSet R_PAREN
                    {
                    	L_PAREN266 = (IToken)input.LT(1);
                    	Match(input,L_PAREN,FOLLOW_L_PAREN_in_constraintExpression3491); 
                    	stream_L_PAREN.Add(L_PAREN266);

                    	PushFollow(FOLLOW_unionSet_in_constraintExpression3493);
                    	unionSet267 = unionSet();
                    	followingStackPointer_--;
                    	
                    	stream_unionSet.Add(unionSet267.Tree);
                    	R_PAREN268 = (IToken)input.LT(1);
                    	Match(input,R_PAREN,FOLLOW_R_PAREN_in_constraintExpression3495); 
                    	stream_R_PAREN.Add(R_PAREN268);

                    	
                    	// AST REWRITE
                    	// elements:          unionSet
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 524:29: -> unionSet
                    	{
                    	    adaptor.AddChild(root_0, stream_unionSet.Next());
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end constraintExpression

    public class valueRangeExpression_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start valueRangeExpression
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:527:1: valueRangeExpression : minVal= lowerEndValue ( (minIncl= '<' )? DOUBLE_DOT (maxIncl= '<' )? maxVal= upperEndValue )? -> ^( VALUE_RANGE_EXPR $minVal ( ^( MAX_VAL_PRESENT $maxVal) )? ( ^( MIN_VAL_INCLUDED $minIncl) )? ( ^( MAX_VAL_INCLUDED $maxIncl) )? ) ;
    public valueRangeExpression_return valueRangeExpression() // throws RecognitionException [1]
    {   
        valueRangeExpression_return retval = new valueRangeExpression_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken minIncl = null;
        IToken maxIncl = null;
        IToken DOUBLE_DOT269 = null;
        lowerEndValue_return minVal = null;

        upperEndValue_return maxVal = null;
        
        
        object minIncl_tree=null;
        object maxIncl_tree=null;
        object DOUBLE_DOT269_tree=null;
        RewriteRuleTokenStream stream_DOUBLE_DOT = new RewriteRuleTokenStream(adaptor,"token DOUBLE_DOT");
        RewriteRuleTokenStream stream_165 = new RewriteRuleTokenStream(adaptor,"token 165");
        RewriteRuleSubtreeStream stream_lowerEndValue = new RewriteRuleSubtreeStream(adaptor,"rule lowerEndValue");
        RewriteRuleSubtreeStream stream_upperEndValue = new RewriteRuleSubtreeStream(adaptor,"rule upperEndValue");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:528:2: (minVal= lowerEndValue ( (minIncl= '<' )? DOUBLE_DOT (maxIncl= '<' )? maxVal= upperEndValue )? -> ^( VALUE_RANGE_EXPR $minVal ( ^( MAX_VAL_PRESENT $maxVal) )? ( ^( MIN_VAL_INCLUDED $minIncl) )? ( ^( MAX_VAL_INCLUDED $maxIncl) )? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:528:4: minVal= lowerEndValue ( (minIncl= '<' )? DOUBLE_DOT (maxIncl= '<' )? maxVal= upperEndValue )?
            {
            	PushFollow(FOLLOW_lowerEndValue_in_valueRangeExpression3514);
            	minVal = lowerEndValue();
            	followingStackPointer_--;
            	
            	stream_lowerEndValue.Add(minVal.Tree);
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:528:25: ( (minIncl= '<' )? DOUBLE_DOT (maxIncl= '<' )? maxVal= upperEndValue )?
            	int alt99 = 2;
            	int LA99_0 = input.LA(1);
            	
            	if ( (LA99_0 == DOUBLE_DOT || LA99_0 == 165) )
            	{
            	    alt99 = 1;
            	}
            	switch (alt99) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:528:27: (minIncl= '<' )? DOUBLE_DOT (maxIncl= '<' )? maxVal= upperEndValue
            	        {
            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:528:27: (minIncl= '<' )?
            	        	int alt97 = 2;
            	        	int LA97_0 = input.LA(1);
            	        	
            	        	if ( (LA97_0 == 165) )
            	        	{
            	        	    alt97 = 1;
            	        	}
            	        	switch (alt97) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:528:28: minIncl= '<'
            	        	        {
            	        	        	minIncl = (IToken)input.LT(1);
            	        	        	Match(input,165,FOLLOW_165_in_valueRangeExpression3521); 
            	        	        	stream_165.Add(minIncl);

            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        	DOUBLE_DOT269 = (IToken)input.LT(1);
            	        	Match(input,DOUBLE_DOT,FOLLOW_DOUBLE_DOT_in_valueRangeExpression3525); 
            	        	stream_DOUBLE_DOT.Add(DOUBLE_DOT269);

            	        	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:528:53: (maxIncl= '<' )?
            	        	int alt98 = 2;
            	        	int LA98_0 = input.LA(1);
            	        	
            	        	if ( (LA98_0 == 165) )
            	        	{
            	        	    alt98 = 1;
            	        	}
            	        	switch (alt98) 
            	        	{
            	        	    case 1 :
            	        	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:528:54: maxIncl= '<'
            	        	        {
            	        	        	maxIncl = (IToken)input.LT(1);
            	        	        	Match(input,165,FOLLOW_165_in_valueRangeExpression3530); 
            	        	        	stream_165.Add(maxIncl);

            	        	        
            	        	        }
            	        	        break;
            	        	
            	        	}

            	        	PushFollow(FOLLOW_upperEndValue_in_valueRangeExpression3536);
            	        	maxVal = upperEndValue();
            	        	followingStackPointer_--;
            	        	
            	        	stream_upperEndValue.Add(maxVal.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          maxIncl, minIncl, maxVal, minVal
            	// token labels:      minIncl, maxIncl
            	// rule labels:       retval, maxVal, minVal
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_minIncl = new RewriteRuleTokenStream(adaptor, "token minIncl", minIncl);
            	RewriteRuleTokenStream stream_maxIncl = new RewriteRuleTokenStream(adaptor, "token maxIncl", maxIncl);
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	RewriteRuleSubtreeStream stream_maxVal = new RewriteRuleSubtreeStream(adaptor, "token maxVal", (maxVal!=null ? maxVal.Tree : null));
            	RewriteRuleSubtreeStream stream_minVal = new RewriteRuleSubtreeStream(adaptor, "token minVal", (minVal!=null ? minVal.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 529:3: -> ^( VALUE_RANGE_EXPR $minVal ( ^( MAX_VAL_PRESENT $maxVal) )? ( ^( MIN_VAL_INCLUDED $minIncl) )? ( ^( MAX_VAL_INCLUDED $maxIncl) )? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:529:6: ^( VALUE_RANGE_EXPR $minVal ( ^( MAX_VAL_PRESENT $maxVal) )? ( ^( MIN_VAL_INCLUDED $minIncl) )? ( ^( MAX_VAL_INCLUDED $maxIncl) )? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(VALUE_RANGE_EXPR, "VALUE_RANGE_EXPR"), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_minVal.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:529:33: ( ^( MAX_VAL_PRESENT $maxVal) )?
            	    if ( stream_maxVal.HasNext() )
            	    {
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:529:33: ^( MAX_VAL_PRESENT $maxVal)
            	        {
            	        object root_2 = (object)adaptor.GetNilNode();
            	        root_2 = (object)adaptor.BecomeRoot(adaptor.Create(MAX_VAL_PRESENT, "MAX_VAL_PRESENT"), root_2);
            	        
            	        adaptor.AddChild(root_2, stream_maxVal.Next());
            	        
            	        adaptor.AddChild(root_1, root_2);
            	        }
            	    
            	    }
            	    stream_maxVal.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:529:61: ( ^( MIN_VAL_INCLUDED $minIncl) )?
            	    if ( stream_minIncl.HasNext() )
            	    {
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:529:61: ^( MIN_VAL_INCLUDED $minIncl)
            	        {
            	        object root_2 = (object)adaptor.GetNilNode();
            	        root_2 = (object)adaptor.BecomeRoot(adaptor.Create(MIN_VAL_INCLUDED, "MIN_VAL_INCLUDED"), root_2);
            	        
            	        adaptor.AddChild(root_2, stream_minIncl.Next());
            	        
            	        adaptor.AddChild(root_1, root_2);
            	        }
            	    
            	    }
            	    stream_minIncl.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:529:91: ( ^( MAX_VAL_INCLUDED $maxIncl) )?
            	    if ( stream_maxIncl.HasNext() )
            	    {
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:529:91: ^( MAX_VAL_INCLUDED $maxIncl)
            	        {
            	        object root_2 = (object)adaptor.GetNilNode();
            	        root_2 = (object)adaptor.BecomeRoot(adaptor.Create(MAX_VAL_INCLUDED, "MAX_VAL_INCLUDED"), root_2);
            	        
            	        adaptor.AddChild(root_2, stream_maxIncl.Next());
            	        
            	        adaptor.AddChild(root_1, root_2);
            	        }
            	    
            	    }
            	    stream_maxIncl.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end valueRangeExpression

    public class lowerEndValue_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start lowerEndValue
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:532:1: lowerEndValue : ( value | MIN );
    public lowerEndValue_return lowerEndValue() // throws RecognitionException [1]
    {   
        lowerEndValue_return retval = new lowerEndValue_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken MIN271 = null;
        value_return value270 = null;
        
        
        object MIN271_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:533:2: ( value | MIN )
            int alt100 = 2;
            int LA100_0 = input.LA(1);
            
            if ( (LA100_0 == L_BRACKET || LA100_0 == INT || LA100_0 == NULL || (LA100_0 >= BitStringLiteral && LA100_0 <= FloatingPointLiteral) || LA100_0 == LID) )
            {
                alt100 = 1;
            }
            else if ( (LA100_0 == MIN) )
            {
                alt100 = 2;
            }
            else 
            {
                NoViableAltException nvae_d100s0 =
                    new NoViableAltException("532:1: lowerEndValue : ( value | MIN );", 100, 0, input);
            
                throw nvae_d100s0;
            }
            switch (alt100) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:533:4: value
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_value_in_lowerEndValue3588);
                    	value270 = value();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, value270.Tree);
                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:534:4: MIN
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	MIN271 = (IToken)input.LT(1);
                    	Match(input,MIN,FOLLOW_MIN_in_lowerEndValue3593); 
                    	MIN271_tree = (object)adaptor.Create(MIN271);
                    	adaptor.AddChild(root_0, MIN271_tree);

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end lowerEndValue

    public class upperEndValue_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start upperEndValue
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:537:1: upperEndValue : ( value | MAX );
    public upperEndValue_return upperEndValue() // throws RecognitionException [1]
    {   
        upperEndValue_return retval = new upperEndValue_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken MAX273 = null;
        value_return value272 = null;
        
        
        object MAX273_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:538:2: ( value | MAX )
            int alt101 = 2;
            int LA101_0 = input.LA(1);
            
            if ( (LA101_0 == L_BRACKET || LA101_0 == INT || LA101_0 == NULL || (LA101_0 >= BitStringLiteral && LA101_0 <= FloatingPointLiteral) || LA101_0 == LID) )
            {
                alt101 = 1;
            }
            else if ( (LA101_0 == MAX) )
            {
                alt101 = 2;
            }
            else 
            {
                NoViableAltException nvae_d101s0 =
                    new NoViableAltException("537:1: upperEndValue : ( value | MAX );", 101, 0, input);
            
                throw nvae_d101s0;
            }
            switch (alt101) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:538:4: value
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	PushFollow(FOLLOW_value_in_upperEndValue3605);
                    	value272 = value();
                    	followingStackPointer_--;
                    	
                    	adaptor.AddChild(root_0, value272.Tree);
                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:539:4: MAX
                    {
                    	root_0 = (object)adaptor.GetNilNode();
                    
                    	MAX273 = (IToken)input.LT(1);
                    	Match(input,MAX,FOLLOW_MAX_in_upperEndValue3610); 
                    	MAX273_tree = (object)adaptor.Create(MAX273);
                    	adaptor.AddChild(root_0, MAX273_tree);

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end upperEndValue

    public class subtypeExpression_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start subtypeExpression
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:543:1: subtypeExpression : (bInlc= INCLUDES )? type -> ^( SUBTYPE_EXPR type ( $bInlc)? ) ;
    public subtypeExpression_return subtypeExpression() // throws RecognitionException [1]
    {   
        subtypeExpression_return retval = new subtypeExpression_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken bInlc = null;
        type_return type274 = null;
        
        
        object bInlc_tree=null;
        RewriteRuleTokenStream stream_INCLUDES = new RewriteRuleTokenStream(adaptor,"token INCLUDES");
        RewriteRuleSubtreeStream stream_type = new RewriteRuleSubtreeStream(adaptor,"rule type");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:543:18: ( (bInlc= INCLUDES )? type -> ^( SUBTYPE_EXPR type ( $bInlc)? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:543:20: (bInlc= INCLUDES )? type
            {
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:543:25: (bInlc= INCLUDES )?
            	int alt102 = 2;
            	int LA102_0 = input.LA(1);
            	
            	if ( (LA102_0 == INCLUDES) )
            	{
            	    alt102 = 1;
            	}
            	switch (alt102) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:543:25: bInlc= INCLUDES
            	        {
            	        	bInlc = (IToken)input.LT(1);
            	        	Match(input,INCLUDES,FOLLOW_INCLUDES_in_subtypeExpression3624); 
            	        	stream_INCLUDES.Add(bInlc);

            	        
            	        }
            	        break;
            	
            	}

            	PushFollow(FOLLOW_type_in_subtypeExpression3627);
            	type274 = type();
            	followingStackPointer_--;
            	
            	stream_type.Add(type274.Tree);
            	
            	// AST REWRITE
            	// elements:          type, bInlc
            	// token labels:      bInlc
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_bInlc = new RewriteRuleTokenStream(adaptor, "token bInlc", bInlc);
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 543:42: -> ^( SUBTYPE_EXPR type ( $bInlc)? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:543:45: ^( SUBTYPE_EXPR type ( $bInlc)? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SUBTYPE_EXPR, "SUBTYPE_EXPR"), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_type.Next());
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:543:65: ( $bInlc)?
            	    if ( stream_bInlc.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_bInlc.Next());
            	    
            	    }
            	    stream_bInlc.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end subtypeExpression

    public class sizeExpression_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start sizeExpression
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:546:1: sizeExpression : a= SIZE constraint -> ^( SIZE_EXPR[$a] constraint ) ;
    public sizeExpression_return sizeExpression() // throws RecognitionException [1]
    {   
        sizeExpression_return retval = new sizeExpression_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        constraint_return constraint275 = null;
        
        
        object a_tree=null;
        RewriteRuleTokenStream stream_SIZE = new RewriteRuleTokenStream(adaptor,"token SIZE");
        RewriteRuleSubtreeStream stream_constraint = new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:546:16: (a= SIZE constraint -> ^( SIZE_EXPR[$a] constraint ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:546:18: a= SIZE constraint
            {
            	a = (IToken)input.LT(1);
            	Match(input,SIZE,FOLLOW_SIZE_in_sizeExpression3652); 
            	stream_SIZE.Add(a);

            	PushFollow(FOLLOW_constraint_in_sizeExpression3654);
            	constraint275 = constraint();
            	followingStackPointer_--;
            	
            	stream_constraint.Add(constraint275.Tree);
            	
            	// AST REWRITE
            	// elements:          constraint
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 546:38: -> ^( SIZE_EXPR[$a] constraint )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:546:41: ^( SIZE_EXPR[$a] constraint )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(SIZE_EXPR, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_constraint.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end sizeExpression

    public class permittedAlphabetExpression_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start permittedAlphabetExpression
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:549:1: permittedAlphabetExpression : a= FROM constraint -> ^( PERMITTED_ALPHABET_EXPR[$a] constraint ) ;
    public permittedAlphabetExpression_return permittedAlphabetExpression() // throws RecognitionException [1]
    {   
        permittedAlphabetExpression_return retval = new permittedAlphabetExpression_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        constraint_return constraint276 = null;
        
        
        object a_tree=null;
        RewriteRuleTokenStream stream_FROM = new RewriteRuleTokenStream(adaptor,"token FROM");
        RewriteRuleSubtreeStream stream_constraint = new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:549:29: (a= FROM constraint -> ^( PERMITTED_ALPHABET_EXPR[$a] constraint ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:549:31: a= FROM constraint
            {
            	a = (IToken)input.LT(1);
            	Match(input,FROM,FOLLOW_FROM_in_permittedAlphabetExpression3678); 
            	stream_FROM.Add(a);

            	PushFollow(FOLLOW_constraint_in_permittedAlphabetExpression3680);
            	constraint276 = constraint();
            	followingStackPointer_--;
            	
            	stream_constraint.Add(constraint276.Tree);
            	
            	// AST REWRITE
            	// elements:          constraint
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 549:49: -> ^( PERMITTED_ALPHABET_EXPR[$a] constraint )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:549:52: ^( PERMITTED_ALPHABET_EXPR[$a] constraint )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(PERMITTED_ALPHABET_EXPR, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_constraint.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end permittedAlphabetExpression

    public class innerTypeExpression_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start innerTypeExpression
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:552:1: innerTypeExpression : (a= WITH COMPONENT constraint -> ^( WITH_COMPONENT_CONSTR[$a] constraint ) | a= WITH COMPONENTS L_BRACKET ( EXT_MARK COMMA )? namedConstraintExpression ( COMMA namedConstraintExpression )* R_BRACKET -> ^( WITH_COMPONENTS_CONSTR[$a] ( EXT_MARK )? ( namedConstraintExpression )+ ) );
    public innerTypeExpression_return innerTypeExpression() // throws RecognitionException [1]
    {   
        innerTypeExpression_return retval = new innerTypeExpression_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken COMPONENT277 = null;
        IToken COMPONENTS279 = null;
        IToken L_BRACKET280 = null;
        IToken EXT_MARK281 = null;
        IToken COMMA282 = null;
        IToken COMMA284 = null;
        IToken R_BRACKET286 = null;
        constraint_return constraint278 = null;

        namedConstraintExpression_return namedConstraintExpression283 = null;

        namedConstraintExpression_return namedConstraintExpression285 = null;
        
        
        object a_tree=null;
        object COMPONENT277_tree=null;
        object COMPONENTS279_tree=null;
        object L_BRACKET280_tree=null;
        object EXT_MARK281_tree=null;
        object COMMA282_tree=null;
        object COMMA284_tree=null;
        object R_BRACKET286_tree=null;
        RewriteRuleTokenStream stream_EXT_MARK = new RewriteRuleTokenStream(adaptor,"token EXT_MARK");
        RewriteRuleTokenStream stream_COMPONENTS = new RewriteRuleTokenStream(adaptor,"token COMPONENTS");
        RewriteRuleTokenStream stream_L_BRACKET = new RewriteRuleTokenStream(adaptor,"token L_BRACKET");
        RewriteRuleTokenStream stream_COMMA = new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_COMPONENT = new RewriteRuleTokenStream(adaptor,"token COMPONENT");
        RewriteRuleTokenStream stream_R_BRACKET = new RewriteRuleTokenStream(adaptor,"token R_BRACKET");
        RewriteRuleTokenStream stream_WITH = new RewriteRuleTokenStream(adaptor,"token WITH");
        RewriteRuleSubtreeStream stream_namedConstraintExpression = new RewriteRuleSubtreeStream(adaptor,"rule namedConstraintExpression");
        RewriteRuleSubtreeStream stream_constraint = new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:553:2: (a= WITH COMPONENT constraint -> ^( WITH_COMPONENT_CONSTR[$a] constraint ) | a= WITH COMPONENTS L_BRACKET ( EXT_MARK COMMA )? namedConstraintExpression ( COMMA namedConstraintExpression )* R_BRACKET -> ^( WITH_COMPONENTS_CONSTR[$a] ( EXT_MARK )? ( namedConstraintExpression )+ ) )
            int alt105 = 2;
            int LA105_0 = input.LA(1);
            
            if ( (LA105_0 == WITH) )
            {
                int LA105_1 = input.LA(2);
                
                if ( (LA105_1 == COMPONENT) )
                {
                    alt105 = 1;
                }
                else if ( (LA105_1 == COMPONENTS) )
                {
                    alt105 = 2;
                }
                else 
                {
                    NoViableAltException nvae_d105s1 =
                        new NoViableAltException("552:1: innerTypeExpression : (a= WITH COMPONENT constraint -> ^( WITH_COMPONENT_CONSTR[$a] constraint ) | a= WITH COMPONENTS L_BRACKET ( EXT_MARK COMMA )? namedConstraintExpression ( COMMA namedConstraintExpression )* R_BRACKET -> ^( WITH_COMPONENTS_CONSTR[$a] ( EXT_MARK )? ( namedConstraintExpression )+ ) );", 105, 1, input);
                
                    throw nvae_d105s1;
                }
            }
            else 
            {
                NoViableAltException nvae_d105s0 =
                    new NoViableAltException("552:1: innerTypeExpression : (a= WITH COMPONENT constraint -> ^( WITH_COMPONENT_CONSTR[$a] constraint ) | a= WITH COMPONENTS L_BRACKET ( EXT_MARK COMMA )? namedConstraintExpression ( COMMA namedConstraintExpression )* R_BRACKET -> ^( WITH_COMPONENTS_CONSTR[$a] ( EXT_MARK )? ( namedConstraintExpression )+ ) );", 105, 0, input);
            
                throw nvae_d105s0;
            }
            switch (alt105) 
            {
                case 1 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:553:4: a= WITH COMPONENT constraint
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,WITH,FOLLOW_WITH_in_innerTypeExpression3703); 
                    	stream_WITH.Add(a);

                    	COMPONENT277 = (IToken)input.LT(1);
                    	Match(input,COMPONENT,FOLLOW_COMPONENT_in_innerTypeExpression3705); 
                    	stream_COMPONENT.Add(COMPONENT277);

                    	PushFollow(FOLLOW_constraint_in_innerTypeExpression3707);
                    	constraint278 = constraint();
                    	followingStackPointer_--;
                    	
                    	stream_constraint.Add(constraint278.Tree);
                    	
                    	// AST REWRITE
                    	// elements:          constraint
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 553:42: -> ^( WITH_COMPONENT_CONSTR[$a] constraint )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:553:45: ^( WITH_COMPONENT_CONSTR[$a] constraint )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(WITH_COMPONENT_CONSTR, a), root_1);
                    	    
                    	    adaptor.AddChild(root_1, stream_constraint.Next());
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
                case 2 :
                    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:554:4: a= WITH COMPONENTS L_BRACKET ( EXT_MARK COMMA )? namedConstraintExpression ( COMMA namedConstraintExpression )* R_BRACKET
                    {
                    	a = (IToken)input.LT(1);
                    	Match(input,WITH,FOLLOW_WITH_in_innerTypeExpression3733); 
                    	stream_WITH.Add(a);

                    	COMPONENTS279 = (IToken)input.LT(1);
                    	Match(input,COMPONENTS,FOLLOW_COMPONENTS_in_innerTypeExpression3735); 
                    	stream_COMPONENTS.Add(COMPONENTS279);

                    	L_BRACKET280 = (IToken)input.LT(1);
                    	Match(input,L_BRACKET,FOLLOW_L_BRACKET_in_innerTypeExpression3737); 
                    	stream_L_BRACKET.Add(L_BRACKET280);

                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:555:4: ( EXT_MARK COMMA )?
                    	int alt103 = 2;
                    	int LA103_0 = input.LA(1);
                    	
                    	if ( (LA103_0 == EXT_MARK) )
                    	{
                    	    alt103 = 1;
                    	}
                    	switch (alt103) 
                    	{
                    	    case 1 :
                    	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:555:6: EXT_MARK COMMA
                    	        {
                    	        	EXT_MARK281 = (IToken)input.LT(1);
                    	        	Match(input,EXT_MARK,FOLLOW_EXT_MARK_in_innerTypeExpression3744); 
                    	        	stream_EXT_MARK.Add(EXT_MARK281);

                    	        	COMMA282 = (IToken)input.LT(1);
                    	        	Match(input,COMMA,FOLLOW_COMMA_in_innerTypeExpression3746); 
                    	        	stream_COMMA.Add(COMMA282);

                    	        
                    	        }
                    	        break;
                    	
                    	}

                    	PushFollow(FOLLOW_namedConstraintExpression_in_innerTypeExpression3753);
                    	namedConstraintExpression283 = namedConstraintExpression();
                    	followingStackPointer_--;
                    	
                    	stream_namedConstraintExpression.Add(namedConstraintExpression283.Tree);
                    	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:556:31: ( COMMA namedConstraintExpression )*
                    	do 
                    	{
                    	    int alt104 = 2;
                    	    int LA104_0 = input.LA(1);
                    	    
                    	    if ( (LA104_0 == COMMA) )
                    	    {
                    	        alt104 = 1;
                    	    }
                    	    
                    	
                    	    switch (alt104) 
                    		{
                    			case 1 :
                    			    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:556:32: COMMA namedConstraintExpression
                    			    {
                    			    	COMMA284 = (IToken)input.LT(1);
                    			    	Match(input,COMMA,FOLLOW_COMMA_in_innerTypeExpression3757); 
                    			    	stream_COMMA.Add(COMMA284);

                    			    	PushFollow(FOLLOW_namedConstraintExpression_in_innerTypeExpression3759);
                    			    	namedConstraintExpression285 = namedConstraintExpression();
                    			    	followingStackPointer_--;
                    			    	
                    			    	stream_namedConstraintExpression.Add(namedConstraintExpression285.Tree);
                    			    
                    			    }
                    			    break;
                    	
                    			default:
                    			    goto loop104;
                    	    }
                    	} while (true);
                    	
                    	loop104:
                    		;	// Stops C# compiler whinging that label 'loop104' has no statements

                    	R_BRACKET286 = (IToken)input.LT(1);
                    	Match(input,R_BRACKET,FOLLOW_R_BRACKET_in_innerTypeExpression3766); 
                    	stream_R_BRACKET.Add(R_BRACKET286);

                    	
                    	// AST REWRITE
                    	// elements:          namedConstraintExpression, EXT_MARK
                    	// token labels:      
                    	// rule labels:       retval
                    	// token list labels: 
                    	// rule list labels:  
                    	retval.tree = root_0;
                    	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
                    	
                    	root_0 = (object)adaptor.GetNilNode();
                    	// 558:3: -> ^( WITH_COMPONENTS_CONSTR[$a] ( EXT_MARK )? ( namedConstraintExpression )+ )
                    	{
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:558:6: ^( WITH_COMPONENTS_CONSTR[$a] ( EXT_MARK )? ( namedConstraintExpression )+ )
                    	    {
                    	    object root_1 = (object)adaptor.GetNilNode();
                    	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(WITH_COMPONENTS_CONSTR, a), root_1);
                    	    
                    	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:558:35: ( EXT_MARK )?
                    	    if ( stream_EXT_MARK.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_EXT_MARK.Next());
                    	    
                    	    }
                    	    stream_EXT_MARK.Reset();
                    	    if ( !(stream_namedConstraintExpression.HasNext()) ) {
                    	        throw new RewriteEarlyExitException();
                    	    }
                    	    while ( stream_namedConstraintExpression.HasNext() )
                    	    {
                    	        adaptor.AddChild(root_1, stream_namedConstraintExpression.Next());
                    	    
                    	    }
                    	    stream_namedConstraintExpression.Reset();
                    	    
                    	    adaptor.AddChild(root_0, root_1);
                    	    }
                    	
                    	}
                    	

                    
                    }
                    break;
            
            }
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end innerTypeExpression

    public class namedConstraintExpression_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start namedConstraintExpression
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:561:1: namedConstraintExpression : ( identifier | MANTISSA | BASE | EXPONENT ) ( constraint )? (eNum= PRESENT | eNum= ABSENT | eNum= OPTIONAL )? -> ^( NAME_CONSTRAINT_EXPR ( identifier )? ( MANTISSA )? ( BASE )? ( EXPONENT )? ( constraint )? ( $eNum)? ) ;
    public namedConstraintExpression_return namedConstraintExpression() // throws RecognitionException [1]
    {   
        namedConstraintExpression_return retval = new namedConstraintExpression_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken eNum = null;
        IToken MANTISSA288 = null;
        IToken BASE289 = null;
        IToken EXPONENT290 = null;
        identifier_return identifier287 = null;

        constraint_return constraint291 = null;
        
        
        object eNum_tree=null;
        object MANTISSA288_tree=null;
        object BASE289_tree=null;
        object EXPONENT290_tree=null;
        RewriteRuleTokenStream stream_BASE = new RewriteRuleTokenStream(adaptor,"token BASE");
        RewriteRuleTokenStream stream_MANTISSA = new RewriteRuleTokenStream(adaptor,"token MANTISSA");
        RewriteRuleTokenStream stream_EXPONENT = new RewriteRuleTokenStream(adaptor,"token EXPONENT");
        RewriteRuleTokenStream stream_PRESENT = new RewriteRuleTokenStream(adaptor,"token PRESENT");
        RewriteRuleTokenStream stream_ABSENT = new RewriteRuleTokenStream(adaptor,"token ABSENT");
        RewriteRuleTokenStream stream_OPTIONAL = new RewriteRuleTokenStream(adaptor,"token OPTIONAL");
        RewriteRuleSubtreeStream stream_constraint = new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        RewriteRuleSubtreeStream stream_identifier = new RewriteRuleSubtreeStream(adaptor,"rule identifier");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:2: ( ( identifier | MANTISSA | BASE | EXPONENT ) ( constraint )? (eNum= PRESENT | eNum= ABSENT | eNum= OPTIONAL )? -> ^( NAME_CONSTRAINT_EXPR ( identifier )? ( MANTISSA )? ( BASE )? ( EXPONENT )? ( constraint )? ( $eNum)? ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:4: ( identifier | MANTISSA | BASE | EXPONENT ) ( constraint )? (eNum= PRESENT | eNum= ABSENT | eNum= OPTIONAL )?
            {
            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:4: ( identifier | MANTISSA | BASE | EXPONENT )
            	int alt106 = 4;
            	switch ( input.LA(1) ) 
            	{
            	case LID:
            		{
            	    alt106 = 1;
            	    }
            	    break;
            	case MANTISSA:
            		{
            	    alt106 = 2;
            	    }
            	    break;
            	case BASE:
            		{
            	    alt106 = 3;
            	    }
            	    break;
            	case EXPONENT:
            		{
            	    alt106 = 4;
            	    }
            	    break;
            		default:
            		    NoViableAltException nvae_d106s0 =
            		        new NoViableAltException("562:4: ( identifier | MANTISSA | BASE | EXPONENT )", 106, 0, input);
            	
            		    throw nvae_d106s0;
            	}
            	
            	switch (alt106) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:5: identifier
            	        {
            	        	PushFollow(FOLLOW_identifier_in_namedConstraintExpression3793);
            	        	identifier287 = identifier();
            	        	followingStackPointer_--;
            	        	
            	        	stream_identifier.Add(identifier287.Tree);
            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:18: MANTISSA
            	        {
            	        	MANTISSA288 = (IToken)input.LT(1);
            	        	Match(input,MANTISSA,FOLLOW_MANTISSA_in_namedConstraintExpression3797); 
            	        	stream_MANTISSA.Add(MANTISSA288);

            	        
            	        }
            	        break;
            	    case 3 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:28: BASE
            	        {
            	        	BASE289 = (IToken)input.LT(1);
            	        	Match(input,BASE,FOLLOW_BASE_in_namedConstraintExpression3800); 
            	        	stream_BASE.Add(BASE289);

            	        
            	        }
            	        break;
            	    case 4 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:33: EXPONENT
            	        {
            	        	EXPONENT290 = (IToken)input.LT(1);
            	        	Match(input,EXPONENT,FOLLOW_EXPONENT_in_namedConstraintExpression3802); 
            	        	stream_EXPONENT.Add(EXPONENT290);

            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:43: ( constraint )?
            	int alt107 = 2;
            	int LA107_0 = input.LA(1);
            	
            	if ( (LA107_0 == L_PAREN) )
            	{
            	    alt107 = 1;
            	}
            	switch (alt107) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:44: constraint
            	        {
            	        	PushFollow(FOLLOW_constraint_in_namedConstraintExpression3806);
            	        	constraint291 = constraint();
            	        	followingStackPointer_--;
            	        	
            	        	stream_constraint.Add(constraint291.Tree);
            	        
            	        }
            	        break;
            	
            	}

            	// C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:57: (eNum= PRESENT | eNum= ABSENT | eNum= OPTIONAL )?
            	int alt108 = 4;
            	switch ( input.LA(1) ) 
            	{
            	    case PRESENT:
            	    	{
            	        alt108 = 1;
            	        }
            	        break;
            	    case ABSENT:
            	    	{
            	        alt108 = 2;
            	        }
            	        break;
            	    case OPTIONAL:
            	    	{
            	        alt108 = 3;
            	        }
            	        break;
            	}
            	
            	switch (alt108) 
            	{
            	    case 1 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:58: eNum= PRESENT
            	        {
            	        	eNum = (IToken)input.LT(1);
            	        	Match(input,PRESENT,FOLLOW_PRESENT_in_namedConstraintExpression3813); 
            	        	stream_PRESENT.Add(eNum);

            	        
            	        }
            	        break;
            	    case 2 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:71: eNum= ABSENT
            	        {
            	        	eNum = (IToken)input.LT(1);
            	        	Match(input,ABSENT,FOLLOW_ABSENT_in_namedConstraintExpression3817); 
            	        	stream_ABSENT.Add(eNum);

            	        
            	        }
            	        break;
            	    case 3 :
            	        // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:562:85: eNum= OPTIONAL
            	        {
            	        	eNum = (IToken)input.LT(1);
            	        	Match(input,OPTIONAL,FOLLOW_OPTIONAL_in_namedConstraintExpression3823); 
            	        	stream_OPTIONAL.Add(eNum);

            	        
            	        }
            	        break;
            	
            	}

            	
            	// AST REWRITE
            	// elements:          identifier, eNum, constraint, BASE, EXPONENT, MANTISSA
            	// token labels:      eNum
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleTokenStream stream_eNum = new RewriteRuleTokenStream(adaptor, "token eNum", eNum);
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 563:7: -> ^( NAME_CONSTRAINT_EXPR ( identifier )? ( MANTISSA )? ( BASE )? ( EXPONENT )? ( constraint )? ( $eNum)? )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:563:10: ^( NAME_CONSTRAINT_EXPR ( identifier )? ( MANTISSA )? ( BASE )? ( EXPONENT )? ( constraint )? ( $eNum)? )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(NAME_CONSTRAINT_EXPR, "NAME_CONSTRAINT_EXPR"), root_1);
            	    
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:563:33: ( identifier )?
            	    if ( stream_identifier.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_identifier.Next());
            	    
            	    }
            	    stream_identifier.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:563:45: ( MANTISSA )?
            	    if ( stream_MANTISSA.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_MANTISSA.Next());
            	    
            	    }
            	    stream_MANTISSA.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:563:55: ( BASE )?
            	    if ( stream_BASE.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_BASE.Next());
            	    
            	    }
            	    stream_BASE.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:563:61: ( EXPONENT )?
            	    if ( stream_EXPONENT.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_EXPONENT.Next());
            	    
            	    }
            	    stream_EXPONENT.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:563:71: ( constraint )?
            	    if ( stream_constraint.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_constraint.Next());
            	    
            	    }
            	    stream_constraint.Reset();
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:563:83: ( $eNum)?
            	    if ( stream_eNum.HasNext() )
            	    {
            	        adaptor.AddChild(root_1, stream_eNum.Next());
            	    
            	    }
            	    stream_eNum.Reset();
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end namedConstraintExpression

    public class patternExpression_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start patternExpression
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:566:1: patternExpression : a= PATTERN value -> ^( PATTERN_EXPR[$a] value ) ;
    public patternExpression_return patternExpression() // throws RecognitionException [1]
    {   
        patternExpression_return retval = new patternExpression_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        value_return value292 = null;
        
        
        object a_tree=null;
        RewriteRuleTokenStream stream_PATTERN = new RewriteRuleTokenStream(adaptor,"token PATTERN");
        RewriteRuleSubtreeStream stream_value = new RewriteRuleSubtreeStream(adaptor,"rule value");
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:566:19: (a= PATTERN value -> ^( PATTERN_EXPR[$a] value ) )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:566:21: a= PATTERN value
            {
            	a = (IToken)input.LT(1);
            	Match(input,PATTERN,FOLLOW_PATTERN_in_patternExpression3871); 
            	stream_PATTERN.Add(a);

            	PushFollow(FOLLOW_value_in_patternExpression3873);
            	value292 = value();
            	followingStackPointer_--;
            	
            	stream_value.Add(value292.Tree);
            	
            	// AST REWRITE
            	// elements:          value
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 566:38: -> ^( PATTERN_EXPR[$a] value )
            	{
            	    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:566:41: ^( PATTERN_EXPR[$a] value )
            	    {
            	    object root_1 = (object)adaptor.GetNilNode();
            	    root_1 = (object)adaptor.BecomeRoot(adaptor.Create(PATTERN_EXPR, a), root_1);
            	    
            	    adaptor.AddChild(root_1, stream_value.Next());
            	    
            	    adaptor.AddChild(root_0, root_1);
            	    }
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end patternExpression

    public class lID_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start lID
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:571:1: lID : LID ;
    public lID_return lID() // throws RecognitionException [1]
    {   
        lID_return retval = new lID_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken LID293 = null;
        
        object LID293_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:571:5: ( LID )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:571:7: LID
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	LID293 = (IToken)input.LT(1);
            	Match(input,LID,FOLLOW_LID_in_lID3896); 
            	LID293_tree = (object)adaptor.Create(LID293);
            	adaptor.AddChild(root_0, LID293_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end lID

    public class modulereference_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start modulereference
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:572:1: modulereference : UID ;
    public modulereference_return modulereference() // throws RecognitionException [1]
    {   
        modulereference_return retval = new modulereference_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken UID294 = null;
        
        object UID294_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:572:17: ( UID )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:572:19: UID
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	UID294 = (IToken)input.LT(1);
            	Match(input,UID,FOLLOW_UID_in_modulereference3903); 
            	UID294_tree = (object)adaptor.Create(UID294);
            	adaptor.AddChild(root_0, UID294_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end modulereference

    public class typereference_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start typereference
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:573:1: typereference : UID ;
    public typereference_return typereference() // throws RecognitionException [1]
    {   
        typereference_return retval = new typereference_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken UID295 = null;
        
        object UID295_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:573:15: ( UID )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:573:17: UID
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	UID295 = (IToken)input.LT(1);
            	Match(input,UID,FOLLOW_UID_in_typereference3910); 
            	UID295_tree = (object)adaptor.Create(UID295);
            	adaptor.AddChild(root_0, UID295_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end typereference

    public class valuereference_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start valuereference
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:574:1: valuereference : LID ;
    public valuereference_return valuereference() // throws RecognitionException [1]
    {   
        valuereference_return retval = new valuereference_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken LID296 = null;
        
        object LID296_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:574:17: ( LID )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:574:19: LID
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	LID296 = (IToken)input.LT(1);
            	Match(input,LID,FOLLOW_LID_in_valuereference3918); 
            	LID296_tree = (object)adaptor.Create(LID296);
            	adaptor.AddChild(root_0, LID296_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end valuereference

    public class identifier_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start identifier
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:575:1: identifier : LID ;
    public identifier_return identifier() // throws RecognitionException [1]
    {   
        identifier_return retval = new identifier_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken LID297 = null;
        
        object LID297_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:575:12: ( LID )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:575:14: LID
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	LID297 = (IToken)input.LT(1);
            	Match(input,LID,FOLLOW_LID_in_identifier3927); 
            	LID297_tree = (object)adaptor.Create(LID297);
            	adaptor.AddChild(root_0, LID297_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end identifier

    public class versionNumber_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start versionNumber
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:576:1: versionNumber : INT ':' -> INT ;
    public versionNumber_return versionNumber() // throws RecognitionException [1]
    {   
        versionNumber_return retval = new versionNumber_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken INT298 = null;
        IToken char_literal299 = null;
        
        object INT298_tree=null;
        object char_literal299_tree=null;
        RewriteRuleTokenStream stream_INT = new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_168 = new RewriteRuleTokenStream(adaptor,"token 168");
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:576:15: ( INT ':' -> INT )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:576:17: INT ':'
            {
            	INT298 = (IToken)input.LT(1);
            	Match(input,INT,FOLLOW_INT_in_versionNumber3934); 
            	stream_INT.Add(INT298);

            	char_literal299 = (IToken)input.LT(1);
            	Match(input,168,FOLLOW_168_in_versionNumber3936); 
            	stream_168.Add(char_literal299);

            	
            	// AST REWRITE
            	// elements:          INT
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 576:25: -> INT
            	{
            	    adaptor.AddChild(root_0, stream_INT.Next());
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end versionNumber

    public class objectIdentifier_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start objectIdentifier
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:577:1: objectIdentifier : a= OBJECT IDENTIFIER -> OBJECT_TYPE[$a] ;
    public objectIdentifier_return objectIdentifier() // throws RecognitionException [1]
    {   
        objectIdentifier_return retval = new objectIdentifier_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken a = null;
        IToken IDENTIFIER300 = null;
        
        object a_tree=null;
        object IDENTIFIER300_tree=null;
        RewriteRuleTokenStream stream_OBJECT = new RewriteRuleTokenStream(adaptor,"token OBJECT");
        RewriteRuleTokenStream stream_IDENTIFIER = new RewriteRuleTokenStream(adaptor,"token IDENTIFIER");
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:577:18: (a= OBJECT IDENTIFIER -> OBJECT_TYPE[$a] )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:577:20: a= OBJECT IDENTIFIER
            {
            	a = (IToken)input.LT(1);
            	Match(input,OBJECT,FOLLOW_OBJECT_in_objectIdentifier3949); 
            	stream_OBJECT.Add(a);

            	IDENTIFIER300 = (IToken)input.LT(1);
            	Match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_objectIdentifier3951); 
            	stream_IDENTIFIER.Add(IDENTIFIER300);

            	
            	// AST REWRITE
            	// elements:          
            	// token labels:      
            	// rule labels:       retval
            	// token list labels: 
            	// rule list labels:  
            	retval.tree = root_0;
            	RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(adaptor, "token retval", (retval!=null ? retval.Tree : null));
            	
            	root_0 = (object)adaptor.GetNilNode();
            	// 577:40: -> OBJECT_TYPE[$a]
            	{
            	    adaptor.AddChild(root_0, adaptor.Create(OBJECT_TYPE, a));
            	
            	}
            	

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end objectIdentifier

    public class relativeOID_return : ParserRuleReturnScope 
    {
        internal object tree;
        override public object Tree
        {
        	get { return tree; }
        }
    };
    
    // $ANTLR start relativeOID
    // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:578:1: relativeOID : RELATIVE_OID ;
    public relativeOID_return relativeOID() // throws RecognitionException [1]
    {   
        relativeOID_return retval = new relativeOID_return();
        retval.start = input.LT(1);
        
        object root_0 = null;
    
        IToken RELATIVE_OID301 = null;
        
        object RELATIVE_OID301_tree=null;
    
        try 
    	{
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:578:13: ( RELATIVE_OID )
            // C:\\prj\\DataModeling\\tinyAsn1\\AntrlParser\\asn1.g:578:15: RELATIVE_OID
            {
            	root_0 = (object)adaptor.GetNilNode();
            
            	RELATIVE_OID301 = (IToken)input.LT(1);
            	Match(input,RELATIVE_OID,FOLLOW_RELATIVE_OID_in_relativeOID3962); 
            	RELATIVE_OID301_tree = (object)adaptor.Create(RELATIVE_OID301);
            	adaptor.AddChild(root_0, RELATIVE_OID301_tree);

            
            }
    
            retval.stop = input.LT(-1);
            
            	retval.tree = (object)adaptor.RulePostProcessing(root_0);
            	adaptor.SetTokenBoundaries(retval.Tree, retval.start, retval.stop);
    
        }
        catch (RecognitionException re) 
    	{
            ReportError(re);
            Recover(input,re);
        }
        finally 
    	{
        }
        return retval;
    }
    // $ANTLR end relativeOID


	private void InitializeCyclicDFAs()
	{
	}

 

    public static readonly BitSet FOLLOW_moduleDefinition_in_moduleDefinitions353 = new BitSet(new ulong[]{0x0000000000000002UL,0x8000000000000000UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_definitiveIdentifier375 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002800UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_definitiveObjIdComponent_in_definitiveIdentifier377 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002800UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_definitiveIdentifier380 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_identifier_in_definitiveObjIdComponent391 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_L_PAREN_in_definitiveObjIdComponent395 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL});
    public static readonly BitSet FOLLOW_INT_in_definitiveObjIdComponent397 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_R_PAREN_in_definitiveObjIdComponent399 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_INT_in_definitiveObjIdComponent407 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_modulereference_in_moduleDefinition423 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000008400UL});
    public static readonly BitSet FOLLOW_definitiveIdentifier_in_moduleDefinition425 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000008000UL});
    public static readonly BitSet FOLLOW_DEFINITIONS_in_moduleDefinition433 = new BitSet(new ulong[]{0x0000000000000000UL,0x00000000005D0000UL});
    public static readonly BitSet FOLLOW_EXPLICIT_in_moduleDefinition439 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000020000UL});
    public static readonly BitSet FOLLOW_TAGS_in_moduleDefinition441 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000500000UL});
    public static readonly BitSet FOLLOW_IMPLICIT_in_moduleDefinition447 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000020000UL});
    public static readonly BitSet FOLLOW_TAGS_in_moduleDefinition449 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000500000UL});
    public static readonly BitSet FOLLOW_AUTOMATIC_in_moduleDefinition456 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000020000UL});
    public static readonly BitSet FOLLOW_TAGS_in_moduleDefinition458 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000500000UL});
    public static readonly BitSet FOLLOW_EXTENSIBILITY_in_moduleDefinition466 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000200000UL});
    public static readonly BitSet FOLLOW_IMPLIED_in_moduleDefinition468 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000400000UL});
    public static readonly BitSet FOLLOW_ASSIG_OP_in_moduleDefinition475 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_BEGIN_in_moduleDefinition477 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000013000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_exports_in_moduleDefinition482 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000011000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_imports_in_moduleDefinition488 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000001000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_typeAssigment_in_moduleDefinition500 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000001000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_valueAssigment_in_moduleDefinition507 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000001000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_END_in_moduleDefinition519 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_EXPORTS_in_exports589 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000004000000UL});
    public static readonly BitSet FOLLOW_ALL_in_exports591 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000400000000UL});
    public static readonly BitSet FOLLOW_162_in_exports593 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_EXPORTS_in_exports604 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000000000UL,0x0000000400800000UL});
    public static readonly BitSet FOLLOW_typereference_in_exports608 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000000UL,0x0000000400000000UL});
    public static readonly BitSet FOLLOW_valuereference_in_exports612 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000000UL,0x0000000400000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_exports616 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_typereference_in_exports619 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000000UL,0x0000000400000000UL});
    public static readonly BitSet FOLLOW_valuereference_in_exports623 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000000UL,0x0000000400000000UL});
    public static readonly BitSet FOLLOW_162_in_exports631 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_IMPORTS_in_imports661 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000000000UL,0x0000000400800000UL});
    public static readonly BitSet FOLLOW_importFromModule_in_imports663 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000000000UL,0x0000000400800000UL});
    public static readonly BitSet FOLLOW_162_in_imports667 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_typereference_in_importFromModule685 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000028000000UL});
    public static readonly BitSet FOLLOW_valuereference_in_importFromModule689 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000028000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_importFromModule693 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_typereference_in_importFromModule696 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000028000000UL});
    public static readonly BitSet FOLLOW_valuereference_in_importFromModule700 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000028000000UL});
    public static readonly BitSet FOLLOW_FROM_in_importFromModule705 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000000000UL});
    public static readonly BitSet FOLLOW_modulereference_in_importFromModule707 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_definitiveIdentifier_in_importFromModule709 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_valuereference_in_valueAssigment744 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_valueAssigment746 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000400000UL});
    public static readonly BitSet FOLLOW_ASSIG_OP_in_valueAssigment750 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008000FFUL});
    public static readonly BitSet FOLLOW_value_in_valueAssigment752 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_typereference_in_typeAssigment785 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000400000UL});
    public static readonly BitSet FOLLOW_ASSIG_OP_in_typeAssigment789 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_typeAssigment791 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_163_in_typeTag827 = new BitSet(new ulong[]{0x0000000000000000UL,0x00000001C0002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_UNIVERSAL_in_typeTag832 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_APPLICATION_in_typeTag838 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_PRIVATE_in_typeTag844 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_INT_in_typeTag849 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000001000000000UL});
    public static readonly BitSet FOLLOW_valuereference_in_typeTag853 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000001000000000UL});
    public static readonly BitSet FOLLOW_164_in_typeTag857 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000050000UL});
    public static readonly BitSet FOLLOW_IMPLICIT_in_typeTag863 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_EXPLICIT_in_typeTag869 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_typeTag_in_type921 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000005800000UL});
    public static readonly BitSet FOLLOW_nULL_in_type927 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_bitStringType_in_type954 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type956 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_booleanType_in_type982 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type984 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_enumeratedType_in_type1010 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1012 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_integerType_in_type1038 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1040 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_realType_in_type1069 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1071 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_stringType_in_type1098 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1100 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_referencedType_in_type1127 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1129 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_sequenceOfType_in_type1155 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_choiceType_in_type1180 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1182 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_sequenceType_in_type1212 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1214 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_setType_in_type1243 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1245 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_setOfType_in_type1274 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_objectIdentifier_in_type1303 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1305 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_relativeOID_in_type1333 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_type1335 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_selectionType_in_type1364 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_identifier_in_selectionType1398 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000002000000000UL});
    public static readonly BitSet FOLLOW_165_in_selectionType1402 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_selectionType1404 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_SIZE_in_sizeShortConstraint1436 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_sizeShortConstraint1438 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_NULL_in_nULL1465 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_BIT_in_bitStringType1476 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000001000000000UL});
    public static readonly BitSet FOLLOW_STRING_in_bitStringType1478 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_bitStringType1481 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000800UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_bitStringItem_in_bitStringType1484 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_COMMA_in_bitStringType1487 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_bitStringItem_in_bitStringType1489 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_bitStringType1497 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_identifier_in_bitStringItem1522 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_L_PAREN_in_bitStringItem1526 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_INT_in_bitStringItem1529 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_valuereference_in_bitStringItem1531 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_R_PAREN_in_bitStringItem1534 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_BOOLEAN_in_booleanType1564 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_ENUMERATED_in_enumeratedType1579 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_enumeratedType1581 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_enumeratedTypeItems_in_enumeratedType1585 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_COMMA_in_enumeratedType1590 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000008000000000UL});
    public static readonly BitSet FOLLOW_EXT_MARK_in_enumeratedType1594 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL,0x0000020000000000UL});
    public static readonly BitSet FOLLOW_exceptionSpec_in_enumeratedType1596 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_COMMA_in_enumeratedType1600 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_enumeratedTypeItems_in_enumeratedType1604 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_enumeratedType1611 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_enumeratedLstItem_in_enumeratedTypeItems1649 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_enumeratedTypeItems1652 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_enumeratedLstItem_in_enumeratedTypeItems1654 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_identifier_in_enumeratedLstItem1673 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_L_PAREN_in_enumeratedLstItem1677 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_INT_in_enumeratedLstItem1680 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_valuereference_in_enumeratedLstItem1682 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_R_PAREN_in_enumeratedLstItem1685 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_INTEGER_in_integerType1712 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_integerType1716 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000800UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_integerTypeListItem_in_integerType1719 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_COMMA_in_integerType1722 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_integerTypeListItem_in_integerType1724 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_integerType1730 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_identifier_in_integerTypeListItem1755 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_L_PAREN_in_integerTypeListItem1759 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_INT_in_integerTypeListItem1762 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_valuereference_in_integerTypeListItem1764 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_R_PAREN_in_integerTypeListItem1767 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_REAL_in_realType1796 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_CHOICE_in_choiceType1812 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_choiceType1814 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_choiceItemsList_in_choiceType1816 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_choiceExtensionBody_in_choiceType1818 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_choiceType1821 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_COMMA_in_choiceExtensionBody1846 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000008000000000UL});
    public static readonly BitSet FOLLOW_EXT_MARK_in_choiceExtensionBody1850 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL,0x0000020000000000UL});
    public static readonly BitSet FOLLOW_exceptionSpec_in_choiceExtensionBody1852 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_choiceListExtension_in_choiceExtensionBody1856 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_choiceExtensionBody1862 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000008000000000UL});
    public static readonly BitSet FOLLOW_EXT_MARK_in_choiceExtensionBody1866 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_choiceItem_in_choiceItemsList1901 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_choiceItemsList1904 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_choiceItem_in_choiceItemsList1906 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_identifier_in_choiceItem1925 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_choiceItem1927 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_COMMA_in_choiceListExtension1954 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000004000800000UL});
    public static readonly BitSet FOLLOW_extensionAdditionAlternative_in_choiceListExtension1956 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_choiceListExtension1959 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000004000800000UL});
    public static readonly BitSet FOLLOW_extensionAdditionAlternative_in_choiceListExtension1961 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_166_in_extensionAdditionAlternative1984 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_versionNumber_in_extensionAdditionAlternative1986 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_choiceItemsList_in_extensionAdditionAlternative1989 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000008000000000UL});
    public static readonly BitSet FOLLOW_167_in_extensionAdditionAlternative1991 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_choiceItem_in_extensionAdditionAlternative2009 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_SEQUENCE_in_sequenceType2023 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_sequenceType2025 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000808000000800UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_sequenceOrSetBody_in_sequenceType2027 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_sequenceType2031 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_SET_in_setType2054 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_setType2056 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000808000000800UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_sequenceOrSetBody_in_setType2058 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_setType2062 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_componentTypeList_in_sequenceOrSetBody2088 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_sequenceOrSetBody2092 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000008000000000UL});
    public static readonly BitSet FOLLOW_seqOrSetExtBody_in_sequenceOrSetBody2094 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_seqOrSetExtBody_in_sequenceOrSetBody2114 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_EXT_MARK_in_seqOrSetExtBody2143 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL,0x0000020000000000UL});
    public static readonly BitSet FOLLOW_exceptionSpec_in_seqOrSetExtBody2145 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_seqOrSetExtBody2149 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000800000000000UL,0x0000004000800000UL});
    public static readonly BitSet FOLLOW_extensionAdditionList_in_seqOrSetExtBody2151 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_seqOrSetExtBody2156 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000008000000000UL});
    public static readonly BitSet FOLLOW_EXT_MARK_in_seqOrSetExtBody2160 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_seqOrSetExtBody2165 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000800000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_componentTypeList_in_seqOrSetExtBody2167 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_extensionAddition_in_extensionAdditionList2207 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_extensionAdditionList2210 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000800000000000UL,0x0000004000800000UL});
    public static readonly BitSet FOLLOW_extensionAddition_in_extensionAdditionList2212 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_componentType_in_extensionAddition2232 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_extensionAdditionGroup_in_extensionAddition2243 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_166_in_extensionAdditionGroup2255 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000800000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_versionNumber_in_extensionAdditionGroup2257 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000800000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_componentTypeList_in_extensionAdditionGroup2260 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000008000000000UL});
    public static readonly BitSet FOLLOW_167_in_extensionAdditionGroup2262 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_componentType_in_componentTypeList2286 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_componentTypeList2290 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000800000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_componentType_in_componentTypeList2292 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_identifier_in_componentType2314 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_componentType2316 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000600000000000UL});
    public static readonly BitSet FOLLOW_OPTIONAL_in_componentType2321 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_DEFAULT_in_componentType2327 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008000FFUL});
    public static readonly BitSet FOLLOW_value_in_componentType2329 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_COMPONENTS_in_componentType2361 = new BitSet(new ulong[]{0x0000000000000000UL,0x0001000000000000UL});
    public static readonly BitSet FOLLOW_OF_in_componentType2363 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_componentType2365 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_SEQUENCE_in_sequenceOfType2399 = new BitSet(new ulong[]{0x0000000000000000UL,0x0001000200001000UL});
    public static readonly BitSet FOLLOW_sizeShortConstraint_in_sequenceOfType2402 = new BitSet(new ulong[]{0x0000000000000000UL,0x0001000000000000UL});
    public static readonly BitSet FOLLOW_constraint_in_sequenceOfType2406 = new BitSet(new ulong[]{0x0000000000000000UL,0x0001000000000000UL});
    public static readonly BitSet FOLLOW_OF_in_sequenceOfType2410 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_identifier_in_sequenceOfType2413 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_sequenceOfType2417 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_SET_in_setOfType2451 = new BitSet(new ulong[]{0x0000000000000000UL,0x0001000200001000UL});
    public static readonly BitSet FOLLOW_sizeShortConstraint_in_setOfType2454 = new BitSet(new ulong[]{0x0000000000000000UL,0x0001000000000000UL});
    public static readonly BitSet FOLLOW_constraint_in_setOfType2458 = new BitSet(new ulong[]{0x0000000000000000UL,0x0001000000000000UL});
    public static readonly BitSet FOLLOW_OF_in_setOfType2462 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_identifier_in_setOfType2465 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_setOfType2469 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_OCTET_in_stringType2506 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000001000000000UL});
    public static readonly BitSet FOLLOW_STRING_in_stringType2508 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_NumericString_in_stringType2516 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_PrintableString_in_stringType2520 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_VisibleString_in_stringType2524 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_IA5String_in_stringType2528 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_TeletexString_in_stringType2532 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_VideotexString_in_stringType2536 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_GraphicString_in_stringType2540 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_GeneralString_in_stringType2544 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_UniversalString_in_stringType2548 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_BMPString_in_stringType2552 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_UTF8String_in_stringType2556 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_GeneralizedTime_in_stringType2560 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_UTCTime_in_stringType2564 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_UID_in_referencedType2578 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000000UL,0x0000000020000000UL});
    public static readonly BitSet FOLLOW_DOT_in_referencedType2581 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000000000UL});
    public static readonly BitSet FOLLOW_UID_in_referencedType2585 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_identifier_in_choiceValue2621 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000010000000000UL});
    public static readonly BitSet FOLLOW_168_in_choiceValue2625 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008000FFUL});
    public static readonly BitSet FOLLOW_value_in_choiceValue2627 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_identifier_in_namedValue2651 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008000FFUL});
    public static readonly BitSet FOLLOW_value_in_namedValue2653 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_BitStringLiteral_in_value2684 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_OctectStringLiteral_in_value2690 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_TRUE_in_value2695 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_FALSE_in_value2700 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_StringLiteral_in_value2705 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_NULL_in_value2710 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_PLUS_INFINITY_in_value2715 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_MINUS_INFINITY_in_value2722 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_valuereference_in_value2729 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_INT_in_value2754 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_FloatingPointLiteral_in_value2760 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_value2768 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_value2770 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_value2794 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000000100UL});
    public static readonly BitSet FOLLOW_MANTISSA_in_value2796 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL});
    public static readonly BitSet FOLLOW_INT_in_value2800 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_value2802 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000000200UL});
    public static readonly BitSet FOLLOW_BASE_in_value2804 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL});
    public static readonly BitSet FOLLOW_INT_in_value2808 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_value2810 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_EXPONENT_in_value2812 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000002000UL});
    public static readonly BitSet FOLLOW_INT_in_value2816 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_value2818 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_value2842 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_objectIdentifierComponent_in_value2844 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000002800UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_value2847 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_choiceValue_in_value2865 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_value2872 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_namedValue_in_value2874 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_COMMA_in_value2877 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_namedValue_in_value2879 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_value2883 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_value2903 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008000FFUL});
    public static readonly BitSet FOLLOW_value_in_value2905 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_COMMA_in_value2908 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008000FFUL});
    public static readonly BitSet FOLLOW_value_in_value2910 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_value2914 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_identifier_in_objectIdentifierComponent2947 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_L_PAREN_in_objectIdentifierComponent2951 = new BitSet(new ulong[]{0x0000000000000000UL,0x8000000000002000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_INT_in_objectIdentifierComponent2954 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_definedValue_in_objectIdentifierComponent2958 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_R_PAREN_in_objectIdentifierComponent2961 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_INT_in_objectIdentifierComponent2986 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_modulereference_in_objectIdentifierComponent3009 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000020000000UL});
    public static readonly BitSet FOLLOW_DOT_in_objectIdentifierComponent3011 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_valuereference_in_objectIdentifierComponent3013 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_valuereference_in_definedValue3036 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_modulereference_in_definedValue3056 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000020000000UL});
    public static readonly BitSet FOLLOW_DOT_in_definedValue3058 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800000UL});
    public static readonly BitSet FOLLOW_valuereference_in_definedValue3060 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_L_PAREN_in_constraint3090 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6E24003400UL,0x0000000805C680FFUL});
    public static readonly BitSet FOLLOW_unionSet_in_constraint3094 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008004000UL,0x0000020000000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_constraint3097 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000008000000000UL});
    public static readonly BitSet FOLLOW_EXT_MARK_in_constraint3101 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008004000UL,0x0000020000000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_constraint3105 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6E24003400UL,0x0000000805C680FFUL});
    public static readonly BitSet FOLLOW_unionSet_in_constraint3109 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL,0x0000020000000000UL});
    public static readonly BitSet FOLLOW_exceptionSpec_in_constraint3116 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_R_PAREN_in_constraint3119 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_169_in_exceptionSpec3161 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00002000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_INT_in_exceptionSpec3170 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_valuereference_in_exceptionSpec3200 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_type_in_exceptionSpec3232 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000010000000000UL});
    public static readonly BitSet FOLLOW_168_in_exceptionSpec3234 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008000FFUL});
    public static readonly BitSet FOLLOW_value_in_exceptionSpec3236 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_intersectionSet_in_unionSet3289 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000000UL,0x0000000000000800UL});
    public static readonly BitSet FOLLOW_UnionMark_in_unionSet3292 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6E20003400UL,0x0000000805C680FFUL});
    public static readonly BitSet FOLLOW_intersectionSet_in_unionSet3294 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000000UL,0x0000000000000800UL});
    public static readonly BitSet FOLLOW_ALL_in_unionSet3315 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_EXCEPT_in_unionSet3317 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6E20003400UL,0x0000000805C680FFUL});
    public static readonly BitSet FOLLOW_constraintExpression_in_unionSet3319 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_intersectionItem_in_intersectionSet3348 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000000UL,0x0000000000002000UL});
    public static readonly BitSet FOLLOW_IntersectionMark_in_intersectionSet3351 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6E20003400UL,0x0000000805C680FFUL});
    public static readonly BitSet FOLLOW_intersectionItem_in_intersectionSet3353 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000000UL,0x0000000000002000UL});
    public static readonly BitSet FOLLOW_constraintExpression_in_intersectionItem3382 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000000UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_EXCEPT_in_intersectionItem3385 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6E20003400UL,0x0000000805C680FFUL});
    public static readonly BitSet FOLLOW_constraintExpression_in_intersectionItem3389 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_valueRangeExpression_in_constraintExpression3422 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_subtypeExpression_in_constraintExpression3438 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_sizeExpression_in_constraintExpression3450 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_permittedAlphabetExpression_in_constraintExpression3476 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_innerTypeExpression_in_constraintExpression3481 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_patternExpression_in_constraintExpression3486 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_L_PAREN_in_constraintExpression3491 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6E24003400UL,0x0000000805C680FFUL});
    public static readonly BitSet FOLLOW_unionSet_in_constraintExpression3493 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_R_PAREN_in_constraintExpression3495 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_lowerEndValue_in_valueRangeExpression3514 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000000000000000UL,0x0000002000004000UL});
    public static readonly BitSet FOLLOW_165_in_valueRangeExpression3521 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000004000UL});
    public static readonly BitSet FOLLOW_DOUBLE_DOT_in_valueRangeExpression3525 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000020008100FFUL});
    public static readonly BitSet FOLLOW_165_in_valueRangeExpression3530 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008100FFUL});
    public static readonly BitSet FOLLOW_upperEndValue_in_valueRangeExpression3536 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_value_in_lowerEndValue3588 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_MIN_in_lowerEndValue3593 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_value_in_upperEndValue3605 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_MAX_in_upperEndValue3610 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_INCLUDES_in_subtypeExpression3624 = new BitSet(new ulong[]{0x0000000000000000UL,0xFFFE1F6C00000000UL,0x0000000805800000UL});
    public static readonly BitSet FOLLOW_type_in_subtypeExpression3627 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_SIZE_in_sizeExpression3652 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_sizeExpression3654 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_FROM_in_permittedAlphabetExpression3678 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_permittedAlphabetExpression3680 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_WITH_in_innerTypeExpression3703 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000080000UL});
    public static readonly BitSet FOLLOW_COMPONENT_in_innerTypeExpression3705 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000001000UL});
    public static readonly BitSet FOLLOW_constraint_in_innerTypeExpression3707 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_WITH_in_innerTypeExpression3733 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000800000000000UL});
    public static readonly BitSet FOLLOW_COMPONENTS_in_innerTypeExpression3735 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000400UL});
    public static readonly BitSet FOLLOW_L_BRACKET_in_innerTypeExpression3737 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000008000000000UL,0x0000000000800700UL});
    public static readonly BitSet FOLLOW_EXT_MARK_in_innerTypeExpression3744 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000000UL});
    public static readonly BitSet FOLLOW_COMMA_in_innerTypeExpression3746 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800700UL});
    public static readonly BitSet FOLLOW_namedConstraintExpression_in_innerTypeExpression3753 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_COMMA_in_innerTypeExpression3757 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000000800700UL});
    public static readonly BitSet FOLLOW_namedConstraintExpression_in_innerTypeExpression3759 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000008000800UL});
    public static readonly BitSet FOLLOW_R_BRACKET_in_innerTypeExpression3766 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_identifier_in_namedConstraintExpression3793 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000200000001000UL,0x0000000000300000UL});
    public static readonly BitSet FOLLOW_MANTISSA_in_namedConstraintExpression3797 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000200000001000UL,0x0000000000300000UL});
    public static readonly BitSet FOLLOW_BASE_in_namedConstraintExpression3800 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000200000001000UL,0x0000000000300000UL});
    public static readonly BitSet FOLLOW_EXPONENT_in_namedConstraintExpression3802 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000200000001000UL,0x0000000000300000UL});
    public static readonly BitSet FOLLOW_constraint_in_namedConstraintExpression3806 = new BitSet(new ulong[]{0x0000000000000002UL,0x0000200000000000UL,0x0000000000300000UL});
    public static readonly BitSet FOLLOW_PRESENT_in_namedConstraintExpression3813 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_ABSENT_in_namedConstraintExpression3817 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_OPTIONAL_in_namedConstraintExpression3823 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_PATTERN_in_patternExpression3871 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000400002400UL,0x00000000008000FFUL});
    public static readonly BitSet FOLLOW_value_in_patternExpression3873 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_LID_in_lID3896 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_UID_in_modulereference3903 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_UID_in_typereference3910 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_LID_in_valuereference3918 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_LID_in_identifier3927 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_INT_in_versionNumber3934 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000010000000000UL});
    public static readonly BitSet FOLLOW_168_in_versionNumber3936 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_OBJECT_in_objectIdentifier3949 = new BitSet(new ulong[]{0x0000000000000000UL,0x0000000000000000UL,0x0000000002000000UL});
    public static readonly BitSet FOLLOW_IDENTIFIER_in_objectIdentifier3951 = new BitSet(new ulong[]{0x0000000000000002UL});
    public static readonly BitSet FOLLOW_RELATIVE_OID_in_relativeOID3962 = new BitSet(new ulong[]{0x0000000000000002UL});

}
